Package: flowViz
Type: Package
Title: Visualization for flow cytometry
Version: 1.76.1
Author: B. Ellis, R. Gentleman, F. Hahne, N. Le Meur, D. Sarkar, M. Jiang
Maintainer: Mike Jiang <mike@ozette.com>
Description: Provides visualization tools for flow cytometry data.
Depends: R (>= 2.7.0), flowCore(>= 1.41.9), lattice
Imports: stats4, Biobase, flowCore, graphics, grDevices, grid,
        KernSmooth, lattice, latticeExtra, MASS, methods, RColorBrewer,
        stats, utils, hexbin,IDPmisc
Suggests: colorspace, flowStats, knitr, rmarkdown, markdown, testthat
License: Artistic-2.0
biocViews: ImmunoOncology, Infrastructure, FlowCytometry,
        CellBasedAssays, Visualization
VignetteBuilder: knitr
RoxygenNote: 6.1.1
git_url: https://git.bioconductor.org/packages/flowViz
git_branch: RELEASE_3_23
git_last_commit: eda6fc2
git_last_commit_date: 2026-08-25
Repository: Bioconductor 3.23
Date/Publication: 2026-08-26
NeedsCompilation: no
Packaged: 2026-08-26 21:50:01 UTC; biocbuild

#' @export 
#' @rdname ecdfplot
prepanel.ecdfplot.flowset <- 
    function(x, frames, channel,
             f.value,
             ...)
{
    distribution <- qunif
    nobs <- max(unlist(eapply(frames, function(x) nrow(exprs(x)))))

    qrange <-
        if (is.null(f.value)) 
            ppoints(sqrt(nobs))
        else if (is.numeric(f.value))
            f.value
        else f.value(nobs)
    qrange <- range(qrange)

    yy <- distribution(qrange)
    xx <-
        unlist(eapply(frames,
                      function(x) {
                          quantile(evalInFlowFrame(channel, x),
                                   qrange,
                                   na.rm = TRUE)
                      }))

    dy <- rep(diff(distribution(c(0.25, 0.75))), length(ls(frames)))
    dx <-
        unlist(eapply(frames,
                      function(x) {
                          diff(quantile(evalInFlowFrame(channel, x),
                                        c(0.25, 0.75),
                                        na.rm = TRUE))
                      }))

    list(xlim = range(xx, finite = TRUE),
         ylim = range(yy, finite = TRUE),
         dx = dx, dy = dy)
}



#' @export 
#' @rdname ecdfplot
panel.ecdfplot.flowset <-
    function(x, 
             frames, channel,
             f.value, 
             ref = TRUE,

             groups = NULL,
             subscripts,

             col = superpose.symbol$col,
             col.points = col,
             pch = superpose.symbol$pch,
             cex = superpose.symbol$cex,
             alpha = superpose.symbol$alpha,
             col.line = col,
             lty = superpose.line$lty,
             lwd = superpose.line$lwd,
             ...)
{
    if (ref)
    {
        reference.line <- trellis.par.get("reference.line")
        do.call(panel.abline, c(list(h = c(0, 1)), reference.line))
    }
    superpose.symbol <- trellis.par.get("superpose.symbol")
    superpose.line <- trellis.par.get("superpose.line")

    if (is.null(groups))
    {
        nx <- length(x)
        col.points <- rep(col.points, length = nx)
        col.line <- rep(col.line, length = nx)
        pch <- rep(pch, length = nx)
        cex <- rep(cex, length = nx)
        lty <- rep(lty, length = nx)
        lwd <- rep(lwd, length = nx)
        alpha <- rep(alpha, length = nx)
    }
    else
    {
        groups <- as.factor(groups)[subscripts]
        stopifnot(length(groups) == length(x))
        ## goal: make colors etc vectors as before, but
        ## associate by group

        ng <- nlevels(groups)
        gcode <- as.numeric(groups)
        col.points <- rep(col.points, length = ng)[gcode]
        col.line <- rep(col.line, length = ng)[gcode]
        pch <- rep(pch, length = ng)[gcode]
        cex <- rep(cex, length = ng)[gcode]
        lty <- rep(lty, length = ng)[gcode]
        lwd <- rep(lwd, length = ng)[gcode]
        alpha <- rep(alpha, length = ng)[gcode]
    }

    distribution <- qunif
    nobs <- max(unlist(eapply(frames, function(x) nrow(exprs(x)))))
    qq <-
        if (is.null(f.value)) 
            ppoints(sqrt(nobs))
        else if (is.numeric(f.value))
            f.value
        else f.value(nobs)
    yy <- distribution(qq)
    x <- as.character(x)
    for (i in seq_along(x))
    {
        nm <- x[i]
        xx <-
            quantile(evalInFlowFrame(channel, frames[[nm]]),
                     qq, na.rm = TRUE)
        panel.xyplot(xx, yy,
                     col.line = col.line[i],
                     col = col[i],
                     cex = cex[i],
                     pch = pch[i],
                     lty = lty[i],
                     lwd = lwd[i],
                     alpha = alpha[i],
                     ...)
    }
}




#' Method implementing Lattice ECDF plots for flow data
#' 
#' 
#' This function creates Trellis displays of Empirical Cumulative Distribution
#' Functions from flow cytometry data using a formula interface.
#' 
#' 
#' @name ecdfplot
#' @aliases ecdfplot ecdfplot,formula,flowSet-method panel.ecdfplot.flowset
#' prepanel.ecdfplot.flowset
#' @docType methods
#' @param x a formula describing the structure of the plot and the variables to
#' be used in the display.  For the prepanel and panel functions, a vector of
#' names for the flow frames to be used in the panel.
#' @param data a \code{flowSet} object that serves as a source of data
#' @param xlab Labels for data axes, with suitable defaults taken from the
#' formula
#' @param f.value determines the number of points used in the plot
#' \code{\link[latticeExtra:ecdfplot]{ecdfplot}} for details.
#' @param panel,prepanel the panel and prepanel functions.
#' @param type type of rendering; by default lines are drawn
#' @param as.table logical; whether to draw panels from top left
#' @param ref logical; whether to add reference lines at 0 and 1
#' @param frames environment containing frame-specific data
#' @param channel expression involving names of columns in the data
#' @param groups,subscripts grouping variable, if specified, and subscripts
#' indexing which frames are being used in the panel.  See
#' \code{\link[lattice:xyplot]{xyplot}} for details.
#' @param col,col.points,pch,cex,alpha,col.line,lty,lwd vector of graphical
#' parameters that are replicated for each group
#' @param \dots more arguments, usually passed on to the underlying lattice
#' methods and the panel function.
#' @section Methods: \describe{
#' 
#' \item{ecdfplot}{\code{signature(x = "formula", data = "flowSet")}: plote
#' empirical CDF for a given channel, with one or more samples per panel } }
#' @seealso Not all standard lattice arguments will have the intended effect,
#' but many should.  For a fuller description of possible arguments and their
#' effects, consult documentation on lattice.
#' @keywords methods dplot
#' @examples
#' 
#' library(flowCore)
#' data(GvHD)
#' 
#' ecdfplot(~ `FSC-H` | Patient, GvHD, f.value = ppoints(100))
#' 
#' ecdfplot(~ asinh(`FSC-H`) | Patient, GvHD,
#'          strip = strip.custom(strip.names = TRUE),
#'          ref = FALSE)
#' 
#' ecdfplot(~ asinh(`FSC-H`) | Patient, GvHD, groups = Visit,
#'          strip = strip.custom(strip.names = TRUE),
#'          ref = FALSE, auto.key = list(columns = 4))
#' 
#' 
#' @export 
setMethod("ecdfplot",
          signature(x = "formula", data = "flowSet"),
          function(x, data, xlab,
                   f.value = function(n) ppoints(ceiling(sqrt(n))),
                   prepanel = prepanel.ecdfplot.flowset,
                   panel = panel.ecdfplot.flowset,
                   type = "l", as.table = TRUE,
                   ...)
      {
          ocall <- sys.call(sys.parent())
          ccall <- match.call(expand.dots = FALSE)
          ccall <- manipulate.call(ocall, ccall)
          pd <- pData(phenoData(data))
          uniq.name <- createUniqueColumnName(pd)
          ## ugly hack to suppress warnings about coercion introducing NAs
          pd[[uniq.name]] <- factor(sampleNames(data))
          channel <- x[[2]]
          if (length(channel) == 3)
          {
              channel <- channel[[2]]
              x[[2]][[2]] <- as.name(uniq.name)
          }
          else x[[2]] <- as.name(uniq.name)
          channel.name <- expr2char(channel)
          channel <- as.expression(channel)
          if (missing(xlab)) xlab <- channel.name
          ccall$x <- x
          ccall$data <- pd
          ccall$f.value <- f.value
          ccall$prepanel <- prepanel
          ccall$panel <- panel
          ccall$type <- type
          ccall$as.table <- as.table
          ccall$xlab <- xlab
          ccall$frames <- data@frames
          ccall$channel <- channel
          ccall[[1]] <- quote(latticeExtra::ecdfplot)
          ans <- eval.parent(ccall)
          ans$call <- ocall
          ans
      })

#' Contour plots for flow data
#' 
#' Basic contour plots for both
#' \code{\link[flowCore:flowFrame-class]{flowFrame}}s and
#' \code{\link[flowCore:flowFrame-class]{flowSet}}s. The densities for the
#' contours are estimated using the fast kernel density estimation algorithm
#' \code{\link[KernSmooth]{bkde2D}}.
#' 
#' 
#' @name contour-methods
#' @aliases contour contour-methods contour,ANY-method contour,flowFrame-method
#' contour,flowSet-method
#' @docType methods
#' @param x An object of class
#' \code{\link[flowCore:flowFrame-class]{flowFrame}} or
#' \code{\link[flowCore:flowFrame-class]{flowSet}}.
#' @param y Numeric or character vector of length 2 indicating the channels to
#' plot.
#' @param nlevels The approximate number of contour line levels, see
#' \code{\link[graphics]{contour}} for details.
#' @param bw The bandwidth factor used for the kernel density estimation, see
#' \code{\link[KernSmooth]{bkde2D}} for details.
#' @param grid.size The grid size used for the kernel density estimation, see
#' \code{\link[KernSmooth]{bkde2D}} for details.
#' @param add Logical, indicating whether contour lines should be superimposed
#' on an existing plot.
#' @param xlab,ylab The axis annotation.
#' @param xlim,ylim The plotting ranges.
#' @param lwd,lty,col,fill The usual plotting parameters, i.e. the line width,
#' line type, line color and fill color. When using a fill color you should
#' consider alpha blending to improve the results.
#' @param \dots Parameters that are passed on to the plotting functions.
#' @section Methods: \describe{
#' 
#' \item{x = "flowFrame"}{ A regular contour plot of the flow data in the
#' frame. It can be added on top of an existing plot using the \code{add}
#' argument.}
#' 
#' \item{x = "flowSet"}{ Overlay of contours of densities for each individual
#' frame in the set. You should consider using differnt colors and alpha
#' blending to improve the result. This is only useful for a very limited
#' number of frames in a set (~5), for larger sets you should consider a
#' panelled lattice-type plot. Not that \code{bw}, \code{gridSize} and
#' \code{nlevels} are passed on via the \dots{} argument.}
#' 
#' }
#' @author F. Hahne
#' @seealso
#' 
#' \code{\link[KernSmooth]{bkde2D}}, \code{\link[graphics]{contour}},
#' \code{\link[flowCore:flowFrame-class]{flowFrame}},
#' \code{\link[flowCore:flowFrame-class]{flowSet}}
#' @keywords methods
#' @examples
#' 
#' library(flowCore)
#' data(GvHD)
#' 
#' ## simple contour plot
#' contour(GvHD[[1]])
#' 
#' ## overlay with existing plot
#' plot(GvHD[[1]], c("FSC-H", "SSC-H"))
#' contour(GvHD[[1]], add=TRUE, col="lightgray", lty=3)
#' 
#' ## colored contours
#' contour(GvHD[[1]], fill="red")
#' cols <- rainbow(3, alpha=0.1)
#' contour(GvHD[[1]], fill=cols, col=cols)
#' 
#' ## overlay of multiple flowFrames in a flowSet
#' contour(GvHD[1:3], col=cols, fill=cols)
#' 
#' @importFrom KernSmooth bkde2D dpik
#' @export 
setMethod("contour",
          signature("flowFrame"),
          function(x, y=1:2, nlevels=10, bw, grid.size=c(65,65), add=FALSE,
                   xlab, ylab, xlim, ylim, lwd=1, lty=1, col=par("fg"),
                   fill="transparent", ...)
      {
          if(length(y) != 2)
              stop("You must specify two dimensions!")
          if(is.character(y))
              y <- match(y[1:2], colnames(x))
          if (missing(bw))
              bw <- diff(apply(exprs(x[,y]), 2, quantile, probs=c(0.05, 0.95),
                               na.rm=TRUE)) / 25
          cnx <- colnames(x)[y[1]]
          if(missing(xlab))
              xlab <- cnx
          cny <- colnames(x)[y[2]]
          if(missing(ylab))
              ylab <- cny
          plotType("contour", c(cnx, cny))
          exp <- exprs(x[,y])
          ## compute the bivariate density and the contour lines
          xr <- range(exp[,1], na.rm=TRUE)
          yr <- range(exp[,2], na.rm=TRUE)
          range <- list(xr+c(-1,1)*bw[1]*2.5, yr+c(-1,1)*bw[2]*2.5)
          z <- bkde2D(exp, bw, grid.size, range.x=range)
          ll <- contourLines(z$x1, z$x2, z$fhat, nlevels=nlevels)
          ## plot everything as polygons
          if(missing(xlim))
              xlim <- unlist(range(x[,y[1]]))
           if(missing(ylim))
              ylim <- unlist(range(x[,y[2]]))
          if(!add) 
              plot(z$x1, z$x2, type="n", xlab=xlab, ylab=ylab,
                   xlim=xlim, ylim=ylim, ...)
          for(ct in ll) {
              polygon(ct$x, ct$y, border=col, col=fill, lwd=lwd, lty=lty)
          }
      })
	
	
setMethod("contour",
          signature("flowSet"),
          function(x, y=1:2, add=FALSE, xlab, ylab, lwd=1, lty=1,
                   col=par("fg"), fill="transparent", ...)
      {
          localPlot <- function(..., bw, nlevels, grid.size)
              plot(...)
          if(length(y) != 2)
              stop("You must specify two dimensions!")
          if(is.character(y))
              y <- match(y[1:2], colnames(x))
           if(missing(xlab))
              xlab <- colnames(x)[y[1]]
          if(missing(ylab))
              ylab <- colnames(x)[y[2]]
          if(!add) {
              mins <- apply(fsApply(x,each_col,min),2,min)
              maxs <- apply(fsApply(x,each_col,max),2,max)
              localPlot(c(mins[y[1]], maxs[y[1]]),
                        c(mins[y[2]], maxs[y[2]]), type="n",
                        xlab=xlab, ylab=ylab, ...)		
          }
          fill <- rep(fill, length.out=length(x))
          col <- rep(col, length.out=length(x))
          lwd <- rep(lwd, length.out=length(x))
          lty <- rep(lty, length.out=length(x))
          for(i in 1:length(x))
              contour(x[[i]], y, col=col[i], fill=fill[i], lwd=lwd[i],
                      lty=lty[i], add=TRUE, ...)
      })

## things are getting too crowded in latticeMethods.R, so start
## splitting things out into different files.  This one is for
## parallel coordinate plots.


#' @export 
#' @rdname lattice-methods
setMethod("parallelplot",
          signature(x = "flowFrame", data = "missing"),
          function(x, data, 
                   reorder.by = function(x) var(x, na.rm = TRUE),
                   time = "Time", exclude.time = TRUE,
                   ...)
      {
          expr <- exprs(x)
          column.names <- colnames(expr)
          if (exclude.time) column.names <- column.names[column.names != time]
          if (!is.null(reorder.by))
          {
              column.order <- rev(order(apply(expr[, column.names], 2, reorder.by)))
              column.names <- column.names[column.order]
          }
          parallelplot(expr[, column.names],
                   ...)
      })



## setMethod("parallel",
##           signature(x = "formula", data = "flowSet"),
##           function(x, data, 
##                    reorder.by = function(x) var(x, na.rm = TRUE),
##                    time = "Time", exclude.time = TRUE,
##                    ...)
##       {
##           expr <- exprs(x)
##           column.names <- colnames(expr)
##           if (exclude.time) column.names <- column.names[column.names != time]
##           if (!is.null(reorder.by))
##           {
##               column.order <- rev(order(apply(expr[, column.names], 2, reorder.by)))
##               column.names <- column.names[column.order]
##           }
##           parallel(expr[, column.names], ...)
##       })


## Formula is like  ~ . | a + b. The '.' part is currently ignored.
#' @param filter flowCore filter
#' @export 
#' @rdname lattice-methods
setMethod("parallelplot",
          signature(x = "formula", data = "flowSet"),
          function(x, data,
                   time = "Time", exclude.time = TRUE,
                   filter = NULL,
                   xlab = NULL, ylab = NULL,
                   ...)
      {

          if(!is.null(filter)){
              if(!is.list(filter)){
                  if(is(filter, "filter"))
                      filter <- filter(data, filter)
              }else if(!is(filter, "filterResultList"))
                  filter <- as(filter, "filterResultList")
          }
          pd <- pData(phenoData(data))
          uniq.name <- createUniqueColumnName(pd)
          ## ugly hack to suppress warnings about coercion introducing NAs
          pd[[uniq.name]] <- factor(sampleNames(data))
          channels <- x[[2]]
          if (length(channels) == 3)
          {
              channels <- channels[[2]]
              x[[2]][[2]] <- as.name(uniq.name)
          }
          else x[[2]] <- as.name(uniq.name)

          ## channels is going to be interpreted as follows: If it is
          ## ".", use all channels except Time.  Otherwise, use
          ## f[,channels], where f is a flow frame


          column.names <- colnames(data)
          if (channels == as.symbol("."))
          {
              if (exclude.time)
                  column.names <- column.names[column.names != time]
          }
          else
              column.names <- eval(channels) ## e.g. c("FSC-H", "Time")

          prepanel.parallel.flowset <- 
              function(x, frames, column.names, ...)
              {
                  x <- as.character(x)
                  if (length(x) > 1) stop("must have only one flow frame per panel")
                  if (length(x) < 1) return()
                  nm <- x
                  z <- as.data.frame(exprs(frames[[nm]])[, column.names])
                  prepanel.default.parallel(z = z)
              }

          panel.parallel.flowset <-
              function(x, 
                       frames, channel, column.names, 
                       ...)
              {
                  x <- as.character(x)
                  if (length(x) > 1) stop("must have only one flow frame per panel")
                  if (length(x) < 1) return()

                  nm <- x
                  z <- as.data.frame(exprs(frames[[nm]])[, column.names])
                  if(!(nm %in% names(filter) || !is(filter[[nm]] ,"filterResult"))){
                      warning("'filter' must either be a filterResultList, a single\n",
                              "filter object or a named list of filter objects.",
                              call.=FALSE)
                      filter <- NULL
                  }
                  if (!is.null(filter))
                  {
                      this.filter.result <- filter[[nm]]
                      groups <- this.filter.result@subSet
                  }
                  else groups <- NULL
                  panel.parallel(1, 1, z = z,
                                 groups = groups,
                                 subscripts = seq_len(nrow(z)),
                                 ...)
              }

          densityplot(x, data = pd,
                      prepanel = prepanel.parallel.flowset,
                      panel = panel.parallel.flowset,
                      frames = data@frames,
                      column.names = column.names,
                      xlab = xlab, ylab = ylab,
                      default.scales =
                      list(x = list(at = c(0, 1), labels = c("Min", "Max")),
                           y =
                           list(alternating = FALSE, axs = "i", tck = 0,
                                at = seq_along(column.names),
                                labels = column.names)),
                      ...)
      })

##############################################################################
##                             flowFrame methods                            ##
##############################################################################

## Default xyplot for flowFrames without any formula. This tries to guess the
## 'Time' parameter from the colnames of the expression matrix and creates
## timeline plots for each parameter in a stacked layout. The method casts
## an error if it isn't able to guess the 'Time' parameter. There are three
## options for plotting:
##    discretize (the default): bin y values in time interval and plot median
##                              values
##    smooth: standard smoothScatter plot of time vs parameter (without
##            points added by default)
##    none of the above: standard type argument for xyplots, defaults to 'l'
#' @export 
#' @rdname xyplot
setMethod("xyplot",
          signature=signature(x="flowFrame",
                              data="missing"),
          definition=function(x,
                              data,
                              time,
                              xlab,
                              ylab="",
                              layout,
                              prepanel=prepanel.xyplot.flowframe.time,
                              panel=panel.xyplot.flowframe.time,
                              type="discrete",
                              ...)
      {
          ## guess the time parameter
          expr <- exprs(x)
          if(missing(time))
              time <- flowCore:::findTimeChannel(expr, strict = TRUE)
          if(!(time %in% colnames(expr)))
              stop("Invalid name of variable (", time, ") recording the ",
                   "\ntime domain specified as 'time' argument.", call.=FALSE)
          if(missing(xlab))
              xlab <- time
          ## set up fake data frame for dispatch
          fakedf <- data.frame(channel=setdiff(colnames(expr), time),
                               time=1)
          ## set up stacked layout
          if (missing(layout)) layout <- c(1, ncol(expr) - 1)
          xyplot(channel ~ time | channel, data=fakedf, type=type,
                 prepanel=prepanel, panel=panel, layout=layout, frame=x,
                 time=time, xlab=xlab, ylab=ylab,
                 default.scales=list(y=list(relation="free", rot=0)), ...)
      })


## Prepanel function to set up dimensions. We want to use the instrument measurement
## range instead of the absolute range of the data for the y dimension. The x-dimension
## is constant since we have the same time recordings for each channel. We also record
## the data ranges in the internal state environment for further use.
#' @export 
#' @rdname xyplot
prepanel.xyplot.flowframe.time <- 
    function(x, y, frame, time, xlim, ylim, ...)
{
    yc <- as.character(y)
    expr <- exprs(frame)  
    
    if(missing(xlim)){
      #use default calculation
      xx <- expr[, time]
      xlim <- range(xx, finite=TRUE)
    }
    
    if(missing(ylim)){
      #use default calculation
      yy <- expr[, yc]
      ylim <- unlist(range(frame)[, yc])
    }


    
    return(list(xlim=xlim, ylim=ylim))
}

## Panel function to do the timeline plotting with several different options
#' @param time A character string giving the name of the data column recording
#' time. If not provided, we try to guess from the available parameters.
#' @param nrpoints The number of points plotted on the smoothed plot in sparse
#'          regions. This is only listed here because we use a different default. See
#'              \code{\link[lattice:panel.smoothScatter]{panel.smoothScatter}} for details.
#' @param type type of rendering; see
#'                      \code{\link[lattice:panel.xyplot]{panel.xyplot}} for details. For the basic
#'                      \code{flowFrame} method without a detailed formula, the addtional type
#'                          \code{discrete} is available, which plots a smoothed average of the flow
#'                          cytometry values against time.
#' @param binSize The size of a bin (i.e., the number of events within a bin)
#' used for the smoothed average timeline plots.

#' @export 
#' @rdname xyplot
panel.xyplot.flowframe.time <- 
    function(x, y, frame, time, type="discrete", nrpoints=0, binSize=100, ...)
{
    y <- as.character(y)
    expr <- exprs(frame)
    xx <- expr[, time]
    yy <- expr[, y]
    ## We record in the state environment which type of plot we produce
#	plotType("gtime", c("Time", as.character(y)))
    if (type == "smooth"){
        ## smoothScatter plot of time vs. parameter (not sure how useful
        ## that is...)
        panel.smoothScatter(xx, yy, nrpoints=nrpoints, ...)
        return(invisible(NULL))
    }else if(type == "discrete"){
        ## discetize y values into bins acording to time intervals and
        ## compute median values for each interval  
        ord <- order(xx)
        xx <- xx[ord]
        yy <- yy[ord]
        lenx <- length(xx)
        nrBins <- floor(lenx/binSize)
        ## time parameter is already binned or very sparse events
        if(length(unique(xx)) < nrBins){
            yy <- sapply(split(yy, xx), median)
            xx <- unique(xx)
        }else{
            ## bin values in nrBins bins
            if(lenx > binSize){
                cf <- c(rep(1:nrBins, each=binSize),
                        rep(nrBins+1, lenx-nrBins*binSize))
                stopifnot(length(cf) == lenx)
                tmpx <- split(xx,cf)
                tmpy <- split(yy,cf)
                yy <- sapply(tmpy, median, na.rm=TRUE)
                xx <- sapply(tmpx, mean, na.rm=TRUE)
            }else{
                ## very little events
                warning("Low number of events", call.=FALSE)
                tmpy <- split(yy,xx)
                yy <- sapply(tmpy, median, na.rm=TRUE)
                xx <- unique(xx)
            }
        }
        panel.xyplot(xx, yy, type="l", ...)
    } else{
        ## regular xyplot using lines
        panel.xyplot(xx, yy, type=type, ...)
    }
}



#' Methods implementing Lattice xyplots for flow data.
#' 
#' 
#' These functions create Trellis scatter plots (a.k.a. dot plots in the Flow
#' Cytometry community) from flow cytometry data.
#' 
#' 
#' The implementation of \code{xyplot} in \code{flowViz} is very close to the
#' original \code{lattice} version. Concepts like conditioning and the use of
#' panels apply directly to the flow cytometry data. The single fundamental
#' difference is that conditioning variables are not evaluated in the context
#' of the raw data, but rather in the \code{phenoData} slot environment (only
#' for the \code{flowSet} methods. Thus, we can directly condition on pheotypic
#' variables like sample groups, patients or treatments.
#' 
#' In the formula interface, the primary and secondary variables (separated by
#' the tilde) have to be valid parameter names. Please note that frequently
#' used variants like \code{FSC-H} and \code{SSC-H} are not syntactically
#' correct R symbols, and need to be wrapped in \code{` `}. E.g.,
#' \code{`FSC-H`}. For \code{flowSets}, the use of a conditioning variable is
#' optional. We implicitely condition on \code{flowFrames} and the default is
#' to arrange panels by sample names.
#' 
#' @name xyplot
#' @param x A formula describing the structure of the plot and the variables to
#' be used in the display.  In the \code{prepanel} and \code{panel} functions,
#' also the names of \code{\link[flowCore:flowFrame-class]{flowFrames}} or any
#' of the annotation data columns in the \code{phenoData} slot.
#' @param data,y,frame a \code{flowSet}, \code{\link[flowCore:flowFrame-class]{flowFrame}},
#' \code{ncdfFlowSet}, or \code{ncdfFlowList} object that serves as the
#' source of data.
#' @param prepanel The prepanel function. See
#' \code{\link[lattice:xyplot]{xyplot}}.
#' @param panel The panel function. See \code{\link[lattice:xyplot]{xyplot}}.
#' @param xlab,ylab Labels for data axes, with suitable defaults taken from the
#' formula.

#' @param \dots
#' 
#' marker.only \code{logical} specifies whether to show both channel and marker
#' names
#' 
#' More arguments, usually passed on to the underlying lattice methods.
#' @section Methods:
#' 
#' \describe{
#' 
#' \item{xyplot}{\code{signature(x = "flowFrame", data = "missing")}: Creates
#' diagnostic time series plots of flow parameter values against time. These
#' plots are useful to detect quality issues in the raw data. If not provided
#' explicitely via the \code{tine} argument, the time parameter will be
#' automatically detected. The additional arguments \code{xlab}, \code{ylab},
#' \code{nrpoints}, and \code{layout} are only listed because \code{flowViz}
#' provides different defaults. Internally, they are directly passed on to the
#' underlying \code{lattice} functions}. Argument \code{type} can be a
#' combination of any of the types allowed in \code{lattice xyplots}, or
#' \code{discrete}, in which case a smoothed average of the parameter against
#' time is plotted. \code{binSize} controls the binning that is used for the
#' smoothing procedure.
#' 
#' \item{xyplot}{\code{signature(x = "formula", data = "flowFrame")}: Creates
#' scatter plots (a.k.a. dot plots) of a pair of FCM channels. Depending on the
#' setting of the \code{smooth} argument, the data will be rendered as a
#' partially smoothed density estimate (\code{smooth=TRUE}, the default) or as
#' a regular scatter plot with separate points for individual events. The
#' formula interface allows for fairly general plotting, however there are
#' certain limitations on the use of expressions as part of the formulae.
#' Unless you are sure about what you are doing, you should transform the raw
#' data in a separate step using one of the tools in the
#' \code{\link[flowCore:flowCore-package]{flowCore}} package rather than inline
#' using the formula interface. The method allows to superimpose gating results
#' though the \code{filter} argument. If \code{smooth=TRUE}, we try to add
#' spherical 2D representations of the gates if applicable. For
#' \code{smooth=FALSE}, gates are indicated by a grouping mechanism using
#' different point shapes or colors (unless \code{outline} is also \code{TRUE},
#' in which case the gate outlines are superimposed in addition to the
#' grouping). Argument \code{margins} controls how events on the margins of the
#' measurement range are treated. The default (\code{TRUE}) is to discard them
#' from any density estimation and later add them as separate glyphs. Argument \code{par.settings} can be used
#' to supply lists of graphical parameters. See \code{\link{flowViz.par.set}} for details on controlling graphical
#' parameters in these plots. }
#' 
#' \item{xyplot}{\code{signature(x = "formula", data = "flowSet")}: Scatter
#' plots from a \code{flowSet} object. We allow for conditioning on variables
#' in the \code{phenoData} slot of the \code{flowSet}. All additional arguments
#' that apply to the \code{flowFrame} method are also valid for
#' \code{flowSets}. }
#' 
#' }
#' @author F. Hahne, D. Sarkar
#' @seealso
#' 
#' Not all standard lattice arguments will have the intended effect, but many
#' should.  For a fuller description of possible arguments and their effects,
#' consult documentation on lattice.
#' @keywords methods dplot
#' @examples
#' 
#' library(flowCore)
#' data(GvHD)
#' GvHD <- GvHD[pData(GvHD)$Patient %in% 5:6]
#' 
#' ## a bivariate scatterplot
#' ## by default ('smooth=TRUE') panel.smoothScatter is used
#' xyplot(`FSC-H` ~ `SSC-H`, GvHD[["s5a05"]], nbin = 100,
#' main="A single flowFrame")
#' 
#' ## A non-smooth version of the same data
#' xyplot(`FSC-H` ~ `SSC-H`, GvHD[["s5a05"]], nbin = 100,
#' main="A single flowFrame", smooth=FALSE)
#' 
#' ## A non-smooth version of the same data with customerized color scheme
#' require(IDPmisc)
#' colramp <- colorRampPalette(IDPcolorRamp(21))
#' xyplot(`FSC-H` ~ `SSC-H`, GvHD[["s5a05"]], nbin = 100,
#'        main="A single flowFrame", smooth=FALSE,
#'        colramp=colramp, pch=20, cex=0.1)
#' 
#' ## A hexbin version of non-smooth scatter plot  
#' xyplot(`FSC-H` ~ `SSC-H`, GvHD[["s5a05"]], xbin = 128
#'        ,main="A single flowFrame", smooth=FALSE)
#' 
#' 
#' ## Visual artifacts created by the pileup of margin events
#' xyplot(`FSC-H` ~ `SSC-H`, GvHD[["s5a05"]], nbin = 100,
#'        main="A single flowFrame", margin=FALSE)
#' 
#' 
#' ## simple bivariate scatter plot (a.k.a. dot plot)
#' ## for the whole flowSet, conditioning on Patient and
#' ## Visit
#' xyplot(`SSC-H` ~ `FSC-H` | Patient:Visit, data = GvHD)
#' 
#' ## Same bivariate scatter plot with replacing default color
#' require(IDPmisc)
#' cols <- colorRampPalette(IDPcolorRamp(21))
#' xyplot(`SSC-H` ~ `FSC-H` | Patient:Visit, data = GvHD, colramp=cols)
#' 
#' ## several examples with time on the X axis
#' ## first for a flowFrame
#' xyplot(GvHD[[1]])
#' 
#' ## and for flowSets
#' xyplot(`FSC-H` ~ Time | Visit, GvHD, 
#'        smooth = FALSE, type = "l", 
#'        subset = (Patient == 5), xbin = 32)
#' 
#' xyplot(`FSC-H` ~ Time | Patient+Visit, GvHD, 
#'        smooth = FALSE, type = "a",
#'        strip = FALSE, strip.left = TRUE,
#'        aspect = "xy", xbin = 32)
#' 
#' 
#' ## combine plots for two channels
#' ssc.time <- 
#' 
#'     xyplot(`SSC-H` ~ Time | factor(Patient):factor(Visit), GvHD, 
#'            smooth = FALSE, type = "a",
#'            strip = FALSE,
#'            strip.left = strip.custom(horizontal = TRUE),
#'            par.strip.text = list(lines = 3),
#'            between = list(y = rep(c(0, 0.5), c(6, 1))),
#'            scales = list(x = list(axs = "i"), y = list(draw = FALSE)),
#'            layout = c(1, 14), xbin = 32)
#' 
#' fsc.time <- 
#'     xyplot(`FSC-H` ~ Time | factor(Patient):factor(Visit), GvHD, 
#'            smooth = FALSE, type = "a",
#'            strip = FALSE,
#'            strip.left = strip.custom(horizontal = TRUE),
#'            par.strip.text = list(lines = 3),
#'            between = list(y = rep(c(0, 0.5), c(6, 1))),
#'            scales = list(x = list(axs = "i"), y = list(draw = FALSE)),
#'            layout = c(1, 14), xbin = 32)
#' 
#' plot(fsc.time, split = c(1, 1, 2, 1))
#' plot(ssc.time, split = c(2, 1, 2, 1), newpage = FALSE)
#' 
#' 
#' ## saving plots as variables allows more manipulation
#' plot(update(fsc.time[8:14], layout = c(1, 7)),
#'      split = c(1, 1, 1, 2))
#' 
#' plot(update(ssc.time[8:14], layout = c(1, 7)),
#'      split = c(1, 2, 1, 2), newpage = FALSE)
#' 
#' 
#' ## displaying filters
#' library(flowStats)
#' n2gate <- norm2Filter("SSC-H", "FSC-H")
#' 
#' xyplot(`SSC-H` ~ `FSC-H` | Patient:Visit, data = GvHD,
#'        filter=n2gate, subset=Patient==5)
#' 
#' xyplot(`SSC-H` ~ `FSC-H` | Patient:Visit,
#'        data=transform("SSC-H"=asinh,"FSC-H"=asinh) %on% GvHD,
#'        smooth=FALSE, filter=n2gate, subset=Patient == 5, xbin = 32)
#' 
#' 
#' ## displaying filters with stats
#' n2gate.results <- filter(GvHD, n2gate)
#' 
#' xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD,
#'        subset=Patient == "6",
#'        filter=n2gate.results, smooth=FALSE, xbin = 32
#'        ,stats=TRUE
#'        ,abs=TRUE
#'        ,digits=3 
#'        )
#' 
#'        
#' ## displaying multiple filters in one panel with stats
#' recGate1<-rectangleGate("FL3-H"=c(2.3,4.1),"FL2-H"=c(6.8,9))
#' recGate2<-rectangleGate("FL3-H"=c(1,3),"FL2-H"=c(4,6))
#' filters1<-filters(list(recGate1,recGate2))
#' trans<-transform("FL2-H"=asinh,"FL3-H"=asinh)
#' trans_data<-transform(GvHD[1:2],trans)
#' #replicate filters object across samples
#' flist <- list(filters1 , filters1)
#' names(flist) <- sampleNames(trans_data)
#' xyplot(`FL2-H` ~ `FL3-H`
#' 	   ,data=trans_data 
#'        ,filter= flist
#'        ,stats=TRUE
#'        ,margin=FALSE
#'        , xbin = 32
#'        , smooth = FALSE
#'        )
#' 
#' #display recGate2 as a overlay 
#' overlay <- Subset(trans_data,recGate1)
#' xyplot(`FL2-H` ~ `FL3-H`
#' 	   ,data=trans_data 
#'        ,filter=recGate2
#'        ,stats=TRUE
#'        ,margin=FALSE
#'        , smooth = FALSE
#'        , xbin = 32
#'        ,overlay= list(rect2 = overlay)
#'        ,par.settings = list(overlay.symbol = list(cex = 0.1))
#'        )
#' 
#' 
#' 
#' 
#' @export
#' @aliases xyplot,formula,flowFrame-method
setMethod("xyplot",
    signature=signature(x="formula",
        data="flowFrame"),
    definition=function(x,
                        data
                        , filter = NULL
                        , overlay= NULL#a list of flowFrames
                        , stats = FALSE
                        , strip.text = NULL#remove strip by setting cond as NULL
                        , ...)
{
  
  if(is.null(strip.text))   {
    defaultCond <- NULL
  }else
  {
    #try to use strip.text as the dummy sample name if it is given 
    #in order to display the customized text in strip
    defaultCond <- "name"
    data <- list(data)
    names(data) <- strip.text
  }
  
  data <- as(data, "flowSet")
  
  sn <- sampleNames(data)
  if(!is.null(filter)){
    filter <- list(filter)
    names(filter) <- sn
  }
  
  overlay <- .process_flowFrame_overlay(overlay, sn)
  
  if(!is.null(stats)){
    stats <- list(stats)
    names(stats) <- sn
  }
  
    
  xyplot(x, data, filter = filter
          , overlay = overlay, stats = stats
          , defaultCond = defaultCond , ...)  
})

#' convert a single flowFrame or a list of flowFrames to a list of flowSet
#' @param overlay flowFrame or a list of flowFrame objects
#' @param sn sample name
.process_flowFrame_overlay <- function(overlay, sn){
  if(!is.null(overlay)){
    # convert single flowFrame to a list
    if(!is.list(overlay))
      overlay <- list(dummy = overlay) #panel.xyplot.flowFrame expect a named list
    # convert a list of flowFrames to a list of flowSets
    overlay <- lapply(overlay, function(thisOverlay){
          thisOverlay <- as(list(thisOverlay), "flowSet")
          sampleNames(thisOverlay) <- sn
          thisOverlay
        })
    
  }
  overlay
}

## Prepanel function to set up dimensions. We want to use the instrument measurement
## range instead of the absolute range of the data. We also record the data ranges
## in the internal state environment for further use.
#' @param xlim,ylim limits for data axes. If not given, they are taken from the
#' ranges stored in flowFrame
#' @export 
#' @rdname xyplot
prepanel.xyplot.flowframe <- 
    function(frame, channel.x.name, channel.y.name, x, y, xlim, ylim,  ...)
{
    ranges <- range(frame)
#    browser()
    if(missing(xlim)){
      #use default calculation
      xlim <- if(!length(grep("`", channel.x.name, fixed=TRUE))){
          tmp <- ranges[, channel.x.name]
          xd <- diff(tmp)/15
          tmp + c(-1,1)*xd
        }else NULL
    }
    
    if(missing(ylim)){
      #use default calculation
        ylim <- if(!length(grep("`", channel.y.name, fixed=TRUE))){
          tmp <- ranges[, channel.y.name]
          yd <- diff(tmp)/15
          tmp + c(-1,1)*yd
        }else NULL
    }
    
    
    return(list(xlim=xlim, ylim=ylim))
}

#old version of panel function that still expects x,y vectors
panel.xyplot.flowframe.old <- function(x,y,frame,
    filter=NULL,
    smooth=TRUE,
    margin=TRUE,
    outline=FALSE,
    channel.x.name,
    channel.y.name,
    pch=gpar$flow.symbol$pch,
    alpha=gpar$flow.symbol$alpha,
    cex=gpar$flow.symbol$cex,
    col=gpar$flow.symbol$col,
    gp
    ,xbins=0
    ,binTrans=sqrt
    ,stats = FALSE
    ,pos=0.5
    ,digits=2
    ,abs=FALSE
    ,overlay.x=NULL
    ,overlay.y=NULL
    ,...)
{
  
  
  ## graphical parameter defaults
  limits<-prepanel.xyplot.flowframe(frame,channel.x.name,channel.y.name)
  xlim<-limits$xlim
  ylim<-limits$ylim
  argcolramp <- list(...)$colramp
  gpar <- flowViz.par.get()
  parameters<-c(channel.x.name, channel.y.name)
  if(!is.null(gp))
    gpar <- lattice:::updateList(gpar, gp)
  if(is.null(gpar$gate$cex))
    gpar$gate$cex <- cex
  if(is.null(gpar$gate$pch))
    gpar$gate$pch <- pch
#   browser()
  if(is.null(gpar$gate$plotType))
    gpar$gate$plotType<-"l"
  if(is.null(gpar$density))
    gpar$density<-TRUE
  ## Whenever we have a function call in the formula we might no longer be the
  ## original scale in which the gate was defined, and we have no clue how to
  # plot it
  validName <- !(length(grep("\\(", channel.x.name)) ||
        length(grep("\\(", channel.y.name)))
  
  ## in order to display overlay ,smooth needs to be set as TRUE
  if(!is.null(overlay.x))
    smooth<-TRUE
#browser()
  if(nrow(frame)==0)
    return (NULL)
  ## We remove margin events before passing on the data to panel.smoothScatter
  ## and after plotting indicate those events by grayscale lines on the plot
  ## margins
  l <- length(x)
  
  
  if (smooth){
    if(margin){
      r <- range(frame)[, c(channel.x.name, channel.y.name)]
#               l <- length(x)
      inc <- apply(r, 2, diff)/1e5
      dots <- list(...)
      nb <- if("nbin" %in% names(dots)) rep(dots$nbin, 2) else rep(64, 2)
      selxL <- x > r[2,channel.x.name]-inc[1]
      selxS <- x < r[1,channel.x.name]+inc[1]
      selyL <- y > r[2,channel.y.name]-inc[2]
      selyS <- y < r[1,channel.y.name]+inc[2]
      allsel <- !(selxL | selxS | selyL | selyS)
      
      if(sum(allsel)>0)
      {
        panel.smoothScatter(x[allsel], y[allsel],
            range.x=list(r[,1], r[,2]), ...)
        addMargin(r[1,channel.x.name], y[selxS], r, l, nb)
        addMargin(r[2,channel.x.name], y[selxL], r, l, nb, b=TRUE)
        addMargin(x[selyS], r[1,channel.y.name], r, l, nb)
        addMargin(x[selyL], r[2,channel.y.name], r, l, nb, b=TRUE)
      }
      else
      {
        panel.smoothScatter(x, y, ...)
      }
    }else{
      panel.smoothScatter(x, y, ...)
    }
    ptList<-plotType("gsmooth", c(channel.x.name, channel.y.name))
  }else{
    #for non-smoothed plot:
    #1:always remove boundary events for hexbin version 
    #since they are going to affect the color encoding for density
    #2.for non-hexbin version,when gpar$density=FALSE,which means one-color non-densityscatter plot
    #we then keep the boundary events 
    if(margin){
      
      r <- range(frame)[, c(channel.x.name, channel.y.name)]
#               l <- length(x)
      inc <- apply(r, 2, diff)/1e5
      dots <- list(...)
      nb <- if("nbin" %in% names(dots)) rep(dots$nbin, 2) else rep(64, 2)
      selxL <- x > r[2,channel.x.name]-inc[1]
      selxS <- x < r[1,channel.x.name]+inc[1]
      selyL <- y > r[2,channel.y.name]-inc[2]
      selyS <- y < r[1,channel.y.name]+inc[2]
      allsel <- !(selxL | selxS | selyL | selyS)
      #we may want to skip marginal events in non-smoothed version to save time           
      if(sum(allsel)>0)
      {
        addMargin(r[1,channel.x.name], y[selxS], r, l, nb)
        addMargin(r[2,channel.x.name], y[selxL], r, l, nb, b=TRUE)
        addMargin(x[selyS], r[1,channel.y.name], r, l, nb)
        addMargin(x[selyL], r[2,channel.y.name], r, l, nb, b=TRUE)
      }
      
      x<-x[allsel]
      y<-y[allsel]
      
    }
#           browser()
    if(xbins>0)
    {
      #using hexbin package to do the hexagon plot    
      bin<-hexbin(x,y,xbins=xbins)
      if (is.null(argcolramp))
        argcolramp<-flowViz.par.get("argcolramp")
      #           if (is.null(argcolramp))
      #               argcolramp<-colorRampPalette(c("blue","green","yellow","red"),bias=1)
      #           browser()
      grid.hexagons(bin,colramp = argcolramp,trans=binTrans)      
      
      
    }else
    {
      if (is.null(argcolramp))
        argcolramp<-flowViz.par.get("argcolramp")
      if(gpar$density)
        col <- densCols(x, y, colramp=argcolramp)
      panel.xyplot(x, y, col=col, cex=cex, pch=pch, alpha=alpha, ...)
      
    }
    
    ptList<-plotType("gpoints", c(channel.x.name, channel.y.name))
  }
#   }
#    browser()
  #plot gate
  if(!is.null(filter) && validName){
    if(is(filter,"filters"))
    {
      
      mapply(filter,stats,FUN=function(curFilter,curStats){
            
            
            if(gpar$gate$plotType=="p")##highlight the dots within gate,by default it is now disabled 
            {
              if(!is(curFilter, "filterResult"))
                curFilter <- filter(frame, curFilter)
              rest <- Subset(frame, !filter)
              x <- exprs(rest[,channel.x.name])
              y <- exprs(rest[,channel.y.name])
              
              
              glpoints(curFilter, frame,
                  channels=c(channel.x.name, channel.y.name),
                  verbose=FALSE, gpar=gpar, strict=FALSE,ptList=ptList, ...)
              if(outline)
                glpolygon(curFilter, frame,
                    channels=c(channel.x.name, channel.y.name),
                    verbose=FALSE, gpar=gpar, names=FALSE,
                    strict=FALSE,ptList=ptList,xlim=xlim
                    ,ylim=ylim)
              
            }else
            {
              
              names <- .getStats(curFilter,curStats, frame, digits, ...)
              
              glpolygon(curFilter, frame,
                  
                  verbose=FALSE, gpar=gpar
                  , names=names
                  ,strict=FALSE
                  ,pos=pos
                  ,abs=abs
                  ,ptList=ptList
                  ,xlim=xlim
                  ,ylim=ylim
              )
            }
          })
    }else
    {
      if(gpar$gate$plotType=="p")##highlight the dots within gate,by default it is now disabled 
      {
        if(!is(filter, "filterResult"))
          filter <- filter(frame, filter)
        rest <- Subset(frame, !filter)
        x <- exprs(rest[,channel.x.name])
        y <- exprs(rest[,channel.y.name])
        
        
        glpoints(filter, frame,
            channels=c(channel.x.name, channel.y.name),
            verbose=FALSE, gpar=gpar, strict=FALSE,ptList=ptList, ...)
        if(outline)
          glpolygon(filter, frame,
              channels=c(channel.x.name, channel.y.name),
              verbose=FALSE, gpar=gpar, names=FALSE,
              strict=FALSE,ptList=ptList,xlim=xlim
              ,ylim=ylim)
        
      }else
      {
        names <- .getStats(filter,stats, frame, digits, ...) 
        
#               browser()
        glpolygon(filter, frame,
#                       channels=c(channel.x.name, channel.y.name),
            verbose=FALSE, gpar=gpar
            , names=names
            ,strict=FALSE
            ,pos=pos
            ,abs=abs
            ,ptList=ptList
            ,xlim=xlim
            ,ylim=ylim
        )
      }
    }
  }
  
  if(!is.null(overlay.x)&&!is.null(overlay.y))
  {
    lpoints(overlay.x,overlay.y,col="red",cex=cex*3,pch=pch)
    #plot stats for bool gates
    if(stats&&is.null(filter))
    {
      p.stats<-length(overlay.x)/l
#           p.stats<-sprintf(paste("%.",prec,"f%%",sep=""),p.stats*100)
      p.stats<-paste(format(p.stats*100,digits=digits),"%",sep="")
#           browser()
      xx<-xlim
      yy<-ylim
      
      pos <- rep(pos, length=2)[1:2]
      xx<-xx[1]+diff(xx)*pos[1]
      yy<-yy[1]+diff(yy)*pos[2]
      
      gltext(xx, yy, labels=p.stats, adj=0.5, gp=gpar$gate.text)
    }
  }
  
  
}


## Panel function that allows us to add filters on the plot. The actual plotting
## is done by either the panel.smoothScatter or the default lattice panel.xyplot
## function
##when xbins>0, we do the hexagon plot provided by hexbin package to improve the speed
#overlay is a list of flowFrames, which are the extra points need to be plotted on top of the x,y



#' @param layout These arguments are passed unchanged to the corresponding
#' methods in lattice, and are listed here only because they provide different
#' defaults.  See documentation for the original methods for details.
#' @param overlay The extra cell events plotted on top of the current cell
#' population.  It is a \code{flowSet} for \code{panel.xyplot.flowset} function
#' and a \code{flowFrame} for \code{xyplot(c("formula","flowFrame"))} method.
#' @param channel.x.name,channel.y.name Character strings giving corresponding
#' names used to match filter parameters if applicable.
#' @param smooth Logical. If \code{TRUE}, \code{panel.smoothScatter} is used to
#' display a partially smoothed version of the data.  Otherwise, events are
#' plotted individually, as in a standard scatter plot. If \code{FALSE}, a
#' graphical parameter \code{colramp} can be used to obtain a coloring of
#' points that is indicative of their local density.
#' @param filter A \code{\link[flowCore:filter-class]{filter}},
#' \code{\link[flowCore:filterResult-class]{filterResult}} or
#' \code{\link[flowCore:filterResult-class]{filterResultList}} object or a list
#' of such objects of the same length as the \code{flowSet}.  Also a
#' \code{\link[flowCore:filters-class]{filters}} or A
#' \code{\link[flowCore:filtersList-class]{filtersList}} can be passed to
#' xyplot in order to plot multiple filters/gates(with the same x,y parameters)
#' on one panel to represent multiple sub-populations.  The appropriate
#' spherical 2D representation of this filter will be superimposed on the plot
#' if \code{smooth=TRUE}, or the result of the filtering operation will be
#' indicated by grouping if \code{smooth=FALSE}. The software will figure out
#' whether the \code{filter} needs to be evaluated in order to be plotted (in
#' which case providing a \code{filterResult} can speed things up
#' considerably).
#' @param margin Logical indicating whether to truncate the density estimation
#' on the margins of the measurement range and plot margin events as lines if
#' \code{smooth=TRUE}. To avoid visual artifacts it is highly recommended to
#' set this option to \code{TRUE}.
#' @param outline Logical, specifying whether to add the boundaries of a gate
#' to the plot when \code{smooth=FALSE} in addition to the grouping. Defaults
#' to \code{FALSE}.
#' @param pch,cex,col,alpha Graphical parameters used when \code{smooth=FALSE}.
#' These mostly exist for conveniance and much more control is available
#' throught the \code{lattice}-like \code{par.setting} and
#' \code{flowViz.par.set} customization. See \code{\link{flowViz.par.set}} for
#' details.
#' @param gp A list of graphical parameters that are passed down to the low
#' level panel functions. This is for internal use only. The public user
#' interface to set graphical parameters is either \code{par.settings} for
#' customization of a single call or \code{flowViz.par.set} for customization
#' of session-wide defaults.
#' @param channel.x,channel.y Expressions defining the x and y variables in
#' terms of columns in the data.  Can involve functions or multiple columns
#' from the data, however this usage is discouraged.
#' @param frames An environment containing frame-specific data.
#' @param xbins The argument passed to \code{\link[hexbin:hexbin]{hexbin}}
#' ,which is the number of bins partitioning the range of xbnds.  It is set as
#' 0 by default,which plots all the events without binning.  When it is larger
#' than 0,hexbin plot engine is used for the faster plotting.  Note that it is
#' only valid when \code{smooth} is set as FALSE .
#' @param binTrans The argument passed to
#' \code{\link[hexbin:grid.hexagons]{grid.hexagons}} ,which is a transformation
#' function (or NULL) for the count.  It is \code{\link[base:sqrt]{sqrt}} by
#' default.
#' @param stats,pos,digits,abs Arguments to control statistics that is
#' associated with \code{\link[flowCore:filter-class]{filter}} to be plotted
#' Currently only population proportion/percentage is supported.  \code{stats}
#' is a \code{logical} scalar indicating whether to display statistics. Default
#' is FALSE.  \code{pos} is the \code{numeric} scalar (range within c(0,1)) or
#' vector(length of 2,first is for x-axis,second for y-axis) to control the
#' position of the statistics label. It is set as 0.5,which is the center.
#' \code{digits} is an \code{integer} indicating the number of significant
#' digits to be used when displaying the percentage of population
#' statistics,Default is 2. see more details from \code{\link[base]{format}}
#' \code{abs} is a \code{logical} scalar indicating whether the \code{pos} is
#' relative to the gate boundary or the entire xy-axis(absolute position).  By
#' default it is set as FALSE,which indicates the position is relative to gate.
#' @param overlay.symbol list of the lattice graphic parameters to format the
#' overlay points.
#' @param sample.ratio \code{numeric} the ratio of sub-sampling of events to
#' speed up plotting.
#' @param strip.text A \code{character} that customizes the text in strip.
#' Default is NULL, which does not display the strip box at all. It is only
#' valid when plotting a \code{flowFrame}
#' @param checkName \code{logical} indicating whether to skip checking the
#' bracket '(' in channel name
#' @export panel.xyplot.flowframe
#' @importFrom hexbin hexbin grid.hexagons
#' @importFrom IDPmisc IDPcolorRamp col2hsv
#' @export 
#' @rdname xyplot
panel.xyplot.flowframe <- function(frame,
                                   filter=NULL,
                                   smooth=TRUE,
                                   margin=TRUE,
                                   outline=FALSE,
                                   channel.x.name,
                                   channel.y.name,
                                   pch=gp$flow.symbol$pch,
                                   alpha=gp$flow.symbol$alpha,
                                   cex=gp$flow.symbol$cex,
                                   col=gp$flow.symbol$col,
                                   gp
								   ,xbins=0
						   		   ,binTrans=sqrt
						   			,stats = FALSE
									,pos=0.5
									,digits=2
									,abs=FALSE
									,overlay = NULL
                                    ,checkName = TRUE
                                    ,sample.ratio = 1
                                    , overlay.symbol = NULL
						   			,...)
{
    
	
    
    
    ## graphical parameter defaults
	limits<-prepanel.xyplot.flowframe(frame,channel.x.name,channel.y.name)
	xlim<-limits$xlim
	ylim<-limits$ylim
    argcolramp <- list(...)$colramp
	
	parameters<-c(channel.x.name, channel.y.name)
    if(is.null(gp$gate$cex))
        gp$gate$cex <- cex
    if(is.null(gp$gate$pch))
        gp$gate$pch <- pch
#	browser()
	if(is.null(gp$gate$plotType))
		gp$gate$plotType<-"l"
	if(is.null(gp$density))
		gp$density<-TRUE
    ## Whenever we have a function call in the formula we might no longer be the
    ## original scale in which the gate was defined, and we have no clue how to
    # plot it
    if(checkName)
      validName <- !(length(grep("\\(", channel.x.name)) ||
                   length(grep("\\(", channel.y.name)))
    else
      validName <- TRUE
	
    if(!validName)
      warning("Gate will not be plotted because channel names contain '(' character! Try to set checkName to FALSE to skip this check.")

    ## in order to display overlay ,smooth needs to be set as TRUE
#    if(!is.null(overlay.x))
#         smooth<-TRUE
    
	if(nrow(frame)==0)
		return (NULL)
    ## We remove margin events before passing on the data to panel.smoothScatter
    ## and after plotting indicate those events by grayscale lines on the plot
    ## margins
    dat <- exprs(frame)
    l <- nrow(dat)
    if(sample.ratio < 1 && sample.ratio > 0){
      ind <- sample.int(l, size = l * sample.ratio)
      x <- dat[ind, channel.x.name]
      y <- dat[ind, channel.y.name]  
    }else
    {
      x <- dat[, channel.x.name]
      y <- dat[, channel.y.name]
    }
      
    
		
	    if (smooth){
			if(margin){
				r <- range(frame)[, c(channel.x.name, channel.y.name)]
#				l <- length(x)
				inc <- apply(r, 2, diff)/1e5
				dots <- list(...)
				nb <- if("nbin" %in% names(dots)) rep(dots$nbin, 2) else rep(64, 2)
				selxL <- x > r[2,channel.x.name]-inc[1]
				selxS <- x < r[1,channel.x.name]+inc[1]
				selyL <- y > r[2,channel.y.name]-inc[2]
				selyS <- y < r[1,channel.y.name]+inc[2]
				allsel <- !(selxL | selxS | selyL | selyS)
				
	            if(sum(allsel)>0)
	            {
	                panel.smoothScatter(x[allsel], y[allsel],
	                                    range.x=list(r[,1], r[,2]), ...)
	                addMargin(r[1,channel.x.name], y[selxS], r, l, nb)
	                addMargin(r[2,channel.x.name], y[selxL], r, l, nb, b=TRUE)
	                addMargin(x[selyS], r[1,channel.y.name], r, l, nb)
	                addMargin(x[selyL], r[2,channel.y.name], r, l, nb, b=TRUE)
	            }
	            else
	            {
	                panel.smoothScatter(x, y, ...)
	            }
	        }else{
	            panel.smoothScatter(x, y, ...)
	        }
			ptList<-plotType("gsmooth", c(channel.x.name, channel.y.name))
	    }else{
			#for non-smoothed plot:
			#1:always remove boundary events for hexbin version 
			#since they are going to affect the color encoding for density
			#2.for non-hexbin version,when gp$density=FALSE,which means one-color non-densityscatter plot
			#we then keep the boundary events 
			if(margin){
				
				r <- range(frame)[, c(channel.x.name, channel.y.name)]
#				l <- length(x)
				inc <- apply(r, 2, diff)/1e5
				dots <- list(...)
				nb <- if("nbin" %in% names(dots)) rep(dots$nbin, 2) else rep(64, 2)
				selxL <- x > r[2,channel.x.name]-inc[1]
				selxS <- x < r[1,channel.x.name]+inc[1]
				selyL <- y > r[2,channel.y.name]-inc[2]
				selyS <- y < r[1,channel.y.name]+inc[2]
				allsel <- !(selxL | selxS | selyL | selyS)
				#we may want to skip marginal events in non-smoothed version to save time			
				if(sum(allsel)>0)
				{
					addMargin(r[1,channel.x.name], y[selxS], r, l, nb)
					addMargin(r[2,channel.x.name], y[selxL], r, l, nb, b=TRUE)
					addMargin(x[selyS], r[1,channel.y.name], r, l, nb)
					addMargin(x[selyL], r[2,channel.y.name], r, l, nb, b=TRUE)
				}
					
				x<-x[allsel]
				y<-y[allsel]
				
			}
#			browser()
        
            if (is.null(argcolramp))
              argcolramp <- flowViz.par.get("argcolramp")
            if(!is.null(overlay)){
              argcolramp <- .colRmpPlt(alpha = gp$overlay.symbol$bg.alpha)
            }
              
			if(xbins > 0)
			{
              
				#using hexbin package to do the hexagon plot	
				bin <- hexbin(x,y,xbins=xbins)
                
				gridRes <- try(grid.hexagons(bin,colramp = argcolramp, trans=binTrans, border =0), silent = TRUE)		
                
                if(class(gridRes) == "try-error"){
                  #if error then try without trans
                  grid.hexagons(bin,colramp = argcolramp, border =0)
                }				
                
			}else
			{
				
				if(gp$density)
					col <- densCols(x, y, colramp=argcolramp)
#                browser()
                dots <- list(...)
                dots$darg <- NULL
                dots$type <- NULL
                do.call(panel.xyplot, args = c(list(x = x, y = y
                                                , col = col
                                                , cex = cex
                                                , pch = pch
                                                , alpha = alpha
                                                )
                                                , dots
                                                )
                                                
                                            )
                    	
			}
            
			ptList<-plotType("gpoints", c(channel.x.name, channel.y.name))
		}

#    browser()
	#plot gate
	if(!is.null(filter) && validName){
		if(is(filter,"filters"))
		{

			mapply(filter,stats,FUN=function(curFilter,curStats){
						
						
						if(gp$gate$plotType=="p")##highlight the dots within gate,by default it is now disabled 
						{
							if(!is(curFilter, "filterResult"))
								curFilter <- filter(frame, curFilter)
							rest <- Subset(frame, !filter)
							x <- exprs(rest[,channel.x.name])
							y <- exprs(rest[,channel.y.name])
							
							
							glpoints(curFilter, frame,
									channels=c(channel.x.name, channel.y.name),
									verbose=FALSE, gpar=gp, strict=FALSE,ptList=ptList, ...)
							if(outline)
								glpolygon(curFilter, frame,
										channels=c(channel.x.name, channel.y.name),
										verbose=FALSE, gpar=gpar, names=FALSE,
										strict=FALSE,ptList=ptList,xlim=xlim
										,ylim=ylim)
							
						}else
						{
                          
                            names <- .getStats(curFilter,curStats, frame, digits, ...)
							
							glpolygon(curFilter, frame,

									verbose=FALSE, gpar=gp
									, names=names
									,strict=FALSE
									,pos=pos
									,abs=abs
									,ptList=ptList
									,xlim=xlim
									,ylim=ylim
							)
						}
					})
		}else
		{
			if(gp$gate$plotType=="p")##highlight the dots within gate,by default it is now disabled 
			{
				if(!is(filter, "filterResult"))
					filter <- filter(frame, filter)
				rest <- Subset(frame, !filter)
				x <- exprs(rest[,channel.x.name])
				y <- exprs(rest[,channel.y.name])
				
				
				glpoints(filter, frame,
						channels=c(channel.x.name, channel.y.name),
						verbose=FALSE, gpar=gp, strict=FALSE,ptList=ptList, ...)
				if(outline)
					glpolygon(filter, frame,
							channels=c(channel.x.name, channel.y.name),
							verbose=FALSE, gpar=gp, names=FALSE,
							strict=FALSE,ptList=ptList,xlim=xlim
							,ylim=ylim)
				
			}else
			{
              names <- .getStats(filter,stats, frame, digits, ...) 
                  
#				browser()
				glpolygon(filter, frame,
#						channels=c(channel.x.name, channel.y.name),
						verbose=FALSE, gpar=gp
						, names=names
						,strict=FALSE
						,pos=pos
						,abs=abs
						,ptList=ptList
						,xlim=xlim
						,ylim=ylim
				)
			}
		}
	}
#	browser()
	if(!is.null(overlay))
	{
        overlayNames <- names(overlay)
        for(overLayName in overlayNames){
          thisOverlay <- overlay[[overLayName]]
          thisDat <- exprs(thisOverlay)
          overlay.x <- thisDat[, channel.x.name]
          overlay.y <- thisDat[, channel.y.name]
          
          this.overlay.symbol <- gp$overlay.symbol#default setting
          user.overlay.symbol <- overlay.symbol[[overLayName]]#customized settings
          #update the default with customized settings
          if(!is.null(user.overlay.symbol))
            this.overlay.symbol <- lattice:::updateList(this.overlay.symbol, overlay.symbol[[overLayName]])
          lpoints(overlay.x, overlay.y
                    , col = this.overlay.symbol[["fill"]]
                    , alpha = this.overlay.symbol[["alpha"]]
                    , cex= this.overlay.symbol[["cex"]] 
                    , pch = this.overlay.symbol[["pch"]]
                    )
        }
        #plot stats for bool gates
        if(is.null(filter))
        {
          if(is.logical(stats)&&stats)
          {
            p.stats<-length(overlay.x)/l
            
            p.stats<-paste(format(p.stats*100,digits=digits),"%",sep="")
            #			browser()
            xx<-xlim
            yy<-ylim
            
            pos <- rep(pos, length=2)[1:2]
            xx<-xx[1]+diff(xx)*pos[1]
            yy<-yy[1]+diff(yy)*pos[2]
            
            gltext(xx, yy, labels=p.stats, adj=0.5, gp=gp$gate.text)
          }
        }
	}
		
	
}




##############################################################################
##                            flowSet methods                               ##
##############################################################################
## xyplot method for flowSets with formula.
#' @export 
#' @rdname xyplot
#' @param par.settings A list of lists of graphical parameters.  See \code{\link{flowViz.par.set}} for details.
setMethod("xyplot",
          signature=signature(x="formula",
                              data="flowSet"),
          definition= function(x,data, ...){
            thisTrellisObj <- .xyplot.flowSet(x, data, plotType = "xyplot", ...)
            thisData <- thisTrellisObj[["panel.args.common"]][["frames"]]
            thisTrellisObj[["panel.args.common"]][["frames"]] <- thisData@frames
            thisTrellisObj
          })
      
## flowViz:::.xyplot.flowSet now passes data instead of data@frames 
## within flowViz::xyplot method that changes it back to data@frames
## however ncdfFlow::xyplot keeps data as it is
# @param marker.only Specifies whether to show both channel and marker names.
# @rdname xyplot
.xyplot.flowSet <- function(x,
                              data,
                              smooth=TRUE,
                              filter=NULL,
                              as.table=TRUE,
                              prepanel=prepanel.xyplot.flowset,
                              panel=panel.xyplot.flowset
                              , xlab= NULL 
                              , ylab= NULL 
                              , par.settings=NULL
                              , axis= axis.grid
                              ,defaultCond = "name" #to override the default conditional variable 'name'
                                            #mainly used for plotting single flowFrame
                              , between = list(x=0.2,y=0.2)
                              , plotType = "xyplot"
                              , marker.only = FALSE
                              , ...)
      {
       
          ## no conditioning variable, we chose 'name' as default
          if (length(x[[3]]) == 1){
              if(!is.null(defaultCond)){
                tmp <- x[[3]]
                strFormula <- "~dummy"  
                strFormula <- paste(strFormula,defaultCond,sep = "|")
                strFormula <-as.formula(strFormula)
                x[[3]] <- (strFormula)[[2]]
                x[[3]][[2]] <- tmp
              }
          }
          if(! "name" %in% names(pData(data)))
              pData(data)$name <- sampleNames(data)
          ## par.settings will not be passed on to the panel functions, so
          ## we have to fetch it from ... and stick the gate relevant stuff
          ## back it in there manually
           
		  this.par.settings <- par.settings #copy the customized settings
		  gpar <- flowViz.par.get()# grab the default theme
		  
          #update the customized settings 
		  if(!is.null(this.par.settings))
		  {
            this.par.settings <- lattice:::updateList(gpar, this.par.settings)
              
		  }else
            this.par.settings <- gpar
            
          ## ugly hack to suppress warnings about coercion introducing
          ## NAs (needs to be `undone' inside prepanel and panel
          ## functions):
          pd <- pData(data)
          uniq.name <- createUniqueColumnName(pd)
          pd[[uniq.name]] <- factor(sampleNames(data))
          
          ## deparse the formula structure
          channel.y <- x[[2]]
          channel.x <- x[[3]]
          if (length(channel.x) == 3)
          {
              channel.x <- channel.x[[2]]
              x[[3]][[2]] <- as.name(uniq.name)
              x[[2]] <- NULL
          }
          else
          {
              x[[3]] <- as.name(uniq.name)
              x[[2]] <- NULL
          }
          channel.x.name <- expr2char(channel.x)
          channel.y.name <- expr2char(channel.y)
          
          
          frm <- data[[1, use.exprs = FALSE]]
          xObj <- getChannelMarker(frm, channel.x.name)
          yObj <- getChannelMarker(frm, channel.y.name)
          channel.x.name <- xObj[["name"]]
          channel.y.name <- yObj[["name"]]
          if(marker.only){
            default_xlab <- as.character(ifelse(is.na(xObj[,"desc"]), channel.x.name, xObj[,"desc"]))
            default_ylab <- as.character(ifelse(is.na(yObj[,"desc"]), channel.y.name, yObj[,"desc"]))
            
          }else
          {
            default_xlab <- sub("NA","",paste(unlist(xObj),collapse=" "))
            default_ylab <- sub("NA","",paste(unlist(yObj),collapse=" "))
          }
         
#          browser()
          if(is.null(xlab)){
            xlab <- default_xlab
          }else
          {
            if(is.list(xlab))
              xlab <- lattice:::updateList(list(label = default_xlab), xlab) #update default scales if non-null scales are specified
          }
          
          if(is.null(ylab)){
            ylab <- default_ylab
          }else
          {
            if(is.list(ylab))
              ylab <- lattice:::updateList(list(label = default_ylab), ylab) #update default scales if non-null scales are specified
          }
          
          channel.x <- as.expression(channel.x)
          channel.y <- as.expression(channel.y)
          ## use densityplot or bwplot method with dedicated panel and prepanel
          ## functions to do the actual plotting
          
          if(plotType == "xyplot"){
            densityplot(x, data=pd, prepanel=prepanel, panel=panel,
                frames=data, channel.x=channel.x,
                channel.y=channel.y, channel.x.name=channel.x.name,
                channel.y.name=channel.y.name, xlab=xlab, ylab=ylab,
                smooth=smooth, gp=this.par.settings, as.table=as.table, filter=filter,
                par.settings=this.par.settings, axis = axis, between = between, ...)
          }else if(plotType %in% c("densityplot", "histogram")){     #use bwplot instead due to the conflicts with the default darg argument of lattice::densityplot      
            bwplot(x, data=pd, prepanel=prepanel, panel=panel,
                      frames=data, channel.x=channel.x,
                      channel.y=channel.y, channel.x.name=channel.x.name,
                      channel.y.name=channel.y.name, xlab=xlab, ylab=ylab,
                      smooth=smooth, gp=this.par.settings, as.table=as.table, filter=filter,
                      par.settings=this.par.settings, axis = axis, between = between, plotType = plotType, ...)
        }else
          stop("unknown plot type: ", plotType)
      }



## Prepanel function to set up dimensions. We want to use the instrument measurement
## range instead of the absolute range of the data. We also record the data ranges
## in the internal state environment for further use.
#' @export 
#' @rdname xyplot
prepanel.xyplot.flowset <- 
    function(x, frames, channel.x.name, channel.y.name
      , xlim , ylim, ...)
{
  if (length(nm <- as.character(x)) > 1)
    stop("must have only one flow frame per panel!Please ensure the conditional variable is not set properly so that each group just has one sample. ")

    if (length(nm) == 1){
        ranges <- range(frames[[nm, use.exprs = FALSE]])
        if(missing(xlim)){
          #use default calculation
          xlim <- if(!length(grep("`", channel.x.name, fixed=TRUE))){
              tmp <- ranges[, channel.x.name]
              xd <- diff(tmp)/15
              tmp + c(-1,1)*xd
          }else NULL
      }
      if(missing(ylim)){
        #use default calculation
        ylim <- if(!length(grep("`", channel.y.name, fixed=TRUE))){
            tmp <- ranges[, channel.y.name]
            yd <- diff(tmp)/15
            tmp + c(-1,1)*yd
        }else NULL
      }
        return(list(xlim=xlim, ylim=ylim))
    }else
		return(list())
}

## 'filter' either has to be a single filter, or a list of filters matching
## the flowSet's sample names, or a filterResultList.
#' @param nm \code{character} sample names
#' @param lc \code{numeric} number of channels, only used for stacked densityplot validity check, ignored for xyplot and non-stacked densityplot
#' @param which.channel \code{numeric} index of channel, only used for stacked densityplot validity check, ignored for xyplot and non-stacked densityplot
.processFilter <- function(filter, nm, lc = 0, which.channel = 0){
#  browser()
  if(!is.null(filter)){

    if(lc > 1){
      if(!is.list(filter) && is(filter, "filterResultList") ||
          length(filter) != lc)
        stop("You are plotting several channels. Argument 'filter'/n",
            "must be a list of the same length as number of channels.",
            call.=FALSE)
      filter <- filter[[which.channel]]
    }
    
    if(!is.list(filter)){
      if(is(filter, "filter")){
        filter <- lapply(seq_along(nm), function(x) filter)
        names(filter) <- nm
      }
    }else if(!is(filter, "filterResultList")&&!is(filter, "filtersList"))
      filter <- as(filter, "filterResultList")
    
    
    if(any(!nm %in% names(filter)) || any(sapply(nm,function(thisNM)
                                                  !(is(filter[[thisNM]] ,"filter")||is(filter[[thisNM]] ,"filters"))
                                            )))
    {
          warning("'filter' must either be a filtersList,filterResultList, a single\n",
          "filter object or a named list of filter objects.",
          call.=FALSE)
      filter <- NULL
    }
  }
  filter
  
  
    
   
  
}

## FIXMES:
##   - How can we cleanly deparse the formula to get to the channel
##     names?
##   - The Formula interface allows for arbitrary functions to be
##     called on the data before plotting. If that happens, we have no
##     clue what to do with the gates, since they are still defined in
##     the old coordinate system.
##   - The same is true for the range parameters stored in the flowFrame.
##     These only make sense in the original coordinates. Do we want to
##     transform them, and if so, how can we do that? Can we substitute
##     the flow data by a vector containing the ranges in the formula? 
## Panel function that allows us to add filters on the plot. The actual plotting
## is done by panel.xyplot.flowframe
#' @export 
#' @rdname xyplot
panel.xyplot.flowset <- function(x,
                                 frames,
                                 filter = NULL,
                                 channel.x,
                                 channel.y,
								 overlay= NULL#a list of flowSet
                                ,stats = FALSE
						 ,...)
{
    nm <- as.character(x)
    if (length(nm) < 1) return()
   
    filter <- .processFilter(filter, nm)

    if(!is.list(stats)){
        stats <- lapply(seq_along(nm), function(x) stats)
        names(stats) <- nm
      
    }
    overlay <- .process_overlay_flowSet(overlay, nm)
    
    
    panel.xyplot.flowframe(frame=frames[[nm]], filter=filter[[nm]]
                              , overlay = overlay
                              , stats = stats[[nm]]
                               , ...)
}

#' extract the respective flowFrame from each flowSet based on the given sampleName
#' @param overlay a list of flowSet
#' @param nm sample name
.process_overlay_flowSet <- function(overlay, nm){
  if(!is.null(overlay)){
    if(!is.list(overlay))
      stop("overlay must be a list of flowSet!")
    overlay <- sapply(overlay, function(thisOverlay){
          thisClass <- class(thisOverlay)
          if(!(extends(thisClass, "flowSet")||extends(thisClass, "ncdfFlowList")))
            stop("overlay must be a list of 'flowSet'")
          thisOverlay[[nm]]
          
        })
  }
  overlay
}

addMargin <- function(x, y, r, total, nb, len=200, b=FALSE)
{
    if(length(x) & length(y)){
        dx <-  diff(r[,1])
        dy <- diff(r[,2])
        lenx <- dx/len
        leny <- dy/len
        addX <- if(b) dx/nb[1]*1.1 else 0
        addY <- if(b) dy/nb[2]*1.1 else 0
        n <- 100
        colvec <- colorRampPalette(c("lightgray", "black"))(100) 
        if(length(x)==1){
            hh <- hist(y, n=n, plot=FALSE)
            sel <- hh$counts > 0
            xoff <- dx/(nb[1]*2)-addX
            col <- colvec[pmin(100, as.integer(hh$counts[sel]/total*5000)+1)]
            panel.segments(rep(x-xoff, n), hh$mids[sel], rep(x-xoff-lenx, n),
                           hh$mids[sel], col=col, lwd=3, lineend=2)
        }else{
            hh <- hist(x, n=n, plot=FALSE)
            sel <- hh$counts > 0
            yoff <- dy/(nb[2]*2)-addY
            col <- colvec[pmin(100, as.integer(hh$counts[sel]/total*5000)+1)]
            panel.segments(hh$mids[sel], rep(y-yoff, n), hh$mids[sel],
                           rep(y-yoff-leny, n), col=col, lwd=3, lineend=2)
        }
    }
}





## ==========================================================================
## Plot a view object. For everything but gates we have the modified data
## available, hence we can plot directly
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
#' @rdname xyplot
#' @aliases xyplot,formula,view-method
setMethod("xyplot",
          signature(x="formula", data="view"),
          function(x, data, ...) xyplot(x, Data(data), ...))

#' @rdname xyplot
#' @aliases xyplot,view,missing-method
setMethod("xyplot",
          signature(x="view", data="missing"),
          function(x, data, ...) xyplot(Data(x), ...))



## ==========================================================================
## Plot a gateView object. Essentially, this is calling the plot
## method on the parent data of the view, adding gates if appropriate.
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
#' @rdname xyplot
#' @aliases xyplot,formula,gateView-method
setMethod("xyplot",
          signature(x="formula", data="gateView"),
          function(x, data, filter=NULL, par.settings, ...)
      {
          fres <-
              if(!is.null(filter)) filter else get(action(data)@filterResult)
          ## deparse the formula structure
          channel.y <- x[[2]]
          channel.x <- x[[3]]
          if (length(channel.x) == 3)
              channel.x <- channel.x[[2]]
          channel.x.name <- flowViz:::expr2char(channel.x)
          channel.y.name <- flowViz:::expr2char(channel.y)
          thisData <- Data(parent(data))
          if(!is.null(fres) && all(c(channel.x.name, channel.y.name) %in%
                                   unique(unlist(parameters(fres))))){
              l <- max(2, if(is(fres, "filterResultList"))
                       length(fres[[1]]) else length(fres))
              n <- if(is(fres, "filterResultList")) names(fres[[1]]) else
              names(fres)
              col <- rep("#00000030", l)
              names(col) <- n
              pop <- data@frEntry
              col[pop] <- "transparent"
              if(missing(par.settings))
                  par.settings <- list(gate=list(fill=col, col="#00000040"))
              xyplot(x, thisData, filter=fres, par.settings=par.settings, ...)
          }else{
              xyplot(x, thisData,  ...)
          }
      })


#' ncdfFlowSet xyplot methods
#' 
#' @aliases xyplot,formula,ncdfFlowSet-method
#' @rdname xyplot
#' @export 
setMethod("xyplot",
          signature=signature(x="formula",
                              data="ncdfFlowSet"),
          definition=function(x, data, ...)
          {
            #construct lattice object
            thisTrellisObj <- .xyplot.flowSet(x, data, type = "xyplot", ...)
            
            #subset data on channels
            channel.x.name <- thisTrellisObj[["panel.args.common"]][["channel.x.name"]]
            channel.y.name <- thisTrellisObj[["panel.args.common"]][["channel.y.name"]]
            thisData <- thisTrellisObj[["panel.args.common"]][["frames"]]
            thisData <- thisData[,c(channel.x.name,channel.y.name)]
            
            #update frames
            thisTrellisObj[["panel.args.common"]][["frames"]] <- thisData
            
            
            thisTrellisObj
          })

#' @aliases xyplot,formula,ncdfFlowList-method
#' @rdname xyplot
setMethod("xyplot",
          signature=signature(x="formula",
                              data="ncdfFlowList"),
          definition=function(x, data, ...)
          {
            selectMethod("xyplot", signature = c("formula", "ncdfFlowSet"))(x, data, ...)
          })

## ==========================================================================
## Draw gate regions as polygons on an existing plot. All graphical
## parameters will be passed on to graphics::polygon in the end, so
## these are basically extended polygon methods for gates and filters.
## Filters are only evaluated if that is needed for plotting of the
## regions.
## FIXME: Need to figure out how to make polygon a generic without masking
##        the default function



## ==========================================================================
## allow for dispatch to default polygon function in graphics
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
#setMethod("polygon", signature(x="ANY"),
#          definition=function(x, ...) graphics::polygon(x, ...))




## ==========================================================================
## for all filters
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## We only know how to add the gate boundaries if the definiton of that gate
## contains exactly two dimensions, and even then we need to guess that
## they match the plotted data, hence we warn. Supplying the names of the
## plotted channels via the "channels" argument always gets precendence.
## All downstream methods will eventually run across this method, so we only
## need to check once.
#' Drawing filter regions
#' 
#' These methods extend the basic graphics \code{\link{polygon}} methods for
#' drawing of \code{\link[flowCore:filter-class]{filter}} regions. They allow
#' for multiple dispatch, since not all
#' \code{\link[flowCore:filter-class]{filter}} types need to be evaluated for
#' plotting, but this decision should be made internally.
#' 
#' When plotting \code{\link[flowCore:flowFrame-class]{flowFrame}}s using the
#' \code{plot} method provided by \code{flowViz}, the plotted parameters are
#' recorded, which makes it possible to correctly overlay the outlines of
#' \code{\link[flowCore:filter-class]{filter}}s assuming that they are defined
#' for the respective parameters. Warnings and error will be cast for the cases
#' where the parameters are non-distinct or ambigious.
#' 
#' The flow parameters plotted can be passed on to any of the methods through
#' the optional \code{channels} argument, which always gets precedence over
#' automatically detected parameters.
#' 
#' The methods support all plotting parameters that are available for the
#' \code{base} \code{polygon} functions.
#' 
#' @name gpolygon-methods
#' @aliases gpolygon gpolygon-methods gpolygon,curv1Filter,ANY-method
#' gpolygon,curv1Filter,flowFrame-method gpolygon,curv1Filter,missing-method
#' gpolygon,curv1Filter,multipleFilterResult-method
#' gpolygon,curv2Filter,ANY-method gpolygon,curv2Filter,flowFrame-method
#' gpolygon,curv2Filter,multipleFilterResult-method
#' gpolygon,filter,missing-method gpolygon,filterResult,flowFrame-method
#' gpolygon,filterResult,ANY-method gpolygon,kmeansFilter,ANY-method
#' gpolygon,norm2Filter,ANY-method gpolygon,norm2Filter,flowFrame-method
#' gpolygon,norm2Filter,logicalFilterResult-method
#' gpolygon,polygonGate,character-method
#' gpolygon,polygonGate,filterResult-method
#' gpolygon,polygonGate,flowFrame-method gpolygon,quadGate,character-method
#' gpolygon,quadGate,filterResult-method gpolygon,quadGate,flowFrame-method
#' gpolygon,rectangleGate,character-method
#' gpolygon,rectangleGate,filterResult-method
#' gpolygon,rectangleGate,flowFrame-method
#' gpolygon,ellipsoidGate,character-method
#' gpolygon,ellipsoidGate,filterResult-method
#' gpolygon,ellipsoidGate,flowFrame-method
#' @docType methods
#' @section Methods:
#' 
#' \describe{
#' 
#' \item{x = "filter", data = "missing"}{ General method for all objects
#' inheriting from \code{\link[flowCore:filter-class]{filter}}. This is used as
#' the default when no more explicit method is found. It tries to find the
#' plotted parameters from the internal \code{flowViz.state} environment. This
#' only works if the flow data has been plotted using the \code{plot} methods
#' provided by this \code{flowViz} package. }
#' 
#' \item{x = "filterResult", data = "ANY"}{ General method for all
#' \code{\link[flowCore:filterResult-class]{filterResult}} object. This
#' basically extracts the \code{\link[flowCore:filter-class]{filter}} from the
#' \code{\link[flowCore:filterResult-class]{filterResult}} and dispatches on
#' that. }
#' 
#' \item{x = "filterResult", data = "flowFrame"}{ For some
#' \code{\link[flowCore:filter-class]{filter}} types we need the raw data to
#' re-evaluate the filter. }
#' 
#' \item{x = "curv1Filter", data = "ANY"}{ We either need a
#' \code{\link[flowCore:filterResult-class]{filterResult}} or the raw data as a
#' \code{\link[flowCore:flowFrame-class]{flowFrame}} for
#' \code{\link[flowStats:curv1Filter-class]{curv1Filter}}s. }
#' 
#' \item{x = "curv1Filter", data = "flowFrame"}{ see above }
#' 
#' \item{x = "curv1Filter", data = "missing"}{ see above }
#' 
#' \item{x = "curv1Filter", data = "multipleFilterResult"}{ see above }
#' 
#' \item{x = "curv2Filter", data = "ANY"}{ We either need a
#' \code{\link[flowCore:filterResult-class]{filterResult}} or the raw data as a
#' \code{\link[flowCore:flowFrame-class]{flowFrame}} for
#' \code{\link[flowStats:curv2Filter-class]{curv2Filter}}.}
#' 
#' \item{x = "curv2Filter", data = "flowFrame"}{ see above }
#' 
#' \item{x = "curv2Filter", data = "multipleFilterResult"}{ see above }
#' 
#' \item{x = "kmeansFilter", data = "ANY"}{ We don't know how to plot regions
#' of a \code{\link[flowCore]{kmeansFilter}}, hence we warn. }
#' 
#' \item{x = "norm2Filter", data = "ANY"}{ We either need a
#' \code{\link[flowCore:filterResult-class]{filterResult}} or the raw data as a
#' \code{\link[flowCore:flowFrame-class]{flowFrame}} for
#' \code{\link[flowStats:norm2Filter-class]{norm2Filter}}.}
#' 
#' \item{x = "norm2Filter", data = "flowFrame"}{ see above }
#' 
#' \item{x = "norm2Filter", data = "logicalFilterResult"}{ see above }
#' 
#' \item{x = "polygonGate", data = "character"}{ We can plot a
#' \code{\link[flowCore]{polygonGate}} directly from the gate definition. }
#' 
#' \item{x = "polygonGate", data = "filterResult"}{ see above }
#' 
#' \item{x = "polygonGate", data = "flowFrame"}{ see above }
#' 
#' \item{x = "quadGate", data = "character"}{ We can plot a
#' \code{\link[flowCore]{quadGate}} directly from the gate definition. }
#' 
#' \item{x = "quadGate", data = "filterResult"}{ see above }
#' 
#' \item{x = "quadGate", data = "flowFrame"}{ see above }
#' 
#' \item{x = "rectangleGate", data = "character"}{ We can plot a
#' \code{\link[flowCore]{rectangleGate}} directly from the gate definition. }
#' 
#' \item{x = "rectangleGate", data = "filterResult"}{ see above }
#' 
#' \item{x = "rectangleGate", data = "flowFrame"}{ see above }
#' 
#' \item{x = "ellipsoidGate", data = "character"}{ We can plot a
#' \code{\link[flowCore]{ellipsoidGate}} directly from the gate definition. }
#' 
#' \item{x = "ellipsoidGate", data = "filterResult"}{ see above }
#' 
#' \item{x = "ellipsoidGate", data = "flowFrame"}{ see above }
#' 
#' }
#' @author F. Hahne
#' @seealso
#' 
#' \code{\link[flowCore:filter-class]{filter}},
#' \code{\link[flowCore:flowFrame-class]{flowFrame}}, \code{\link{glines}},
#' \code{\link{gpoints}}
#' @keywords methods
#' @param x filter or filterResult or any derived filter class
#' @param data flowFrame or filterResult or character or missing or ANY
#' @param verbose logical
#' @param ... other arguments
#' @export 
setMethod("gpolygon",
          signature(x="filter", data="missing"), 
          function(x, data, verbose=TRUE, ...)
      {
          parms <- checkParameterMatch(parameters(x), verbose=verbose, ...)
          gpolygon(x, parms, ...)
      })


## Extract the filter definiton from a filterResult and pass that on
## along with it
setMethod("gpolygon",
          signature(x="filterResult", data="ANY"), 
          function(x, data, verbose=TRUE, ...)
      {
          fd <- filterDetails(x)
          filt <- fd[[length(fd)]]$filter
          if(!missing(data) && is.character(data) &&
             ! ("channels" %in% names(list(...))))
              gpolygon(filt, x, verbose=FALSE, channels=data, ...)
          else
             gpolygon(filt, x, verbose=FALSE, ...) 
      })

## We don't need the flowFrame if the filter is already evaluated, but we
## can check that the IDs are matching
setMethod("gpolygon",
          signature(x="filterResult", data="flowFrame"), 
          function(x, data, verbose=TRUE, ...){
              checkIdMatch(x=x, f=data)
              gpolygon(x, verbose=verbose, ...)
              dropWarn("flowFrame", "filterResults", verbose=verbose)
          })




## ==========================================================================
## for rectangleGates
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## Plotting parameters are specified as a character vector
setMethod("gpolygon",
          signature(x="rectangleGate", data="character"), 
          function(x, data, channels, verbose=TRUE, ...)
      {
          if(!missing(channels))
              data <- channels
          parms <- parameters(x)
          usr <- par("usr")
          if(length(parms)==1){## 1D rectangular gate (region gate)
              mt <- match(parms, data)
              if(mt==1)
                  rect(fixInf(x@min, usr[1]), usr[3], fixInf(x@max, usr[2]),
                       usr[4], ...)
              else if(mt==2)
                  rect(usr[1], fixInf(x@min, usr[3]), usr[2],
                       fixInf(x@max, usr[4]), ...)
              else
                  stop("How did you end up here????")
          }else{## 2D rectangular gate    
              bl <- x@min[data]
              tr <- x@max[data]
              rect(fixInf(bl[1], usr[1:2]), fixInf(bl[2], usr[3:4]),
                   fixInf(tr[1], usr[1:2]),  fixInf(tr[2], usr[3:4]), ...)
          }
      })

## We can ignore the filterResult, don't need it to plot the gate
setMethod("gpolygon",
          signature(x="rectangleGate", data="filterResult"), 
          function(x, data, verbose=TRUE, ...)
      {
          dropWarn("filterResult", "rectangleGates", verbose=verbose)
          gpolygon(x, verbose=verbose, ...)
      })

## we can drop the dataFrame, don't need it for rectangleGates
setMethod("gpolygon",
          signature(x="rectangleGate", data="flowFrame"), 
          function(x, data, verbose=TRUE, ...)
      {
          dropWarn("flowFrame", "rectangleGates", verbose=verbose)
          gpolygon(x, verbose=verbose, ...)
      })



## ==========================================================================
## for ellipsoidGates
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## Plotting parameters are specified as a character vector
setMethod("gpolygon",
          signature(x="ellipsoidGate", data="character"), 
          function(x, data, channels, verbose=TRUE, ...)
      {
          if(!missing(channels))
              data <- channels
          parms <- parameters(x)
	  ## We coerce to a polygon gate and plot that
          gpolygon(as(fd, "polygonGate"), verbose=verbose, ...)      
      })


## We can ignore the filterResult, don't need it to plot the gate
setMethod("gpolygon",
          signature(x="ellipsoidGate", data="filterResult"), 
          function(x, data, verbose=TRUE, ...)
      {
          dropWarn("filterResult",
                   "ellipsoidGates", verbose=verbose)
          gpolygon(x, verbose=verbose, ...)
      })


## we can drop the dataFrame, don't need it for ellipsoidGates
setMethod("gpolygon",
          signature(x="ellipsoidGate", data="flowFrame"), 
          function(x, data, verbose=TRUE, ...)
      {
          dropWarn("flowFrame", "ellipsoidGates", verbose=verbose)
          gpolygon(x, verbose=verbose, ...)
      })







## ==========================================================================
## for quadGates
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## We plot this as four individual rectangle gates
setMethod("gpolygon",
          signature(x="quadGate", data="character"), 
          function(x, data, channels, verbose=TRUE, col, ...)
      {
          if(!missing(channels))
              data <- channels
          parms <- parameters(x)
          if(missing(col)){
               col <-  col2rgb(colorRampPalette(brewer.pal(9, "Set1"))(4),
                              alpha=TRUE)
              col <- rgb(col[1,], col[2,], col[3,], 75, maxColorValue=255)
          }
          else
              col <- rep(col,4)
          v <- x@boundary[data[1]]
          h <- x@boundary[data[2]]
          mat <- matrix(c(-Inf, v, h, Inf, v, Inf, h, Inf, -Inf, v, -Inf,
                          h, v, Inf, -Inf, h), byrow=TRUE, ncol=4)              
          for(i in 1:4){
              rg <- rectangleGate(.gate=matrix(mat[i,], ncol=2,
                                  dimnames=list(c("min", "max"), data)))
              gpolygon(rg, verbose=FALSE, col=col[i], ...)
          }
      })

## We can ignore the filterResult, don't need it to plot the gate
setMethod("gpolygon",
          signature(x="quadGate", data="filterResult"), 
          function(x, data, verbose=TRUE, ...)
      {
          dropWarn("filterResult", "quadGates", verbose=verbose)
          gpolygon(x, verbose=verbose, ...)
      })

## we can drop the dataFrame, don't need it for rectangleGates
setMethod("gpolygon",
          signature(x="quadGate", data="flowFrame"), 
          function(x, data, verbose=TRUE, ...)
      {
          dropWarn("flowFrame", "quadGates", verbose=verbose)
          gpolygon(x, verbose=verbose, ...)
      })




## ==========================================================================
## for polygonGates
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## Plotting parameters are specified as a character vector
setMethod("gpolygon",
          signature(x="polygonGate", data="character"), 
          function(x, data, channels, verbose=TRUE, ...)
      {
          if(!missing(channels))
              data <- channels
          parms <- parameters(x)
          xp <- x@boundaries[,data[1]]
          yp <- x@boundaries[,data[2]]
          polygon(xp, yp, ...)
      })

## We can ignore the filterResult, don't need it to plot the gate
setMethod("gpolygon",
          signature(x="polygonGate", data="filterResult"), 
          function(x, data, verbose=TRUE, ...)
      {
          dropWarn("filterResult", "polygonGates", verbose=verbose)
          gpolygon(x, verbose=verbose, ...)
      })

## we can drop the flowFrame, don't need it for polygonGates
setMethod("gpolygon",
          signature(x="polygonGate", data="flowFrame"), 
          function(x, data, verbose=TRUE, ...)
      {
          dropWarn("flowFrame", "polygonGates", verbose=verbose)
          gpolygon(x, verbose=verbose, ...)
      })




# ==========================================================================
## for norm2Filters
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## An error if we can't evaluate the filter
setMethod("gpolygon",
          signature(x="norm2Filter", data="ANY"), 
          function(x, data, verbose=TRUE, ...) evalError("norm2Filters"))

## Filter has been evaluated and the filterResult is provided
setMethod("gpolygon",
          signature(x="norm2Filter", data="logicalFilterResult"), 
          function(x, data, verbose=TRUE, ...)
      {
          checkFres(filter=x, fres=data, verbose=verbose)
          fd <- filterDetails(data, identifier(x))
          ## create a polygonGate and plot that
          gpolygon(norm2Polygon(fd, parameters(x)), verbose=verbose, ...)
          })

## Evaluate the filter and plot the filterResult
setMethod("gpolygon",
          signature(x="norm2Filter", data="flowFrame"), 
          function(x, data, verbose=TRUE, ...)
      {
          fres <- filter(data, x)
          gpolygon(x, fres, verbose=verbose, ...)
      })




## ==========================================================================
## for kmeansFilters
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## We don't know how to plot these, hence we warn
setMethod("gpolygon",
          signature(x="kmeansFilter", data="ANY"), 
          function(x, data, verbose=TRUE, ...){
              nnWarn("kmeansFilter", verbose=verbose)
          })

## ==========================================================================
## Draw gate regions as polygons on an existing lattice plot. All graphical
## parameters will be passed on to grid.polygon in the end, so
## these are basically extended grid.polygon methods for gates and filters.
## Filters are only evaluated if that is needed for plotting of the
## regions. The methods always dispatch on filters (or filteResults since
## they inherits from filter) and on an optional additional argument
## data, which can be either a character vector, a filterResult or a
## flowFrame. The optional channels argument can be used to pass along
## the plotting parameters, and it takes precendence over everything else.
##
## Most of the methods will just call the next applicable method, the real
## workhorses are signature(x="rectangleGate", data="character") and
## signature(x="polygonGate", data="character") since in the end everything
## boils down to rectangles or polygons.
##
## Population names can be added to the plot if argument 'names' is true.
## Eventually we may want to fix the size and location of the names tags,
## but for now it is always using the gate centroids.



## ==========================================================================
## for all filters
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## We only know how to add the gate boundaries if the definiton of that gate
## contains exactly two dimensions, and even then we need to guess that
## they match the plotted data, hence we warn unless the plotted parameters
## are explicitely provided by the channels argument.
#' Drawing filter regions
#' 
#' These methods extend the lattice \code{\link[lattice:llines]{lpolygon}}
#' methods for drawing of \code{\link[flowCore:filter-class]{filter}} regions.
#' They allow for multiple dispatch, since not all
#' \code{\link[flowCore:filter-class]{filter}} types need to be evaluated for
#' plotting, but this decision should be made internally.
#' 
#' When plotting \code{\link[flowCore:flowFrame-class]{flowFrames}} using the
#' any of the lattice-type \code{plot} method provided by \code{flowViz}, the
#' plotted parameters are recorded, which makes it possible to correctly
#' overlay the outlines of \code{\link[flowCore:filter-class]{filter}} assuming
#' that they are defined for the respective parameters. Warnings and error will
#' be cast for the cases where the parameters are non-distinct or ambigious.
#' These methods are meant to be used within lattice panel functions and are
#' probably not of much use outside of those.
#' 
#' @name glpolygon-methods
#' @aliases glpolygon glpolygon-methods glpolygon,curv1Filter,ANY-method
#' glpolygon,complementFilter,ANY-method glpolygon,curv1Filter,flowFrame-method
#' glpolygon,curv1Filter,missing-method
#' glpolygon,curv1Filter,multipleFilterResult-method
#' glpolygon,curv2Filter,ANY-method glpolygon,curv2Filter,flowFrame-method
#' glpolygon,curv2Filter,multipleFilterResult-method
#' glpolygon,filter,missing-method glpolygon,filterResult,flowFrame-method
#' glpolygon,filterResult,missing-method glpolygon,filterResult,ANY-method
#' glpolygon,kmeansFilter,ANY-method glpolygon,norm2Filter,ANY-method
#' glpolygon,norm2Filter,flowFrame-method
#' glpolygon,norm2Filter,logicalFilterResult-method
#' glpolygon,polygonGate,character-method
#' glpolygon,polygonGate,filterResult-method
#' glpolygon,polygonGate,flowFrame-method glpolygon,quadGate,character-method
#' glpolygon,quadGate,filterResult-method glpolygon,quadGate,flowFrame-method
#' glpolygon,rectangleGate,character-method
#' glpolygon,rectangleGate,filterResult-method
#' glpolygon,rectangleGate,flowFrame-method
#' glpolygon,ellipsoidGate,character-method
#' glpolygon,ellipsoidGate,filterResult-method
#' glpolygon,ellipsoidGate,flowFrame-method glpolygon,subsetFilter,ANY-method
#' @docType methods
#' @return The methods will return the outlines of the gate region as polygon
#' vertices.
#' @section Methods:
#' 
#' \describe{
#' 
#' \item{x = "filter", data = "missing"}{ General method for all objects
#' inheriting from \code{\link[flowCore:filter-class]{filter}}. This is used as
#' the default when no more explicit method is found. It tries to find the
#' plotted parameters from the internal \code{flowViz.state} environment. This
#' only works if the flow data has been plotted using the \code{plot} methods
#' provided by this \code{flowViz} package. }
#' 
#' \item{x = "filterResult", data = "missing"}{ General method for all
#' \code{\link[flowCore:filterResult-class]{filterResult}} object. This
#' basically extracts the \code{\link[flowCore:filter-class]{filter}} from the
#' \code{\link[flowCore:filterResult-class]{filterResult}} and dispatches on
#' that. }
#' 
#' \item{x = "filterResult", data = "flowFrame"}{ For some
#' \code{\link[flowCore:filter-class]{filter}} types we need the raw data to
#' re-evaluate the filter. }
#' 
#' \item{x = "curv1Filter", data = "ANY"}{ We either need a
#' \code{\link[flowCore:filterResult-class]{filterResult}} or the raw data as a
#' \code{\link[flowCore:flowFrame-class]{flowFrame}} for
#' \code{\link[flowStats:curv1Filter-class]{curv1Filter}}s. }
#' 
#' \item{x = "curv1Filter", data = "flowFrame"}{ see above }
#' 
#' \item{x = "curv1Filter", data = "missing"}{ see above }
#' 
#' \item{x = "curv1Filter", data = "multipleFilterResult"}{ see above }
#' 
#' \item{x = "curv2Filter", data = "ANY"}{ We either need a
#' \code{\link[flowCore:filterResult-class]{filterResult}} or the raw data as a
#' \code{\link[flowCore:flowFrame-class]{flowFrame}} for
#' \code{\link[flowStats:curv2Filter-class]{curv2Filter}}.}
#' 
#' \item{x = "curv2Filter", data = "flowFrame"}{ see above }
#' 
#' \item{x = "curv2Filter", data = "multipleFilterResult"}{ see above }
#' 
#' \item{x = "kmeansFilter", data = "ANY"}{ We don't know how to plot regions
#' of a \code{\link[flowCore:kmeansFilter]{kmeansFilter}}, hence we warn. }
#' 
#' \item{x = "norm2Filter", data = "ANY"}{ We either need a
#' \code{\link[flowCore:filterResult-class]{filterResult}} or the raw data as a
#' \code{\link[flowCore:flowFrame-class]{flowFrame}} for
#' \code{\link[flowStats:norm2Filter-class]{norm2Filter}}.}
#' 
#' \item{x = "norm2Filter", data = "flowFrame"}{ see above }
#' 
#' \item{x = "norm2Filter", data = "logicalFilterResult"}{ see above }
#' 
#' \item{x = "polygonGate", data = "character"}{ We can plot a
#' \code{\link[flowCore]{polygonGate}} directly from the gate definition. }
#' 
#' \item{x = "polygonGate", data = "filterResult"}{ see above }
#' 
#' \item{x = "polygonGate", data = "flowFrame"}{ see above }
#' 
#' \item{x = "quadGate", data = "character"}{ We can plot a
#' \code{\link[flowCore]{quadGate}} directly from the gate definition. }
#' 
#' \item{x = "quadGate", data = "filterResult"}{ see above }
#' 
#' \item{x = "quadGate", data = "flowFrame"}{ see above }
#' 
#' \item{x = "rectangleGate", data = "character"}{ We can plot a
#' \code{\link[flowCore]{rectangleGate}} directly from the gate definition. }
#' 
#' \item{x = "rectangleGate", data = "filterResult"}{ see above }
#' 
#' \item{x = "rectangleGate", data = "flowFrame"}{ see above }
#' 
#' \item{x = "ellipsoidGate", data = "character"}{ We can plot a
#' \code{\link[flowCore]{rectangleGate}} directly from the gate definition. }
#' 
#' \item{x = "ellipsoidGate", data = "filterResult"}{ see above }
#' 
#' \item{x = "ellipsoidGate", data = "flowFrame"}{ see above }
#' 
#' }
#' @author F. Hahne
#' @seealso
#' 
#' \code{\link[flowCore:filter-class]{filter}},
#' \code{\link[flowCore:flowFrame-class]{flowFrame}},
#' \code{\link[flowViz:glpoints-methods]{glpoints}}
#' @keywords methods
#' @export 
#' @param x filter or filterResult or any derived filter class
#' @param data flowFrame or filterResult or character or missing or ANY
#' @param verbose logical
#' @param gpar a list of graphical parameters. see 'help(flowViz.par.get)' for details.
#' @param strict logical
#' @param ... other arguments
setMethod("glpolygon",
          signature(x="filter", data="missing"), 
          function(x, data, verbose=TRUE, gpar=flowViz.par.get(),
                   strict=TRUE, ...)
      {
          parms <- checkParameterMatch(parameters(x), verbose=verbose,
                                       strict=strict,...)
          if(!all(is.na(parms)))
              glpolygon(x=x, data=parms, gpar=gpar, verbose=FALSE,strict=strict, ...)
      })


## Extract the filter definiton from a filterResult and pass that on
## along with it. We decide later if we really need it or not.
setMethod("glpolygon",
          signature(x="filterResult", data="ANY"), 
          definition=function(x, data, verbose=TRUE,
          gpar=flowViz.par.get(), ...)
      {
          fd <- filterDetails(x)
          filt <- fd[[length(fd)]]$filter
          if(!missing(data) && is.character(data) &&
             ! ("channels" %in% names(list(...))))
              glpolygon(filt, x, verbose=FALSE, channels=data,
                        gpar=gpar, ...)
          else
              glpolygon(filt, x, verbose=FALSE, gpar=gpar, ...) 
      })


## We don't need the flowFrame if the filter is already evaluated, but we
## can check that the IDs are matching before dropping it.
setMethod("glpolygon",
          signature(x="filterResult", data="flowFrame"), 
          definition=function(x, data, verbose=TRUE,
          gpar=flowViz.par.get(), ...){
              checkIdMatch(x=x, f=data)
              dropWarn("flowFrame", "filterResults", verbose=verbose)
              glpolygon(x=x, verbose=verbose, gpar=gpar, ...)
          })




## ==========================================================================
## for rectangleGates
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## Plotting parameters are specified as a character vector. If channels is
## provided this takes precedence.
setMethod("glpolygon",
          signature(x="rectangleGate", data="character"), 
          function(x, data, channels, verbose=TRUE,
                   gpar=flowViz.par.get(), plot=TRUE, names=FALSE,xlim,ylim, ...)
      {
          if(!missing(channels))
              data <- channels
          parms <- parameters(x)
#          browser()
          if(plot){
              ## 1D rectangular gate (region gate). We cheat those by drawing a
              ## rectangle that is slightly bigger than the drawing limits in the
              ## missing channel and let clipping work for us.
              if(length(parms)==1){
                  mt <- match(parms, data)
                  if(mt==1){
                      glrect(fixInf(x@min, xlim), ylim[1]-diff(ylim)*10,
                             fixInf(x@max, xlim), ylim[2]+diff(ylim)*10,
                             gp=gpar$gate, ...)
                  }   
                  else if(mt==2){
                      glrect(xlim[1]-diff(xlim)*10, fixInf(x@min, ylim),
                             xlim[2]+diff(xlim)*10, fixInf(x@max, ylim),
                             gp=gpar$gate, ...)
                  }else
                  stop("How did you end up here????")
              }else{## 2D rectangular gate   
                  bl <- x@min[data]
                  tr <- x@max[data]
                  glrect(fixInf(bl[1], xlim), fixInf(bl[2], ylim),
                         fixInf(tr[1], xlim),  fixInf(tr[2], ylim),
                         gp=gpar$gate, ...)
              }
              
          }
		  ## add names if necessary
		  addName(x, names, data, gp = gpar$gate.text,xlim=xlim,ylim=ylim,...)
          res <- rbind(x@min[data], x@max[data])
          res <- res[,!apply(res, 2, function(z) all(is.na(z))), drop=FALSE]
          return(invisible(list(res)))
      })

## We can ignore the filterResult, don't need it to plot the gate.
setMethod("glpolygon",
          signature(x="rectangleGate", data="filterResult"), 
          function(x, data, verbose=TRUE, gpar=flowViz.par.get(), ...)
      {
          dropWarn("filterResult", "rectangleGates", verbose=verbose)
          glpolygon(x=x, verbose=verbose, gpar=gpar, ...)
      })

## We can drop the flowFrame, don't need it for rectangleGates.
setMethod("glpolygon",
          signature(x="rectangleGate", data="flowFrame"), 
          function(x, data, verbose=TRUE, gpar=flowViz.par.get(), ...)
      {
          dropWarn("flowFrame", "rectangleGates", verbose=verbose)
          glpolygon(x=x, verbose=verbose, gpar=gpar, ...)
      })




## ==========================================================================
## for ellipsoidGates
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## Plotting parameters are specified as a character vector
setMethod("glpolygon",
          signature(x="ellipsoidGate", data="character"), 
          function(x, data, channels, verbose=TRUE, gpar=flowViz.par.get(),
                   plot=TRUE, names=FALSE, ...)
      {
          if(!missing(channels))
              data <- channels
          parms <- parameters(x)
	  ## We coerce to a polygon gate and plot that
          res <- as(x, "polygonGate")
          glpolygon(res, verbose=verbose, gpar=gpar, plot=plot, ...)
          addName(x, names, data, gp = gpar$gate.text,...)
          return(invisible(res@boundaries))
      })


## We can ignore the filterResult, don't need it to plot the gate.
setMethod("glpolygon",
          signature(x="ellipsoidGate", data="filterResult"), 
          function(x, data, verbose=TRUE, gpar=flowViz.par.get(), ...)
      {
          dropWarn("filterResult", "ellipsoidGates", verbose=verbose)
          glpolygon(x=x, verbose=verbose, gpar=gpar, ...)
      })

## We can drop the flowFrame, don't need it for rectangleGates.
setMethod("glpolygon",
          signature(x="ellipsoidGate", data="flowFrame"), 
          function(x, data, verbose=TRUE, gpar=flowViz.par.get(), ...)
      {
          dropWarn("flowFrame", "ellipsoidGates", verbose=verbose)
          glpolygon(x=x, verbose=verbose, gpar=gpar, ...)
      })






## ==========================================================================
## for quadGates
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## We plot this as four individual rectangle gates. If channels is
## provided this takes precedence.
setMethod("glpolygon",
          signature(x="quadGate", data="character"), 
          function(x, data, channels, verbose=TRUE,
                   gpar=flowViz.par.get(), names=NULL,abs=FALSE,pos=NULL,...)
      {
#		  browser()
          if(!missing(channels))
              data <- channels
          v <- x@boundary[data[1]]
          h <- x@boundary[data[2]]
          mat <- matrix(c(-Inf, v, h, Inf, v, Inf, h, Inf, -Inf, v, -Inf,
                          h, v, Inf, -Inf, h), byrow=TRUE, ncol=4)
          ## we want to be able to use different colors for each population
          fill <- rep(gpar$gate$fill, 4)
          col <- rep(gpar$gate$col, 4)
          col <- col[c(2,1,3,4)]
          fill <- fill[c(2,1,3,4)]
          res <- vector(4, mode="list")
		  #quadrant iteration in this loop goes by :x-y+,x+y+,x-y-,x+y-
		  #	yet populations generated from quadGate is:++,-+,+-,--
		  #so we need to re-order the names character
		  if(length(names)==1)
			  names<-rep(names,4)
		  names<-names[c(2,1,4,3)]
		  # fix the location of gate labels at four corners for quadGate
		  
		  poslist<-vector(mode="list",4)
		  poslist[[1]]<-c(0.15,0.9)
		  poslist[[2]]<-c(0.9,0.9)
		  poslist[[3]]<-c(0.15,0.1)
		  poslist[[4]]<-c(0.9,0.1)
          for(i in 1:4){
              gpar$gate$col <- col[i]
              gpar$gate$fill <- fill[i]
              rg <- rectangleGate(.gate=matrix(mat[i,], ncol=2,
                                  dimnames=list(c("min", "max"),
                                  data)))
		  
              res[[i]] <- glpolygon(x=rg, data=data, verbose=FALSE,
                                    gpar=gpar, channels=data,names=names[i],abs=abs,pos=poslist[[i]],...)[[1]]
										
          }
          return(invisible(res))
      })

## We can ignore the filterResult, don't need it to plot the gate.
setMethod("glpolygon",
          signature(x="quadGate", data="filterResult"), 
          function(x, data, verbose=TRUE, gpar=flowViz.par.get(),
                   names=FALSE, ...)
      {
#		  browser()
          dropWarn("filterResult", "quadGates", verbose=verbose)
#          glpolygon(x=x, verbose=verbose, gpar=gpar,
#                    names=ifelse(names, names(x), FALSE), ...)  

			glpolygon(x=x, verbose=verbose, gpar=gpar,
                    names=names, ...)
      })

## We can drop the dataFrame, don't need it for rectangleGates.
setMethod("glpolygon",
          signature(x="quadGate", data="flowFrame"), 
          function(x, data, verbose=TRUE, gpar=flowViz.par.get(),
                   names=FALSE, ...)
      {
          dropWarn("flowFrame", "quadGates", verbose=verbose)
          res <- glpolygon(x=x, verbose=verbose, gpar=gpar,
                    names=FALSE, ...)
          addName(x, names, data=data, gp = gpar$gate.text,...)
          return(invisible(res))
      })




## ==========================================================================
## for polygonGates
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## Plotting parameters are specified as a character vector. If channels is
## provided this takes precedence.
setMethod("glpolygon",
          signature(x="polygonGate", data="character"), 
          function(x, data, channels, verbose=TRUE,
                   gpar=flowViz.par.get(), plot=TRUE, names=FALSE,
                   inverse=FALSE,xlim,ylim, ...)
      {
		  
          if(!missing(channels))
              data <- channels
          xp <- x@boundaries[,data[1]]
          yp <- x@boundaries[,data[2]]
#          class(gpar) <- "gpar"
          if(plot){
              if(inverse){
                  mx <- which.min(yp)
                  xpi <- rep(xp, 2)
                  ypi <- rep(yp, 2)
                  nextDiff <- min(which(xpi[-(1:mx)] != xpi[mx]))+mx
                  if(xpi[nextDiff] < xp[mx]){
                      xp <- rev(xp)
                      yp <- rev(yp)
                      mx <- which.min(yp)
                  }
                  
                  xoff <- diff(xlim)
                  yoff <- diff(ylim)
                  boundingBox <- cbind(c(rep(xlim-xoff, 2),
                                         rep(xlim+xoff, 2)),
                                       c(ylim-yoff, ylim+yoff,
                                         ylim+yoff, ylim-yoff))
                  xpi <- c(rep(boundingBox[1,1], 2), xp, xp[1],
                          boundingBox[,1], boundingBox[1,1])
                  ypi <- c(boundingBox[1,2], yp[mx], yp, yp[1],
                          yp[mx], boundingBox[-1,2],
                             boundingBox[1,2])
                  gpari <- gpar$gate
                  gpari$col <- "transparent"
                  glpoly(xpi, ypi, gp=gpari)
                  gpari$col <- gpar$gate$col
                  gpari$fill <- "transparent"
                  glpoly(xp, yp, gp=gpari)
              }else{
                  glpoly(xp, yp, gp=gpar$gate)
              }
          }
          addName(x, names, data, gp = gpar$gate.text,xlim=xlim,ylim=ylim,...)
          res <- cbind(xp,yp)
          res <- res[,!apply(res, 2, function(z) all(is.na(z))), drop=FALSE]
          return(invisible(list(res)))
      })

## We can ignore the filterResult, don't need it to plot the gate.
setMethod("glpolygon",
          signature(x="polygonGate", data="filterResult"), 
          function(x, data, verbose=TRUE, gpar=flowViz.par.get(), ...)
      {
          dropWarn("filterResult", "polygonGates", verbose=verbose)
          glpolygon(x=x, verbose=verbose, gpar=gpar, ...)
      })

## we can drop the flowFrame, don't need it for polygonGates.
setMethod("glpolygon",
          signature(x="polygonGate", data="flowFrame"), 
          function(x, data, verbose=TRUE, gpar=flowViz.par.get(), ...)
      {
          dropWarn("flowFrame", "polygonGates", verbose=verbose)
          glpolygon(x=x, verbose=verbose, gpar=gpar, ...)
      })




# ==========================================================================
## for norm2Filters
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## An error if we can't evaluate the filter.
setMethod("glpolygon",
          signature(x="norm2Filter", data="ANY"), 
          function(x, data, ...) evalError("norm2Filters"))

## Filter has been evaluated and the filterResult is provided. We convert
## this into a polygon gate and plot that.
setMethod("glpolygon",
          signature(x="norm2Filter", data="logicalFilterResult"), 
          function(x, data, verbose=TRUE, gpar=flowViz.par.get(),
                   names=FALSE, ...){
              checkFres(filter=x, fres=data, verbose=verbose)
              fd <- filterDetails(data, identifier(x))
              np <- norm2Polygon(fd, parameters(x))
              identifier(np) <- identifier(x)
              glpolygon(x=np, verbose=FALSE, gpar=gpar, names=names, ...)
          })

## Evaluate the filter and pass on to the filterResult method.
setMethod("glpolygon",
          signature(x="norm2Filter", data="flowFrame"), 
          function(x, data, verbose=TRUE, gpar=flowViz.par.get(), ...){
              fres <- filter(data, x)
               glpolygon(x=x, data=fres, verbose=verbose, gpar=gpar, ...)
          })





## ==========================================================================
## for kmeansFilters
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## We don't know how to plot these, hence we warn
setMethod("glpolygon",
          signature(x="kmeansFilter", data="ANY"), 
          function(x, data, verbose=TRUE, ...)
          nnWarn("kmeansFilter", verbose))



## ==========================================================================
## for complementFilter
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## We have to do this on the level of polygons or rectangles, so here we
## only set a flag and pass on the basic filter.
## FIXME: This doesn't work for multi-polygon filters so far.
setMethod("glpolygon",
          signature(x="complementFilter", data="ANY"), 
          function(x, data, verbose=TRUE, inverse=FALSE, ...)
      {
          glpolygon(x@filters[[1]], data, verbose=verbose,
                    inverse=!inverse, ...)
      })




# ==========================================================================
## for subsetFilter
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## For now we just plot the top-level filter.
## FIXME: We may want to be able to plot all filters
setMethod("glpolygon",
          signature(x="subsetFilter", data="ANY"), 
          function(x, data, verbose=TRUE, inverse=FALSE, ...)
      {
          glpolygon(x@filters[[1]], data, verbose=verbose, ...)
      })

## Helper functions that will be needed for all of the gate plotting functions
## These are mostly functions that do some sanity checking.
#require(grDevices)  # RColorBrewer assumes 'rgb' on the search path

## Store state info in this internal environment
flowViz.state <- new.env(hash = FALSE)


# based on colorRampPalette
# add the optional alpha control
#' @param alpha \code{numeric} range from 0 to 1
#' @importFrom grDevices rgb colorRamp colorRampPalette col2rgb
#' @importFrom RColorBrewer brewer.pal
.colRmpPlt <- function (alpha = 1, ...) 
{
  
  colors <- rev(brewer.pal(11, "Spectral"))
  ramp <- colorRamp(colors, ...)
  function(n) {
    x <- ramp(seq.int(0, 1, length.out = n))
    rgb(x[, 1L], x[, 2L], x[, 3L], maxColorValue = 255, alpha = alpha * 255)
  }
}

## FIXME: We hardcode a lattice theme for the X11xcairo device for now which will be
## used for all other devices as well. Later this should follow the example from the
## lattice package, i.e., real device-specific themes that are set up once the device
## is first called.
.flowViz.par.init <- function(lattice.par){
  gate.par <- list(gate=list(alpha=1,
                              cex=NULL,
                              pch=NULL,
                              col="#9E0142"#"red",
                              ,fill="transparent",
                              lwd=1,
                              lty="solid"),
                        gate.text=list(font=1,
                                        col="#000000",
                                        alpha=1,#0.4,
                                        cex=0.8,#1.2,
                                        lineheight=0.8#1.2
                                        ,background=list(fill="white"
                                                        ,col="transparent"
                                                        ,alpha=1
                                                    )
                                    ),
                        overlay.symbol = list(alpha = 0.5
                                              ,bg.alpha = 0.3
                                              ,col = "transparent"
                                              ,fill = "red"
                                              ,cex = 0.5
                                              , pch = 19
                                          ),                 
                        flow.symbol=list(alpha=1,
                                            cex = 0.1,
                                            pch = 19,
                                            col="black",
                                            fill="transparent"),
                        gate.density=list(alpha=1,
                                          fill="#FFFFFFB3",
                                          col="black",
                                          lwd=1,
                                          lty="dotted")
                                      
                        ,argcolramp = .colRmpPlt()
                    )
  flowViz.state[["lattice.theme"]] <- list(X11cairo= c(gate.par, lattice.par))
}
# can't do it within Namespace events hooks (e.g. .onLoad) 
# since it needs to load namespace (e.g. 'rgb' through 'brewer.pal' call
# other than base namespace
#' @importFrom latticeExtra ecdfplot ggplot2like axis.grid
.flowViz.par.init(lattice.par = ggplot2like())

## Get and set graphical defaults for plots in flowViz. To a great extend, this uses
## the trellis.par.get and trellis.par.set infrastructure defined in the lattice package.
## Currently it is not possible to directly register additional setting there, instead
## we provide our own wrappers which look for available defaults in lattice first and
## fetch or set additional defaults within the internal flowViz environment if they can't
## be found in the lattice defaults.


#' Query and set session-wide graphical parameter defaults.
#' 
#' 
#' \code{flowViz.par.get} is the equivalent to
#' \code{\link[lattice]{trellis.par.get}}. It queries the session wide defaults
#' for all \code{lattice} and \code{flowViz} graphical parameters.
#' 
#' \code{flowViz.par.set} is the equivalent to
#' \code{\link[lattice:trellis.par.get]{trellis.par.set}}. It sets the same set
#' of graphical parameters, either in the \code{flowViz} package or directly in
#' \code{lattice}.
#' 
#' 
#' Getting and setting graphical parameters in \code{flowViz} follows exactly
#' the mechanism of the \code{lattice} package. For all purpose and intentions,
#' \code{flowViz.par.get} and \code{flowViz.par.get} can be viewed as wrappers
#' around their \code{lattice} counterparts
#' \code{\link[lattice]{trellis.par.get}} and
#' \code{\link[lattice:trellis.par.get]{trellis.par.set}} and you should
#' consult their documentation for further details.
#' 
#' We introduce four new categories of graphical parameters that are relevant
#' for \code{flowViz} plots:
#' 
#' \describe{ \item{gate}{Controls the appearance of gate boundaries in
#' \code{xyplots} (if \code{smooth=TRUE}) or of the points within a gate region
#' (\code{smooth=FALSE}).  Available parameters are \code{col},
#' \code{cex},\code{pch},\code{alpha},\code{lwd},\code{lty} and \code{fill}. }
#' 
#' \item{gate.density}{Controls the appearance of gate boundaries in
#' \code{densityplots}.  Available parameters are \code{col},
#' \code{alpha},\code{lwd},\code{lty} and \code{fill}. }
#' 
#' \item{flow.symbol}{Controls the appearance of 'regular' points in a
#' \code{flowViz} plot.  Available parameters are \code{col},
#' \code{cex},\code{pch},\code{alpha} and \code{fill}. }
#' 
#' \item{gate.text}{Controls the appearance of the text used for gate names.
#' Available parameters are \code{col}, \code{cex},\code{font},\code{alpha} and
#' \code{lineheight}. } }
#' 
#' @aliases flowViz.par.get flowViz.par.set
#' @param name The name of a parameter category to set.
#' @param value A named list of values to set for category \code{name} or a
#' list of such lists if \code{name} is missing.
#' @param \dots Further arguments that get passed on.
#' @param theme The theme to set. See
#' \code{\link[lattice:trellis.par.get]{trellis.par.set}} for details.
#' @param warn This gets passed on directly to \code{trellis.par.set}.
#' @param strict This gets passed on directly to \code{trellis.par.set}.
#' @param reset \code{logical} scalar. When TRUE, drop the entire list of old
#' graphical parameters and reset it with the supplied one. Default is FALSE,
#' which updates the existing parameters.
#' @return
#' 
#' \code{flowViz.par.get} returns a list of graphical parameter defaults, if
#' \code{name} is not empty, only for this particular category. For an empty
#' \code{name} argument, the function returns all parameter defaults, including
#' the ones specified in the lattice package.
#' 
#' \code{flowViz.par.set} is called for its side-effects of setting default
#' parameters.
#' @note
#' 
#' Because parameter settings in \code{lattice} are device-dependent,
#' \code{flowViz.par.get} will open a (default) device none is open at the time
#' of the query.
#' @author F. Hahne
#' @seealso
#' 
#' \code{\link[lattice]{trellis.par.get}} and
#' \code{\link[lattice:trellis.par.get]{trellis.par.set}}
#' @references Deepayan Sarker, \emph{Lattice, Multivariate Data Visualization
#' with R}, Springer, New York, 2008
#' @examples
#' 
#' 
#' ## Return all available parameters, including lattice ones
#' flowViz.par.get()
#' 
#' ## Set the font for gate names 
#' flowViz.par.set("gate.text", list(font=2))
#' 
#' ## Query only the gate.text category
#' flowViz.par.get("gate.text")
#' 
#' ## Set a lattice parameter
#' plot.symbol <- trellis.par.get("plot.symbol")
#' flowViz.par.set("plot.symbol", list(col="red"))
#' trellis.par.get("plot.symbol")
#' 
#' ## undo all settings
#' flowViz.par.set(list(plot.symbol=plot.symbol, gate.text=list(font=1)))
#' library(flowCore)
#' data(GvHD)
#' fs <- GvHD[1:2]
#' 
#' # using default ggplot2like theme
#' densityplot(~`FSC-H`, fs)
#' xyplot(`SSC-H`~`FSC-H`, fs, smooth = FALSE)
#'             
#' # reset it with default lattice theme            
#' flowViz.par.set(theme =  trellis.par.get(), reset = TRUE)
#' densityplot(~`FSC-H`, fs)
#' xyplot(`SSC-H`~`FSC-H`, fs, smooth = FALSE)
#' 
#' 
#' @export 
#' @importFrom utils modifyList
flowViz.par.get <- function (name = NULL) 
{
  ## FIXME: We want this to be device-specific, needs to be set up in the same
  ## way as it is done in lattice.
  lPars <- flowViz.state[["lattice.theme"]]$X11cairo
  if (is.null(name)) 
    lPars
  else if (name %in% names(lPars)) 
    lPars[[name]]
  else NULL
}

#' @export
#' @rdname flowViz.par.get
flowViz.par.set <- function (name, value, ..., theme, warn = TRUE, strict = FALSE, reset = FALSE) 
{
  if (missing(theme)) {
    if (!missing(value)) {
      theme <- list(value)
      names(theme) <- name
    }
    else if (!missing(name) && is.list(name)) {
      theme <- name
    }
    else theme <- list(...)
  }
  else {
    if (is.character(theme)) 
      theme <- get(theme)
    if (is.function(theme)) 
      theme <- theme()
    if (!is.list(theme)) {
      warning("Invalid 'theme' specified")
      theme <- NULL
    }
  }
  
  #reset by dropping all the existing lattic par
  if(reset){
    .flowViz.par.init(lattice.par = theme)  
  }else{
    fvPars <- names(theme) %in% names(flowViz.state[["lattice.theme"]]$X11cairo)
    
    if (strict)
      flowViz.state[["lattice.theme"]]$X11cairo[names(theme[fvPars])] <- theme[fvPars]  
    else flowViz.state[["lattice.theme"]]$X11cairo <-
          lattice:::updateList(flowViz.state[["lattice.theme"]]$X11cairo, theme[fvPars])
    
  }
  invisible()
}




## return the state information from the internal environment
state <- function(x) flowViz.state[[x]]

plotType <- function(type, parms){
	return (list(plotted= TRUE
				,type=type
				,parameters= parms)
			)
}




## We only know how to add the gate boundaries if the definiton of that gate
## contains exactly two dimensions, and even then we need to guess that
## they match the plotted data, hence we warn
fmatchWarn <- function(parms, verbose=TRUE)
{
    if(verbose)
        warning("The filter is defined for parameters '",
                paste(parms, collapse="' and '"), "'.\nPlease make sure ",
                "that they match the plotting parameters.", call.=FALSE)
}

checkParameterMatch <- function(parms,channels, verbose=TRUE, strict=TRUE,ptList, ...)
{
	parameters<-ptList$parameters
	plotted<-ptList$plotted
    if(missing(channels)){
        if(plotted && length(parameters==2)){
            sparms <- parameters
            err <-   function(strict=TRUE){
                if(strict)
                    stop("The flow parameters used in the last plot don't match ",
                         "the\nparameters provided by the filter or via the ",
                         "'channels' argument.\n   Plotted: ",
                         paste(sparms, collapse=" vs. "), "\n   Provided: ",
                         paste(parms, collapse=", "),
                         "\nPlease check or redraw the plot.", call.=FALSE)
            }
            mt <- sparms %in% parms
            if(length(parms)<2){
                if(!parms %in% sparms){
                    err(strict)
                    return(NA)
                }
            }else if(!all(mt)){
                err(strict)
                return(NA)
            }
            return(sparms)
        }else{
            fmatchWarn(parms, verbose=verbose)
            return(parms)
        }
    }else{
        parms <- channels
        if(length(parms)!=2 && strict)
            stop("The filter definition contains the following parameters:\n",
                 paste(parms, collapse=", "), "\nDon't know how to match to",
                 " the plotted data.\nPlease specify plotting parameters as ",
                 "an additional argument.", call.=FALSE)
        return(parms)
    }
}


## We check that the IDs of a flowFrame and a filter are matching
checkIdMatch <- function(x, f)
{
    if(!identifier(f) %in% x@frameId)
        stop("The filter was evaluated on flowFrame(s)\n'",
             paste(x@frameId, collapse="', '", sep=),
             "'\n  but the frame provided is '",
             identifier(f), "'.", call.=FALSE)
}


## Warning when we ignore an argument that is not needed
dropWarn <- function(type, gate, verbose=FALSE)
{
    if(verbose)
        warning("No '", type, "' needed to plot '", gate,
                "'.\nArgument is ignored.", call.=FALSE)
}


## Cast error that we need the data to evaluate the filter
evalError <- function(type)
{
    stop("'", type, "' need to be evaluated for plotting.\n",
         "Either provide a 'flowFrame' or an appropriate ",
         "'filterResult' \nas second argument.", call.=FALSE)
}

## check that a filterResult and a filter actually match
checkFres <- function(filter, fres, verbose=TRUE)
{
    fd <- filterDetails(fres, identifier(filter))
    if(!identical(identifier(filter), identifier(fres)))
        stop("The 'filterResult' and the '", class(filter),
             "' don't match.", call.=FALSE)
}

## We don't know how to draw 'type' filters, hence we warn
nnWarn <- function(type, verbose=TRUE)
{
    if(verbose)
        warning("Don't know how to plot outline for a '", type,
                "'.", call.=FALSE)
    return(invisible(NULL))
}

## replace infinite values by something useful
fixInf <- function(x, replacement)
{
#	browser()
    for(i in seq_along(x)){
        y <- x[i]
        if(is.infinite(y) && y<0)
            x[i] <- replacement[1]-diff(replacement)*10
        else if(is.infinite(y) && y>0)
            x[i] <- replacement[2]+diff(replacement)*10
    }
    return(x)
}
##fixInf returned the exagerated bounaries which does not give good esitmation of label position for gates
##so we add another version here specifically for addName methods
fixBound_addName <- function(x, range)
{
#	browser()
	for(i in seq_along(x)){
		y <- x[i]
		if(y<range[1])
			x[i] <- range[1]
		else if(y>range[2])
			x[i] <- range[2]
	}
	return(x)
}

## convert a norm2Filter into a polygonGate
norm2Polygon <- function(fd, parms=fd$parameters)
{
    ## get the ellipse lines
    norm.center <- fd$center[parms]
    norm.cov <- fd$cov[parms, parms]
    norm.radius <- fd$radius
    chol.cov <- t(chol(norm.cov))
    t <- seq(0, 2 * base::pi, length = 50)
    ans <- norm.center +
        (chol.cov %*% rbind(x = norm.radius * cos(t),
                            y = norm.radius * sin(t)))
    ans <- as.data.frame(t(ans))
    names(ans) <- parms
    ## create a polygonGate
    polygonGate(.gate=ans)
}

## convert a norm2Gate into an ellipsoidGate
norm2Ell <- function(fd, parms=fd$parameters)
{
    ellipsoidGate(mean=fd$center[parms],
                  cov=fd$cov[parms, parms],
                  distance=fd$radius)
}

## convert an ellipseoidalFilter into a polygonGate
ell2Polygon <- function(fd, parms=parameters(fd))
{
  .Deprecated("as")
    ## get the ellipse lines
    center <- fd@mean[parms]
    if(is.null(rownames(fd@cov)))
      rownames(fd@cov) <- colnames(fd@cov)
    cov <- fd@cov[parms, parms]
    radius <- fd@distance
    chol.cov <- t(chol(cov))
    t <- seq(0, 2 * base::pi, length = 50)
    ans <- center +
        (chol.cov %*% rbind(x = radius * cos(t),
                            y = radius * sin(t)))
    ans <- as.data.frame(t(ans))
    names(ans) <- parms
    ## create a polygonGate
    polygonGate(.gate=ans)
}


## Helper function that calls panel.x in a more user-fiendly way
glrect <- function (xleft, ybottom, xright, ytop, ..., gp) 
{
    panel.rect(xleft, ybottom,  xright, ytop, col=gp$fill,
               border=gp$col, lty=gp$lty, lwd=gp$lwd,
               alpha=gp$alpha, ...)
}

gltext <- function (x, y, labels, ..., gp) 
{   
#    browser()
#    gp_txt <- gp
#    gp_txt$background <- NULL
#    txtObj <- textGrob(label = labels, gp = gpar(gp_txt), default.units = "native")
    cex <- gp$cex    
	#add rectange as white background for the better visual effect when label is plotted against color 
	grid.rect(x=unit(x,"native")
			,y=unit(y,"native")
#			,width= unit(cex, "grobwidth", data = txtObj)#unit(1,'strwidth',labels)
#			,height=unit(cex, "grobheight", data = txtObj) #unit(1,'strheight',labels)
            ,width= unit(cex,'strwidth',labels)
            ,height=unit(cex,'strheight',labels)
			, gp=gpar(fill=gp$background$fill
					,col=gp$background$col
					,alpha=gp$background$alpha
					)
	)
#	browser()
		
    panel.text(x, y, labels=labels, col=gp$col, cex=gp$cex,
               linheight=gp$lineheigt, alpha=gp$alpha, font=gp$font)
}

glpoly <- function (x, y, ..., gp) 
{
    panel.polygon(x, y, labels=labels, border=gp$col, col=gp$fill,
                  lty=gp$lty, lwd=gp$lwd, alpha=gp$alpha, ...)
}





## Default function to plot points for a single gate region. This uses the
## existing Subset architecture, hence it only works for filters that
## produce logicalFilterResults so far
addLpoints <- function(x, data, channels, verbose=TRUE,
                       filterResult=NULL, gpar, ...)
{
    ## We check if the filterResult matches the filter and subset with that
    if(!is.null(filterResult)){
        if(!identical(identifier(x), identifier(filterResult)) ||
           class(x) != class(filterDetails(filterResult)[[1]]$filter))
            stop("The 'filterResult' and the filter object ",
                 "don't match.", call.=FALSE)
        x <- filterResult
    }
    exp <- exprs(Subset(data, x))
    
    panel.points(exp[,channels[1]], exp[,channels[2]],
                 pch=gpar$pch, cex=gpar$cex, col=gpar$col,
                 fill=gpar$fill, alpha=gpar$alpha, ...)
    return(invisible(NULL))
}


## Helper function to add points for multipleFilterResults.
## We check that the filterResult matches the filter and split by that
## The first component is everything outside not in the filter and we
## drop that
multFiltPoints <-  function(x, data, channels, verbose=TRUE,
                            filterResult=NULL, gpar, ...)
{
    if(is.null(filterResult))
        filterResult <- filter(data, x)
    checkIdMatch(x=filterResult, f=data)
    x <- filterResult 
    datsplit <- split(data, x)[-1]
    ld <- length(datsplit)
    ## we want to be able to use different colors for each population
    col <- rep(gpar$col, ld)[1:ld]
    for(i in 1:ld){
        gpar$col <- col[i]
        panel.points(exprs(datsplit[[i]])[,channels[1]],
                     exprs(datsplit[[i]])[,channels[2]],
                     pch=gpar$pch, cex=gpar$cex,
                     col=gpar$col, alpha=gpar$alpha,
                     fill=gpar$fill, ...)
    }
    return(invisible(NULL))
}

#' Visualization for flow cytometry
#' 
#' Functions and methods to visualize flow cytometry data. This package heavily
#' depends on the flowCore package.
#' 
#' \tabular{ll}{ Package: \tab flowViz\cr Type: \tab Package\cr Version: \tab
#' 0.2.1\cr Date: \tab 2006-11-16\cr License: \tab Artistic\cr } Traditionally,
#' large parts of the analysis process of flow cytometry data has been mostly
#' qualitative. To this end, dedicated visualization techniques have been used
#' for both quality control and infernece of the data. This package provides a
#' number of different visualization tools for flow data.
#' 
#' @name flowViz-package
#' @aliases flowViz-package flowViz
#' @docType package
#' @author
#' 
#' Maintainer: Florian Hahne <f.hahne@@dkfz.de> Authors: T. Duong, B. Ellis, R.
#' Gentleman, F. Hahne, N. Le Meur, D. Sarkar, M. Tang
#' @seealso \code{\link[flowCore:flowCore-package]{flowCore}}
#' @keywords package
#' @examples
#' 
#' ## examples go here
#' @import flowCore
#' @importClassesFrom methods ANY character formula logical matrix missing
#' @importMethodsFrom Biobase exprs pData pData<- phenoData sampleNames sampleNames<-
#' @importFrom methods as is
#' @importFrom grid gpar get.gpar grid.points grid.polygon grid.rect current.viewport unit
NULL

## ==========================================================================
## Draw points within a gate  on an existing plot. All graphical
## parameters will be passed on to graphics::points in the end, so
## these are basically extended points methods for gates and filters.
## We need to evaluate a filter to plot points (unless we pass a
## filterResult) and we always need the data to plot.
## FIXME: Need to figure out how to make points a generic without masking
##        the default function

## Default function to plot points for a single gate region. This uses the
## existing Subset architecture, hence it only works for filters that
## produce logicalFilterResults
addPoints <- function(x, data, channels, verbose=TRUE,
                      filterResult=NULL, ...)
{
    parms <- parameters(x)
    channels <- checkParameterMatch(channels, verbose=verbose,...)
    ## We check if the filterResult matches the filter and subset with that
    if(!is.null(filterResult)){
        fd <- filterDetails(filterResult, identifier(x))
        if(!identical(identifier(x), identifier(filterResult)) ||
           class(x) != class(fd$filter))
            stop("The 'filterResult' and the filter object ",
                 "don't match.", call.=FALSE)
        x <- filterResult
    }
    points(exprs(Subset(data, x))[,channels], ...)
}




## ==========================================================================
## for all filters
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## We only know how to add points within the gate if the definiton of that gate
## fits the parameters of the data provided. We also need to know about the
## plotted parameters, or guess if there are only two in the gate.
## If the first argument is a filterResult, we extract the filter definiton
## and pass that on to the next method as a separate argument
#' Adding points within a gate to a plot
#' 
#' These methods extend the basic graphics \code{\link{points}} methods for
#' drawing of points contained within a
#' \code{\link[flowCore:filter-class]{filter}}. They allow for multiple
#' dispatch, since not all \code{\link[flowCore:filter-class]{filter}} types
#' need to be evaluated for plotting, but this decision should be made
#' internally. In any case, we need the raw data in the form of a
#' \code{\link[flowCore:flowFrame-class]{flowFrame}}.
#' 
#' When plotting \code{\link[flowCore:flowFrame-class]{flowFrame}}s using the
#' \code{plot} method provided by \code{flowViz}, the plotted parameters are
#' recorded, which makes it possible to correctly overlay the points within
#' \code{\link[flowCore:filter-class]{filter}}s assuming that they are defined
#' for the respective parameters. Warnings and error will be cast for the cases
#' where the parameters are non-distinct or ambigious.
#' 
#' @name gpoints-methods
#' @aliases gpoints gpoints gpoints-methods
#' gpoints,curv1Filter,flowFrame,character-method
#' gpoints,curv2Filter,flowFrame,character-method
#' gpoints,filter,flowFrame,missing-method gpoints,filter,missing,ANY-method
#' gpoints,filterResult,flowFrame,character-method
#' gpoints,kmeansFilter,flowFrame,character-method
#' gpoints,norm2Filter,flowFrame,character-method
#' gpoints,polygonGate,flowFrame,character-method
#' gpoints,quadGate,flowFrame,character-method
#' gpoints,rectangleGate,flowFrame,character-method
#' @docType methods
#' @section Methods:
#' 
#' \describe{
#' 
#' \item{x = "filter", data = "flowFrame", channels = "missing"}{ General
#' method for all objects inheriting from
#' \code{\link[flowCore:filter-class]{filter}}. This is used as the default
#' when no more explicit method is found. It tries to find the plotted
#' parameters from the internal \code{flowViz.state} environment. This only
#' works if the flow data has been plotted using the \code{plot} methods
#' provided by this \code{flowViz} package. }
#' 
#' \item{x = "filter", data = "missing", channels = "ANY"}{ This gives a useful
#' error message when we don't get what we need. }
#' 
#' \item{x = "filterResult", data = "flowFrame", channels = }{ We can get all
#' the information about a \code{\link[flowCore:filter-class]{filter}} from its
#' \code{\link[flowCore:filterResult-class]{filterResult}} without the need to
#' re-evaluate.}\item{ "character"}{ We can get all the information about a
#' \code{\link[flowCore:filter-class]{filter}} from its
#' \code{\link[flowCore:filterResult-class]{filterResult}} without the need to
#' re-evaluate.}
#' 
#' \item{x = "curv1Filter", data = "ANY"}{ We either need a
#' \code{\link[flowCore:filterResult-class]{filterResult}} or the raw data as a
#' \code{\link[flowCore:flowFrame-class]{flowFrame}} for
#' \code{\link[flowStats:curv1Filter-class]{curv1Filter}}s. }
#' 
#' \item{x = "curv1Filter", data = "flowFrame"}{ see above }
#' 
#' \item{x = "curv1Filter", data = "missing"}{ see above }
#' 
#' \item{x = "curv1Filter", data = "multipleFilterResult"}{ see above }
#' 
#' \item{x = "curv2Filter", data = "ANY"}{ We either need a
#' \code{\link[flowCore:filterResult-class]{filterResult}} or the raw data as a
#' \code{\link[flowCore:flowFrame-class]{flowFrame}} for
#' \code{\link[flowStats:curv2Filter-class]{curv2Filter}}s.}
#' 
#' \item{x = "curv1Filter", data = "flowFrame", channels = }{ We evaluate the
#' \code{\link[flowCore:filter-class]{filter}} on the
#' \code{\link[flowCore:flowFrame-class]{flowFrame}} and plot the subset of
#' selected points. By default, every subpopulation (if there are any) is
#' colored differently.}\item{ "character"}{ We evaluate the
#' \code{\link[flowCore:filter-class]{filter}} on the
#' \code{\link[flowCore:flowFrame-class]{flowFrame}} and plot the subset of
#' selected points. By default, every subpopulation (if there are any) is
#' colored differently.}
#' 
#' \item{x = "curv2Filter", data = "flowFrame", channels = "character"}{ see
#' above }
#' 
#' \item{x = "kmeansFilter", data = "flowFrame", channels = }{ see above
#' }\item{ "character"}{ see above }
#' 
#' \item{x = "norm2Filter", data = "flowFrame", channels = }{ see above }\item{
#' "character"}{ see above }
#' 
#' \item{x = "polygonGate", data = "flowFrame", channels = }{ see above }\item{
#' "character"}{ see above }
#' 
#' \item{x = "quadGate", data = "flowFrame", channels = "character"}{ see above
#' }
#' 
#' \item{x = "rectangleGate", data = "flowFrame", channels = }{ see above
#' }\item{ "character"}{ see above }
#' 
#' }
#' @author F. Hahne
#' @seealso
#' 
#' \code{\link[flowCore:filter-class]{filter}},
#' \code{\link[flowCore:flowFrame-class]{flowFrame}}, \code{\link{glines}},
#' \code{\link{gpolygon}}
#' @keywords methods
#' @importFrom graphics abline axis barplot contour hist layout lines pairs par points polygon rect smoothScatter
#' @export
#' @param x filter, filterResult or any derived filter class
#' @param data flowFrame or missing
#' @param channels character or missing
#' @param verbose logical
#' @param filterResult filterResult class
#' @param ... other arguments
setMethod("gpoints",
          signature(x="filter", data="flowFrame", channels="missing"), 
          function(x, data, channels, verbose=TRUE,
          filterResult=NULL, ...)
      {
          if(is(x, "filterResult")){
              filterResult <- x
              fd <- filterDetails(x)
              x <- fd[[length(fd)]]$filter
          }
          channels <- checkParameterMatch(parameters(x), verbose=verbose,...)
          gpoints(x=x, data=data, channels=channels, verbose=verbose,
                  filterResult=filterResult, ...)
      })

## Need this to deal with filterResults when the plotting channels are
## specified
setMethod("gpoints",
          signature(x="filterResult", data="flowFrame", channels="character"), 
          function(x, data, channels, verbose=TRUE,
          filterResult=NULL, ...)
      {
          if(x@frameId != identifier(data))
              stop("The filter was evaluated on flowFrame '",
                   x@frameId, "'\n  but the frame provided is '",
                   identifier(data), "'.", call.=FALSE)
          filterResult <- x
          fd <- filterDetails(x)
          x <- fd[[length(fd)]]$filter
          channels <- checkParameterMatch(channels, verbose=verbose,...)
          gpoints(x=x, data=data, channels=channels, verbose=verbose,
                   filterResult=filterResult, ...)
      })    

## A useful error message when we don't get what we need
setMethod("gpoints",
          signature(x="filter", data="missing", channels="ANY"), 
          function(x, data, channels, verbose=TRUE,
          filterResult=NULL, ...)
      {
          stop("Need the 'flowFrame' in order to add points.", call.=FALSE)
      })



          
## ==========================================================================
## for rectangleGates
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## Only warning that we don't use the filterResult, the rest is pretty
## much the default
setMethod("gpoints",
          signature(x="rectangleGate", data="flowFrame", channels="character"), 
          function(x, data, channels, verbose=TRUE,
          filterResult=NULL, ...)
      { 
          if(!is.null(filterResult))
              dropWarn("filterResult", "rectangleGates", verbose=verbose)
          addPoints(x=x, data=data, channels=channels, verbose=verbose,
                      filterResult=NULL, ...)
      })




## ==========================================================================
## for quadGates
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## We plot this as four individual rectangle gates
setMethod("gpoints",
          signature(x="quadGate", data="flowFrame", channels="character"), 
          function(x, data, channels, verbose=TRUE, col, ...)
      {
          if(!is.null(filterResult))
              dropWarn("filterResult", "quadGates", verbose=verbose)
          parms <- parameters(x)
          channels <- checkParameterMatch(channels, verbose=verbose,...)
          if(missing(col))
              col <-  colorRampPalette(brewer.pal(9, "Set1"))(4)
          else
              col <- rep(col,4)
          v <- x@boundary[channels[1]]
          h <- x@boundary[channels[2]]
          mat <- matrix(c(-Inf, v, h, Inf, v, Inf, h, Inf, -Inf, v, -Inf,
                          h, v, Inf, -Inf, h), byrow=TRUE, ncol=4)              
          for(i in 1:4){
              rg <- rectangleGate(.gate=matrix(mat[i,], ncol=2,
                                  dimnames=list(c("min", "max"), parms)))
              gpoints(rg, data=data, channels=channels, verbose=FALSE,
                      col=col[i], ...)
          }
      })




## ==========================================================================
## for polygonGates
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## Only warning that we don't use the filterResult, the rest is pretty
## much the default
setMethod("gpoints",
          signature(x="polygonGate", data="flowFrame", channels="character"), 
          definition=function(x, data, channels, verbose=TRUE,
          filterResult=NULL, ...)
      {
          if(!is.null(filterResult))
              dropWarn("filterResult", "polygonGates", verbose=verbose)
          addPoints(x=x, data=data, channels=channels, verbose=verbose,
                      filterResult=NULL, ...)
      })


## ==========================================================================
## for norm2Filters
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## We don't need to reevaluate the filter if the filterResult is used,
## so no need for a warning here
setMethod("gpoints",
          signature(x="norm2Filter", data="flowFrame", channels="character"), 
          definition=function(x, data, channels, verbose=TRUE,
          filterResult=NULL, ...)
      {
          addPoints(x=x, data=data, channels=channels, verbose=verbose,
                      filterResult=filterResult, ...)
      })



## ==========================================================================
## for kmeansFilters
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## This filter produces a multipleFilterResult, so we can't subset directly.
## Instead, we split the original frame and plot each component separately
setMethod("gpoints",
          signature(x="kmeansFilter", data="flowFrame", channels="character"), 
          function(x, data, channels, verbose=TRUE,
                   filterResult=NULL, col, ...)
      {
          ## We check that the filterResult matches the filter and split by that
          channels <- checkParameterMatch(channels, verbose=verbose,...)
          if(!is.null(filterResult)){
              if(!identical(identifier(x), identifier(filterResult)) ||
                 class(x) != class(filterDetails(filterResult,
                                                 identifier(x))$filter))
                  stop("The 'filterResult' and the filter object ",
                       "don't match.", call.=FALSE)
              x <- filterResult
          }
          datsplit <- split(data, x)
          ld <- length(datsplit)
          if(missing(col))
              col <-  colorRampPalette(brewer.pal(9, "Set1"))(ld)
          else
              col <- rep(col, ld)[1:ld]
          mapply(function(z, co, ...) points(exprs(z)[,channels], col=co, ...),
                 z=datsplit, co=col, MoreArgs=list(...))
          return(invisible(NULL))
      })







          

## load a flowFrame
unloadNamespace("flowViz")

library(flowViz)
library(ncdfFlow)
library(grid)
library(IDPmisc)
library(hexbin)
library(latticeExtra)
library(grDevices)
library(gridExtra)
lapply(list.files("~/rglab/workspace/flowViz/R",full=T),source)
data(GvHD)
#fcs1 <- GvHD[[1]]
#fcs2 <- GvHD[[1]]
#colnames(fcs2)[1] <- "noname"
fs <- GvHD[c(1,2,8,9)]
#fs <- ncdfFlowSet(fs)
g1 <- rectangleGate("SSC-H"=c(400,Inf))
g2 <- rectangleGate("SSC-H"=c(900,950))
overlay <- Subset(fs[1],g2)
dev.off()
x11()
#grid.arrange(
    xyplot(`FSC-H`~`SSC-H`,fs
              ,xbin=64
              ,smooth=F 
#            ,filter = sapply(sampleNames(fs),function(x)filters(list(g1,g2)),simplify=F)
              ,filter = g1
    , overlay =overlay
    ,stats=T
      )
#  ,xyplot(`FSC-H`~`SSC-H`, fs[1]
#      ,xbin=64
#                ,smooth=F 
#      , par.settings = list(overlay.symbol = list(fill = "black")
#      )
#      ,filter = g1, overlay =overlay
#      )
#  )




aa <- trellis.par.get()
bb <- flowViz.par.get()

system.time(
densityplot(~`SSC-H`
                ,fs
              ,stack = T
#              ,filter = sapply(sampleNames(fs),function(x)filters(list(g1,g2)),simplify=F)
              ,filter =g1
              ,fitGate = F
      ,stats =T
          )

)
pData(GvHD)
## a wrapper that catches and reports errors
wrap <- function(x)
{
    tmp <- try(x)
    if(!is(tmp, "try-error")){
        print("done")
        if(!is.null(tmp))
            warning("Return value should be NULL.", call.=FALSE)
    }
}
    

## plot a gate with all possible combinations of arguments
plotGates <- function(gate, data=fcs1, verbose=TRUE)
{
    opar <- par(ask=TRUE)
    oo <- options(warn=1)
    on.exit({par(opar); options(oo)})
    yp <- xp <- p <- parameters(gate)
    xp[1] <- "falseX"
    yp[2] <- "falseY"
    fres <- try(filter(data, gate))
    ## first without a second argument
    print("Only dispatch on filter")
    plot(fcs1, c("FSC-H", "SSC-H"))
    wrap(fun(gate, verbose=verbose, lwd=2, lty=3))
    ## Now with optional channel argument
    print("Only dispatch on filter, but with optional channels argument")
    plot(fcs1, c("FSC-H", "SSC-H"))
    wrap(fun(gate, channels=c("FSC-H", "SSC-H"), lty=3,
             lwd=2, verbose=verbose))
    ## Now the second argument are the channels
    print("Dispatch on filter and channel names")   
    plot(fcs1, c("FSC-H", "SSC-H"))
    wrap(fun(gate, c("FSC-H", "SSC-H"), verbose=verbose,
                col=2, lwd=2, lty=3))
    ## Some of the channels are not in the filter
    print("Dispatch on filter and channel names with y channel wrong")  
    plot(fcs1, c("FSC-H", "SSC-H"))
    wrap(fun(gate, yp, verbose=verbose, col=2, lwd=2, lty=3))
    ## And with optional channel argument added on top
    print("Dispatch on filter with optional channels argument")  
    plot(fcs1, c("SSC-H", "FSC-H"))
    wrap(fun(gate, c("FSC-H", "SSC-H"), verbose=verbose,
                col=2, lwd=2, lty=3, channels=c("SSC-H", "FSC-H")))
    ## Some of the channels are not in the filter
    print("Dispatch on filter and channel names with y channel wrong and with optional channels argument")
    plot(fcs1, c("SSC-H", "FSC-H"))
    wrap(fun(gate, yp, verbose=verbose, col=2, lwd=2, lty=3, channels=xp))
    ## Now the second argument is a filterResult
    print("Dispatch on filter and filterResult")   
    plot(fcs1, c("FSC-H", "SSC-H"))
    wrap(fun(gate, fres, verbose=verbose,
                lwd=2, lty=3))
    ## And with optional channel argument added on top
    print("Dispatch on filter and filterResult with optional channels argument")   
    plot(fcs1, c("SSC-H", "FSC-H"))
    wrap(fun(gate, fres, verbose=verbose,
                col=5, lwd=2, lty=3, channels=c("SSC-H", "FSC-H")))
    ## Now the second argument is a flowFrame
    print("Dispatch on filter and flowFrame")   
    plot(fcs1, c("FSC-H", "SSC-H"))
    wrap(fun(gate, data, verbose=verbose,
                col=5, lwd=2, lty=3))
    ## And with optional channel argument added on top
    print("Dispatch on filter and flowFrame with optional channels argument")   
    plot(fcs1, c("SSC-H", "FSC-H"))
    wrap(fun(gate, data, verbose=verbose,
                lwd=2, lty=3, channels=c("SSC-H", "FSC-H")))
}


## plot points in a gate with all possible combinations of arguments
plotPoints <- function(gate, data=fcs1, verbose=TRUE)
{
    opar <- par(ask=TRUE)
    oo <- options(warn=1)
    on.exit({par(opar); options(oo)})
    yp <- xp <- p <- parameters(gate)
    xp[1] <- "falseX"
    yp[2] <- "falseY"
    fres <- try(filter(data, gate))
    ## first without a third argument
    print("Only dispatch on filter")
    plot(fcs1, c("FSC-H", "SSC-H"))
    wrap(fun(gate, fcs1, verbose=verbose, lwd=2, lty=3))
    ## Now with the channel argument
    print("Only dispatch on filter, but with optional channels argument")
    plot(fcs1, c("FSC-H", "SSC-H"))
    wrap(fun(gate, fcs1, channels=c("FSC-H", "SSC-H"), lty=3,
             lwd=2, verbose=verbose))
    ## Some of the channels are not in the filter
    print("Dispatch on filter and channel names with y channel wrong")  
    plot(fcs1, c("FSC-H", "SSC-H"))
    wrap(fun(gate, fcs1, yp, verbose=verbose, col=2, lwd=2, lty=3))
    ## Now the first argument is a filterResult
    print("Dispatch on filter and filterResult")   
    plot(fcs1, c("FSC-H", "SSC-H"))
    wrap(fun(fres, fcs1, verbose=verbose,
                lwd=2, lty=3))
    ## And with channel argument added on top
    print("Dispatch on filter and filterResult with channels argument")   
    plot(fcs1, c("SSC-H", "FSC-H"))
    wrap(fun(fres, fcs1, verbose=verbose,
                col=5, lwd=2, lty=3, channels=c("SSC-H", "FSC-H")))
}



############################################################################
##                            rectangelGates first                        ##
############################################################################
## lines
fun <- glines
rg <- rectangleGate(filterId="Rectangle", "FSC-H" = c(250, 650),
              "SSC-H" = c(400, 575))
plotGates(rg)
plotGates(rg, verbose=FALSE)
rg <- rectangleGate(filterId="Rectangle", "FSC-H" = c(250, 650),
              "SSC-H" = c(400, 575), "FL2-H" = c(400, 500))
plotGates(rg)
plotGates(rg, verbose=FALSE)
rg <- rectangleGate(filterId="Rectangle", "FSC-H" = c(250, 650))
plotGates(rg)
plotGates(rg, verbose=FALSE)

## polygons
fun <- gpolygon
rg <- rectangleGate(filterId="Rectangle", "FSC-H" = c(250, 650),
              "SSC-H" = c(400, 575))
plotGates(rg)
plotGates(rg, verbose=FALSE)
rg <- rectangleGate(filterId="Rectangle", "FSC-H" = c(250, 650),
              "SSC-H" = c(400, 575), "FL2-H" = c(400, 500))
plotGates(rg)
plotGates(rg, verbose=FALSE)
rg <- rectangleGate(filterId="Rectangle", "FSC-H" = c(250, 650))
plotGates(rg)
plotGates(rg, verbose=FALSE)

## points
fun <- gpoints
rg <- rectangleGate(filterId="Rectangle", "FSC-H" = c(250, 650),
              "SSC-H" = c(400, 575))
plotPoints(rg)
plotPoints(rg, verbose=FALSE)
rg <- rectangleGate(filterId="Rectangle", "FSC-H" = c(250, 650),
              "SSC-H" = c(400, 575), "FL2-H" = c(400, 500))
plotPoints(rg)
plotPoints(rg, verbose=FALSE)
rg <- rectangleGate(filterId="Rectangle", "FSC-H" = c(250, 650))
plotPoints(rg)
plotPoints(rg, verbose=FALSE)


############################################################################
##                                quadGates                               ##
############################################################################
## lines
fun <- glines
qg <- quadGate(filterId="nonDebris", "FSC-H"=500, "SSC-H"=800)
plotGates(qg)
plotGates(qg, verbose=FALSE)

## polygons
fun <- gpolygon
plotGates(qg)
plotGates(qg, verbose=FALSE)

## points
fun <- gpoints
plotPoints(qg)
plotPoints(qg, verbose=FALSE)


############################################################################
##                               polygonGates                             ##
############################################################################
## lines
fun <- glines
sqrcut <- matrix(c(300,400,600,500, 200, 50, 100, 300, 400,70),
                 ncol=2)
colnames(sqrcut) <- c("FSC-H","SSC-H")
pg <- polygonGate(filterId="nonDebris", boundaries= sqrcut)
plotGates(pg)
plotGates(pg, verbose=FALSE)

## polygons
fun <- gpolygon
plotGates(pg)
plotGates(pg, verbose=FALSE)

## points
fun <- gpoints
plotPoints(pg)
plotPoints(pg, verbose=FALSE)


############################################################################
##                               norm2Filter                              ##
############################################################################
## lines
fun <- glines
nf <- norm2Filter(filterId = "BVNorm", "FSC-H", "SSC-H", scale=2)
plotGates(nf)
plotGates(nf, verbose=FALSE)

## polygons
fun <- gpolygon
plotGates(nf)
plotGates(nf, verbose=FALSE)

## points
fun <- gpoints
plotPoints(nf)
plotPoints(nf, verbose=FALSE)


############################################################################
##                               curv2Filter                              ##
############################################################################
## lines
fun <- glines
c2f <- curv2Filter(filterId = "BVCurv", "FSC-H", "SSC-H")
plotGates(c2f)
plotGates(c2f, verbose=FALSE)

## polygons
fun <- gpolygon
plotGates(c2f)
plotGates(c2f, verbose=FALSE)

## points
fun <- gpoints
plotPoints(c2f)
plotPoints(c2f, verbose=FALSE)


############################################################################
##                               curv1Filter                              ##
############################################################################
## lines
fun <- glines
c1f <- curv1Filter(filterId = "BVCurv", "SSC-H")
plotGates(c1f)
plotGates(c1f, verbose=FALSE)

## polygons
fun <- gpolygon
plotGates(c1f)
plotGates(c1f, verbose=FALSE)

## points
fun <- gpoints
plotPoints(c1f)
plotPoints(c1f, verbose=FALSE)


############################################################################
##                               kmeansFilter                             ##
############################################################################
## lines
fun <- glines
kf <- kmeansFilter("kmfilt", "FSC-H" = c("Low", "High"))
plotGates(kf)

## polygons
fun <- gpolygon
plotGates(kf)

## points
fun <- gpoints
plotPoints(kf)
plotPoints(kf, verbose=FALSE)

############################################################################
##                               hexbin
############################################################################
xyplot(`FSC-H` ~ `SSC-H`, GvHD[1:3], smooth=F,xbin=128)

############################################################################
##                               conditioning lattice
############################################################################

library(flowViz)
library(IDPmisc)
data(GvHD)

fs<-GvHD[c(1,2,9,10)]

xyplot(`SSC-H` ~ `FSC-H`|Patient:Visit:name ,data =fs)
xyplot(`SSC-H` ~ `FSC-H`|Patient:name ,data =fs)

xyplot(`SSC-H` ~ `FSC-H` ,data =fs)
exprs(fs[[3]])<-exprs(fs[[3]])[0,,drop=F]
xyplot(`SSC-H` ~ `FSC-H` ,data =fs[[3]])

xyplot(Grade~factor(name)|Patient+Visit,data=pData(fs))

require(flowWorkspace)
library(flowStats)
library(flowClust)
lapply(list.files("~/rglab/workspace/flowViz/R",full=T),source)

load("~/rglab/workspace/HIMCLyoplate/Gottardo/flowCAP/wf.rda")
png("~/rglab/workspace/HIMCLyoplate/Gottardo/pipeline/analysis/Tcell/flowVizFixed.png",width=800,height=600)
plotGate(wf)
dev.off()



overlay(wf[1:2],gate=4,overlay.gate.indices=c(4,5))

overlay <- function(gs,gate=9,overlay.gate.indices=c(9,40),trans=TRUE,grid=65,h=c(0.1,0.1),nlines=25,wh=1,...){
	#gs is a gating set, and we want to generate one plot at a time..
	browser()
	gh <- gs[[wh]]
	p <- getParent(gh,gate)
	d <- getData(gh,p)
	g <- getGate(gh,gate)
	cn <- colnames(g@boundaries)
	d <- exprs(d)[,cn]
	
	x <- d[,1]
	y <- d[,2]
	
	ogi <- and(do.call(cbind,lapply(overlay.gate.indices,function(i)flowWorkspace:::getIndices(gh,i))))
	a <- and(do.call(cbind,lapply(c(overlay.gate.indices,gate),function(i)flowWorkspace:::getIndices(gh,i))))
	b<-flowWorkspace:::getIndices(gh,p)
	prop <- prop.table(table(a[b]))[2]
	cl <- kde2d(x=x,y=y,h=h,n=grid)
	if(trans){
		cl$z <- sqrt(cl$z)
	}
	contour(cl,n=nlines,...)
	d <- exprs(getData(gh)[,cn])[ogi,,drop=FALSE]
	points(x=d[,1],y=d[,2],col="red",cex=3,pch='.')
	
	polygon(getGate(gh,gate)@boundaries,border="blue")
	text(3.5,2,signif(prop,3))
}
or <- function(x,...){
	if(ncol(x)==1){
		x
	}else if(ncol(x)==2){
		x[,1]|x[,2]
	}else{
		Recall(x[,-1L])
	}
}
and <- function(x,...){
	if(ncol(x)==1){
		x
	}else if(ncol(x)==2){
		x[,1]&x[,2]
	}else{
		Recall(x[,-1L])
	}
}

#' @importFrom MASS kde2d
#' @export 
#' @rdname lattice-methods
setMethod("levelplot",
          signature(x = "formula", data = "flowSet"),
          function(x, data, xlab, ylab,
                   as.table = TRUE, contour = TRUE, labels = FALSE,
                   n = 50, 
                   ...)
      {
          samples <- sampleNames(data)
          channel.y <- x[[2]]
          channel.x <- x[[3]]
          if (length(channel.x) == 3) ## cy ~ cx | foo+bar
          {
              channel.x <- channel.x[[2]]
              my.formula <- x
              my.formula[[2]] <- as.name("z")
              my.formula[[3]][[2]] <- (z ~ x * y)[[3]]
          }
          else ## cy ~ cx
          {
              my.formula <- z ~ x * y
          }
          channel.x.name <- expr2char(channel.x)
          channel.y.name <- expr2char(channel.y)
          channel.x <- as.expression(channel.x)
          channel.y <- as.expression(channel.y)

          range.x <- range(unlist(lapply(samples, function(nm) range(evalInFlowFrame(channel.x, data@frames[[nm]]), finite = TRUE))))
          range.y <- range(unlist(lapply(samples, function(nm) range(evalInFlowFrame(channel.y, data@frames[[nm]]), finite = TRUE))))
          ## range.y <- range(unlist(eapply(data@frames, function(x) range(x[, channel.y], finite = TRUE))))

          range.x <- lattice:::extend.limits(range.x, prop = 0.05)
          range.y <- lattice:::extend.limits(range.y, prop = 0.05)
          computeKde <- function(nm)
          {
              xx <- evalInFlowFrame(channel.x, data@frames[[nm]])
              yy <- evalInFlowFrame(channel.y, data@frames[[nm]])
              temp <- kde2d(xx, yy, n = n, lims = c(range.x, range.y))
              data.frame(x = rep(temp$x, n),
                         y = rep(temp$y, each = n),
                         z = as.vector(temp$z))
          }
          ft <- do.call(make.groups, sapply(samples, computeKde, simplify = FALSE))
          ## The next step is not efficient, as it replicates the
          ## phenodata many times over.  However, bypassing this is a
          ## task for another day
          ft <- cbind(ft, pData(phenoData(data))[as.character(ft$which), , drop = FALSE])
          if (missing(xlab)) xlab <- channel.x.name
          if (missing(ylab)) ylab <- channel.y.name
          levelplot(my.formula, data = ft,
                    contour = contour, labels = labels,
                    xlab = xlab,
                    ylab = ylab,
                    as.table = as.table, 
                    ...)
      })


##Example:
##
## require(colorspaces)
## YlOrBr <- c("#FFFFD4", "#FED98E", "#FE9929", "#D95F0E", "#993404")
## colori <- colorRampPalette(YlOrBr, space = "Lab")
## levelplot(`SSC-H` ~ `FSC-H` | name, samp, col.regions=colori(50), main="Contour Plot")
##



## QQ plot

## setGeneric("qqmath")


#' Methods implementing Lattice displays for flow data
#' 
#' 
#' Various methods implementing multipanel visualizations for flow data using
#' infrastructure provided in the lattice package.  The original generics for
#' these methods are defined in lattice, and these S4 methods (mostly) dispatch
#' on a formula and the \code{data} argument which must be of class
#' \code{flowSet} or \code{flowFrame}.  The formula has to be fairly basic:
#' conditioning can be done using phenodata variables and channel names (the
#' \code{colnames} slot) can be used as panel variables. See examples below for
#' sample usage.
#' 
#' Not all standard lattice arguments will have the intended effect, but many
#' should.  For a fuller description of possible arguments and their effects,
#' consult documentation on lattice (Trellis docs would also work for the
#' fundamentals).
#' 
#' @name lattice-methods
#' @param x a formula describing the structure of the plot and the variables to
#' be used in the display.
#' @param data a \code{flowSet} object that serves as a source of data.
#' @param xlab,ylab Labels for data axes, with suitable defaults taken from the
#' formula
#' @param f.value,distribution number of points used in Q-Q plot, and the
#' reference distribution used.  See \code{\link[lattice:qqmath]{qqmath}} for
#' details.
#' @param n the number of bins on each axis to be used when evaluating the
#' density
#' @param as.table,contour,labels These arguments are passed unchanged to the
#' corresponding methods in lattice, and are listed here only because they
#' provide different defaults.  See documentation for the original methods for
#' details.
#' @param time A character string giving the name of the column recording time.
#' @param exclude.time logical, specifying whether to exclude the time variable
#' from a scatter plot matrix or parallel coordinates plot.  It is rarely
#' meaningful not to do so.
#' @param reorder.by a function, which is applied to each column.  The columns
#' are ordered by the results.  Reordering can be suppressed by setting this to
#' \code{NULL}.
#' @param \dots more arguments, usually passed on to the underlying lattice
#' methods.
#' @section Methods: \describe{
#' 
#' \item{qqmath}{\code{signature(x = "formula", data = "flowSet")}: creates
#' theoretical quantile plots of a given channel, with one or more samples per
#' panel }
#' 
#' \item{levelplot}{\code{signature(x = "formula", data = "flowSet")}: similar
#' to the \code{xyplot} method, but plots estimated density (using
#' \code{\link[MASS:kde2d]{kde2d}}) with a common z-scale and an optional color
#' key.  }
#' 
#' \item{parallelplot}{\code{signature(x = "flowFrame", data = "missing")}: draws a
#' parallel coordinates plot of all channels (excluding time, by default) of a
#' \code{flowFrame} object.  This is rarely useful without transparency, but
#' that is currently only possible with the \code{\link{pdf}} device (and
#' perhaps the aqua device as well).  }
#' 
#' }
#' @keywords methods dplot
#' @examples
#' 
#' library(flowCore)
#' data(GvHD)
#' 
#' qqmath( ~ `FSC-H` | factor(Patient), GvHD,
#'        grid = TRUE, type = "l",
#'        f.value = ppoints(100))
#' 
#' 
#' ## contourplot of bivariate density:
#' 
#' require(colorspace)
#' YlOrBr <- c("#FFFFD4", "#FED98E", "#FE9929", "#D95F0E", "#993404")
#' colori <- colorRampPalette(YlOrBr)
#' levelplot(asinh(`SSC-H`) ~ asinh(`FSC-H`) | Visit + Patient, GvHD, n = 20,
#'           col.regions = colori(50), main = "Contour Plot")
#' 
#' 
#' 
#' ## parallel coordinate plots
#' 
#' parallelplot(GvHD[["s6a01"]])
#' 
#' \dontrun{
#' 
#' ## try with PDF device
#' parallelplot(GvHD[["s7a01"]], alpha = 0.01)
#' 
#' }
#' 
#' @import lattice
#' @export 
#' @rdname lattice-methods
#' @aliases qqmath,formula,flowSet-method
setMethod("qqmath",
          signature(x = "formula", data = "flowSet"),
          function(x, data, xlab, ylab,
                   f.value = function(n) ppoints(ceiling(sqrt(n))),
                   distribution = qnorm,
                   ...)
      {
          pd <- pData(phenoData(data))
          uniq.name <- createUniqueColumnName(pd)
          ## ugly hack to suppress warnings about coercion introducing NAs
          pd[[uniq.name]] <- factor(sampleNames(data))
          channel <- x[[2]]
          if (length(channel) == 3)
          {
              channel <- channel[[2]]
              x[[2]][[2]] <- as.name(uniq.name)
          }
          else x[[2]] <- as.name(uniq.name)
          channel.name <- expr2char(channel)
          channel <- as.expression(channel)

          prepanel.qqmath.flowset <- 
              function(x, frames, channel,
                       f.value, distribution,
                       ...)
              {
                  distribution <- if (is.function(distribution)) 
                      distribution
                  else if (is.character(distribution)) 
                      get(distribution)
                  else eval(distribution)

                  nobs <- max(unlist(eapply(frames, function(x) nrow(exprs(x)))))

                  qrange <-
                      if (is.null(f.value)) 
                          ppoints(sqrt(nobs))
                      else if (is.numeric(f.value))
                            f.value
                      else f.value(nobs)
                  qrange <- range(qrange)

                  xx <- distribution(qrange)
                  yy <-
                      unlist(eapply(frames,
                                    function(x) {
                                        quantile(evalInFlowFrame(channel, x),
                                                 qrange,
                                                 na.rm = TRUE)
                                    }))

                  dx <- rep(diff(distribution(c(0.25, 0.75))), length(ls(frames)))
                  dy <-
                      unlist(eapply(frames,
                                    function(x) {
                                        diff(quantile(evalInFlowFrame(channel, x),
                                                      c(0.25, 0.75),
                                                      na.rm = TRUE))
                                    }))

                  list(xlim = range(xx, finite = TRUE),
                       ylim = range(yy, finite = TRUE),
                       dx = dx, dy = dy)
              }

          panel.qqmath.flowset <-
              function(x, 
                       frames, channel,
                       f.value, distribution,
                       grid = FALSE,

                       col = superpose.symbol$col,
                       col.points = col,
                       pch = superpose.symbol$pch,
                       cex = superpose.symbol$cex,
                       alpha = superpose.symbol$alpha,
                       col.line = col,
                       lty = superpose.line$lty,
                       lwd = superpose.line$lwd,
                       ...)
              {
                  if (grid) panel.grid(h = -1, v = -1)
                  superpose.symbol <- trellis.par.get("superpose.symbol")
                  superpose.line <- trellis.par.get("superpose.line")

                  nx <- length(x)
                  col.points <- rep(col.points, length = nx)
                  col.line <- rep(col.line, length = nx)
                  pch <- rep(pch, length = nx)
                  cex <- rep(cex, length = nx)
                  lty <- rep(lty, length = nx)
                  lwd <- rep(lwd, length = nx)
                  alpha <- rep(alpha, length = nx)

                  distribution <- if (is.function(distribution)) 
                      distribution
                  else if (is.character(distribution)) 
                      get(distribution)
                  else eval(distribution)

                  nobs <- max(unlist(eapply(frames, function(x) nrow(exprs(x)))))
                  qq <-
                      if (is.null(f.value)) 
                          ppoints(sqrt(nobs))
                      else if (is.numeric(f.value))
                          f.value
                      else f.value(nobs)
                  xx <- distribution(qq)
                  x <- as.character(x)
                  for (i in seq_along(x))
                  {
                      nm <- x[i]
                      yy <-
                          quantile(evalInFlowFrame(channel, frames[[nm]]),
                                   qq, na.rm = TRUE)
                      panel.xyplot(xx, yy,
                                   col.line = col.line[i],
                                   col = col[i],
                                   cex = cex[i],
                                   pch = pch[i],
                                   lty = lty[i],
                                   lwd = lwd[i],
                                   alpha = alpha[i],
                                   ...)
                  }
              }

          if (missing(xlab)) xlab <- deparse(substitute(distribution))
          if (missing(ylab)) ylab <- channel.name
          qqmath(x, data = pd,
                 f.value = f.value, distribution = distribution,
                 prepanel = prepanel.qqmath.flowset,
                 panel = panel.qqmath.flowset,
                 frames = data@frames,
                 channel = channel,
                 xlab = xlab,
                 ylab = ylab,
                      
                 ...)
      })

#' One-dimensional density/histogram plots for flow data
#' 
#' 
#' For \code{\link[flowCore:flowSet-class]{flowSets}} the idea is to
#' horizontally stack plots of density estimates for all frames in the
#' \code{flowSet} for one or several flow parameters. In the latter case, each
#' parameter will be plotted in a separate panel, i.e., we implicitly condition
#' on parameters.
#' 
#' 
#' Not all standard lattice arguments will have the intended effect, but many
#' should.  For a fuller description of possible arguments and their effects,
#' consult documentation on lattice (Trellis docs would also work for the
#' fundamentals).
#' 
#' @name densityplot
#' 
#' @param x A formula describing the structure of the plot and the variables to
#' be used in the display. The structure of the formula is \code{factor ~
#' parameter}, where \code{factor} can be any of the phenotypic factors in the
#' \code{phenoData} slot or an appropriate factor object and \code{parameter}
#' is a flow parameter. Panels for multiple parameters are drawn if the formula
#' structure is similar to \code{factor ~ parameter1 + parameter2}, and
#' \code{factor} can be missing, in which case the sample names are used as
#' y-variable. To facilitate programatic access, the formula can be of special
#' structure \code{factor ~ .}, in which case the optional \code{channel}
#' argument is considered for parameter selection. For the workflow methods,
#' \code{x} can also be one of the several workflow objects.
#' 
#' @param data A flow data object that serves as a source of data, either a
#' \code{\link[flowCore:flowFrame-class]{flowFrame}} or
#' \code{\link[flowCore:flowSet-class]{flowSet}}
#' 
#' @param \dots More arguments, usually passed on to the underlying lattice
#' methods.  
#' \itemize{
#'
#'  \item channels A character vector of parameters that are supposed to be
#'                  plotted when the formula in \code{x} is of structure \code{factor ~ .}.
#' 
#'  \item xlab: Label for data x axis, with suitable defaults taken from the
#'  formula
#' 
#'  \item prepanel: The prepanel function.  See \code{\link[lattice]{xyplot}}
#' 
#'  \item panel: the panel function.  See \code{\link[lattice]{xyplot}}
#' 
#'  \item axis: axis function passed to lattice, default is \code{axis.grid}
#' 
#'  \item ... : other arguments passed to panel.densityplot.flowset.stack or
#'              panel.histogram.flowframe
#' 
#' }
#' @examples
#' 
#' library(flowCore)
#' library(flowStats)
#' data(GvHD)
#' GvHD <- GvHD[pData(GvHD)$Patient %in% 6:7]
#' 
#' densityplot(~ `FSC-H`, GvHD)
#' 
#' densityplot(~ `FSC-H` + `SSC-H`, GvHD)
#' 
#' densityplot(~ ., GvHD[1:3])
#' 
#' ## include a filter
#' densityplot(~ `FSC-H`, GvHD, filter=curv1Filter("FSC-H"))
#' 
#' #display the gate by its boundaries with statistics 
#' densityplot(~ `FSC-H`, GvHD[1:2], filter=curv1Filter("FSC-H"),fitGate=FALSE,stats=TRUE)
#' 
#' ## plot a single flowFrame
#' densityplot(~ `SSC-H`, GvHD[[1]], margin=FALSE)
#' 
#' ## plot histogram
#' histogram(~ `SSC-H`, GvHD[[1]]) #default type is 'density'
#' #change the type to 'count' and adjust breaks
#' histogram(~ `SSC-H`, GvHD[[1]], margin=FALSE, type = "count", breaks = 50)
#' 
#' @aliases densityplot,formula,flowSet-method
#' @export 
#' @rdname densityplot
setMethod("densityplot",
    signature(x = "formula", data = "flowSet"),
    function(x, data, ...){
      #construct lattice object
      thisTrellisObj <- .densityplot.adapor(x, data, ...) 
      
      #pass frames slot
      thisData <- thisTrellisObj[["panel.args.common"]][["frames"]]
      thisTrellisObj[["panel.args.common"]][["frames"]] <- thisData@frames
      thisTrellisObj
    })

## Dedicated prepanel function to set up dimensions
#' @export 
#' @rdname densityplot
prepanel.densityplot.flowset.stack <- 
    function(x, y, frames, 
             overlap=0.3, subscripts, ...,
             which.channel)
{
    channel.name <- unique(which.channel[subscripts])
    stopifnot(length(channel.name) == 1)
    if(extends(class(frames),"flowSet"))
      ranglist <- eapply(frames@frames, function(fr)range(fr)[, channel.name])
    else
      ranglist <- lapply(sampleNames(frames), function(sn)range(frames[[sn, use.exprs = FALSE]])[, channel.name])
    xl <- range(ranglist, finite=TRUE)
    list(xlim=xl + c(-1,1)*0.07*diff(xl))   
}


## add a barchart indicating the margin events
mbar <- function(dat, p, r, i, col, m)
{
    rl <- r + c(-1,1)*min(100, 0.06*diff(r))
    off <- min(5, 0.005*diff(r))
    lx <- length(dat)
    des <- -20
    fac <- 0.7
    for(j in seq_along(p)){
        sp <- sum(p[[j]], na.rm=TRUE)
        if(sp > lx*m)
        {
            panel.segments(rl[j], i, rl[j], i+fac, col="gray")
            panel.lines(rep(rl[j],2), c(i, i+(sp/lx*fac)),
                        col=desat(col, des), lwd=4)
            panel.segments(rl[j]-off, i, rl[j]+off, i, col="gray")
            panel.segments(rl[j]-off, i+fac, rl[j]+off, i+fac, col="gray")

        }
    }
}


    
## Dedicated panel function to do the plotting and add gate boundaries
#' @param overlay see help(xyplot).
#' 
#' @param overlap The amount of overlap between stacked density plots. This
#' argument is ignored for the \code{flowFrame} method.
#' 
#' @param filter A \code{\link[flowCore:filter-class]{filter}},
#' \code{\link[flowCore:filterResult-class]{filterResult}} or
#' \code{\link[flowCore:filterResult-class]{filterResultList}} object or a list
#' of such objects of the same length as the \code{flowSet}. If applicable, the
#' gate region will be superiposed on the density curves using color shading.
#' The software will figure out whether the \code{filter} needs to be evaluated
#' in order to be plotted (in which case providing a \code{filterResult} can
#' speed things up considerably).
#' 
#' @param groups Use identical colors for grouping. The value of the argument
#' is expected to be a phenotypic variable in the \code{flowSet}, or a factor.
#' 
#' 
#' @param subscripts,which.channel,channel.name,y Internal indices necessary to
#' map panels to parameters.
#' 
#' @param frames An environment containing frame-specific data.
#' @param channel The name of the currently plotted flow parameter.
#' @param darg These arguments are passed unchanged to the corresponding
#' methods in lattice, and are listed here only because they provide different
#' defaults.  See documentation for the original methods for details.
#' \code{darg} gets passed on to \code{\link[stats]{density}}.
#' @param col,fill,lty,lwd,alpha Graphical parameters. These mostly exist for
#' conveniance and much more control is available throught the
#' \code{lattice}-like \code{par.setting} and \code{flowViz.par.set}
#' customization. The relevant parameter category for density plots is
#' \code{gate.density} with available parameters \code{col}, \code{fill},
#' \code{lwd}, \code{alpha} and \code{lty}. See
#' \code{\link[flowViz:flowViz.par.get]{flowViz.par.set}} for details.
#' @param refline Logical. Add one ore more vertical reference lines to the
#' plot.  This argument is directly passed to
#' \code{\link[lattice:panel.functions]{panel.abline}}.
#' @param margin Either Logical value 'FALSE' or Numeric valuein \code{[0,1]}.
#' When 'FALSE', it doesn't do anything to the margin events.  When Numeric
#' value, it indicates margin events by horizontal bars. The value of
#' \code{margin} is interpreted as the proportion of events on the margin over
#' which the bars are added. E.g., a value of \code{0,5} means to indicate
#' margin events if there are more than \code{0.5} times the total number of
#' events. \code{1} means to ignore margin events completetly. For \code{0}
#' bars are added even if there is only a single margin event.
#' @param stats,pos,digits,abs Arguments to control statistics that is
#' associated with \code{\link[flowCore:filter-class]{filter}} to be plotted.
#' see \link[flowViz]{xyplot} for details.
#' @param fitGate A \code{logical} scalar indicating whether to display the
#' gate as fitted 1d density gate region or simply display the gate boundaries
#' using vertical lines. The latter would be helpful to display the gate when
#' the gated density region is too small to see.
#' @param checkName A \code{logical} scalar indicating whether to validity
#' check the channel name. Default is TRUE, which consider '(' as invalid
#' character in channel names
#' @param gp A list of graphical parameters that are passed down to the low
#' level panel functions. This is for internal use only. The public user
#' interface to set graphical parameters is either \code{par.settings} for
#' customization of a single call or \code{flowViz.par.set} for customization
#' of session-wide defaults.
#' @param plotType either 'densityplot' or 'histogram'
#' @param hist.type see 'type' argument in 'help(panel.histogram)'
#' @param breaks see 'help(hist)' 
#' @importFrom stats approxfun cor density median ppoints qnorm quantile qunif var
#' @export
#' @rdname densityplot
panel.densityplot.flowset.stack <-
    function(x, y, darg=list(n=50, na.rm=TRUE), frames, channel,
             overlap = 0.3, channel.name, filter=NULL,
             fill=superpose.polygon$col,
             lty=superpose.polygon$lty,
             lwd=superpose.polygon$lwd,
             alpha=superpose.polygon$alpha,
             col=superpose.polygon$border,
             groups=NULL, refline=NULL,
             margin=0.005
			 ,stats=FALSE
			 ,pos=0.5
			 ,digits=2
			 ,abs=FALSE
			 ,fitGate=TRUE
             ,checkName = TRUE
             , plotType = "densityplot"
             , hist.type = "density"
             , breaks = "Sturges"
             ,gp, ...)
{
    which.channel <- tail(which.packet(), 1)
    
    lc <- length(channel)
    channel <- channel[[which.channel]]
    channel.name <- channel.name[which.channel]
    ycode <- as.numeric(y)
    validName <- !length(grep("\\(", channel.name))
    if(checkName)
      validName <- !(length(grep("\\(", channel.name)) ||
            length(grep("\\(", channel.name)))
    else
      validName <- TRUE
    
    if(!validName)
      warning("Gate will not be plotted because channel names contain '(' character! Try to set checkName to FALSE to skip this check.")

    if (any(duplicated(ycode)))
        warning("Some combinations seem to have multiple samples.  \n  ",
                "Only one will be used.")
    nnm <- as.character(x)
    filter <- .processFilter(filter, nnm, lc = lc, which.channel = which.channel)  
    ny <- nlevels(y)
	superpose.polygon <- flowViz.par.get("superpose.polygon")
    border <- rep(col, length = ny)
    col <- rep(fill, length = ny)
    if(!is.null(groups))
        col <- col[groups]
    lty <- rep(lty, length = ny)
    lwd <- rep(lwd, length = ny)
    alpha <- rep(alpha, length = ny)
    x <- as.character(x)
    height <- (1 + overlap)
    parm <- gsub("`", "", as.character(channel))
	ptList<-plotType("gdensity", parm)
    for (i in rev(seq_len(ny))){
        if (i %in% ycode)
        {
            nm <- x[match(i, ycode)]
            xx <- evalInFlowFrame(channel, frames[[nm]])
            r <- unlist(range(frames[[nm]])[, channel.name])
            
            if(!is.logical(margin)||isTRUE(margin))#when margin is logical FALSE we skip marginal events filtering
            {
              margin <- min(1, max(0, margin))
              pl <- xx<=r[1]
              pr <- xx>=r[2]
              xxt <- xx[!(pl | pr)]
              ## we indicate piled up data by vertical lines (if > 1%) unless
              ## margin=FALSE
              if(margin<1)
                  mbar(xx, list(pl, pr), r, i, col[i], margin)
              }else
                xxt <- xx
            ## we need a smaller bandwidth than the default and keep it constant
            if(length(xxt)){
                
                if(plotType == "densityplot"){
                  #densityplot
                  if(!("adjust" %in% names(darg)))
                    darg[["adjust"]] <- 2
                  h <- do.call(density, c(list(x=xxt), darg))
                  x.val <- h$x
                  y.val <- h$y
                  n <- length(x.val)
                }else{
                  fitGate <- FALSE
                  #histogram
                  h <- lattice:::hist.constructor(xxt, breaks = breaks, ...)
                  y.val <- switch(hist.type, count = h$counts, percent = 100 * h$counts/length(x), density = h$density)
                  x.val <- h$breaks
                  n <- length(x.val)
                  if (length(y.val) != n - 1) 
                    warning("problem with 'hist' computations")
                }

                max.d <- max(y.val)
                xl <- x.val[c(1, 1:n, n)]
                yl <- i + height * c(0, y.val, 0) / max.d
                
                if(plotType == "densityplot")
                  panel.polygon(x=xl,y=yl, col=col[i], border=NA, alpha=alpha[i])
                else
                  panel.rect(x = xl[-n], y = 0, height = yl, width = diff(xl), 
                      col = col[i], alpha = alpha[i], border = border[i], just = c("left", "bottom"), identifier = "histogram")
                
                ## add the filterResult if possible, we get them from the output of
                ## glpolygon (with plot=FALSE)
				
                if(!is.null(filter[[nm]]) && validName){
                  curFilter <- filter[[nm]]
                  
                  if(is.list(stats))
                    curStats <- stats[[nm]]
                  else
                    curStats <- stats
#                browser()
                if(is(curFilter,"filters"))
                {
                  mapply(curFilter,curStats,FUN=function(thisFilter,thisStats){
                         names <- .getStats(thisFilter,thisStats, frames[[nm]], digits, ...)
                        

                        #this plot routine is only for 2-d scatter plot
                        #thus set plot as FALSE,just use it to get bounds
                        #add plot stats/names
                        bounds <- glpolygon(thisFilter, frames[[nm]],
                            channels=parm
                            ,ptList=ptList
                            ,verbose=FALSE
                            , plot=FALSE 
                            ,names=names
                            ,xlim=r
                            ,ylim=c(i,i+1)
                            ,strict=FALSE)
                        oo <- options(warn=-1)
                        on.exit(options(oo))
                        if(any(!is.na(bounds))){
                          ## iterate over gate regions
                          for(j in seq_along(bounds)){
                            if(any(!is.na(bounds[[j]]))){
                              tb <- bounds[[j]]
                              if(fitGate)
                              {
                                if(ncol(tb) == 1 && colnames(tb) == parm){
                                  sel <- xl >= min(tb) & xl <= max(tb)
                                  if(any(sel)){
                                    afun <- approxfun(xl, yl)
                                    xr <- c(min(tb), seq(min(tb), max(tb), len=100),
                                            max(tb))
                                    yr <- c(i, afun(xr[-c(1, length(xr))]), i)
                                    gpd<-gp$gate.density
                                    panel.polygon(xr, yr
                                                  , border=gpd$col, col=gpd$fill,
                                                  alpha=gpd$alpha, lwd=gpd$lwd,
                                                  lty=gpd$lty
                                    )
                                  }
                                }	
                              }else
                              {
                                gpg<-gp$gate
                                panel.lines(x=c(tb[1],tb[1]),y=c(i,i+height)
                                            ,col=gpg$col,alpha=gpg$alpha, lwd=gpg$lwd,lty=gpg$lty)
                                panel.lines(x=c(tb[2],tb[2]),y=c(i,i+height)
                                            ,col=gpg$col,alpha=gpg$alpha, lwd=gpg$lwd,lty=gpg$lty)
                              }
                            }
                          }
                        }
                        
                        
                        
                        options(oo)
                      })
                }else
                {
					curFilter<-filter[[nm]]
#					browser()
                    if(is.list(stats))
                      thisStats <- stats[[nm]]
                    else
                      thisStats <- stats
                    names <- .getStats(curFilter,thisStats, frames[[nm]], digits, ...)
					
#					browser()
					#this plot routine is only for 2-d scatter plot
					#thus set plot as FALSE,just use it to get bounds
					#add plot stats/names
                    bounds <- glpolygon(curFilter, frames[[nm]],
                                        channels=parm
										,ptList=ptList
                                        ,verbose=FALSE
										, plot=FALSE 
										,names=names
										,xlim=r
										,ylim=c(i,i+1)
										,strict=FALSE)
                    oo <- options(warn=-1)
                    on.exit(options(oo))
                    if(any(!is.na(bounds))){
                        ## iterate over gate regions
                        for(j in seq_along(bounds)){
                          if(any(!is.na(bounds[[j]]))){
                            tb <- bounds[[j]]
                            if(fitGate)
                            {
                              if(ncol(tb) == 1 && colnames(tb) == parm){
                                sel <- xl >= min(tb) & xl <= max(tb)
                                if(any(sel)){
                                  afun <- approxfun(xl, yl)
                                  xr <- c(min(tb), seq(min(tb), max(tb), len=100),
                                          max(tb))
                                  yr <- c(i, afun(xr[-c(1, length(xr))]), i)
                                  gpd<-gp$gate.density
                                  panel.polygon(xr, yr
                                                , border=gpd$col, col=gpd$fill,
                                                alpha=gpd$alpha, lwd=gpd$lwd,
                                                lty=gpd$lty
                                  )
                                }
                              }	
                            }else
                            {
                              gpg<-gp$gate
                              panel.lines(x=c(tb[1],tb[1]),y=c(i,i+height)
                                          ,col=gpg$col,alpha=gpg$alpha, lwd=gpg$lwd,lty=gpg$lty)
                              panel.lines(x=c(tb[2],tb[2]),y=c(i,i+height)
                                          ,col=gpg$col,alpha=gpg$alpha, lwd=gpg$lwd,lty=gpg$lty)
                            }
                          }
                        }
                    }
					
					
					
                    options(oo)
                }
               }
#				browser()
                panel.lines(x=xl,y=yl, col=border[i], lty=lty[i],lwd=lwd[i])

            }else{
                panel.lines(rl, rep(i,2), col="black")
            }
			
        }
    }
    if(!is.null(refline))
        panel.abline(v=refline)
}


prepanel.densityplot.flowset <- 
    function(x, frames, channel.x.name, xlim ,margin = TRUE, hist.type = "density", breaks = "sturges", ...)
{
  if (length(nm <- as.character(x)) > 1)
    stop("must have only one flow frame per panel")
  
  if (length(nm) == 1){
    ranges <- range(frames[[nm]])
    if(missing(xlim)){
      #use default calculation
      xlim <- if(!length(grep("`", channel.x.name, fixed=TRUE))){
            tmp <- ranges[, channel.x.name]
            xd <- diff(tmp)/15
            tmp + c(-1,1)*xd
          }else NULL
    }
    
    if(hist.type %in% c("count", "percent")){
      #run hist to estimate the max count
      data <- as.vector(exprs(frames[[nm, channel.x.name]]))
      
      if(margin){
        r <- ranges[, channel.x.name]
        pl <- data<=r[1]
        pr <- data>=r[2]
        data <- data[!(pl | pr)]  
      }
      h <- lattice:::hist.constructor(data, breaks = breaks, ...)
      y.val <- switch(hist.type, count = h$counts, percent = 100 * h$counts/length(data), density = h$density)
      ylim = c(0, max(y.val))
    }else
      ylim = c(0,1)#when hist.type = density, y will be normalized to c(0,1), thus no need to compute ylim  
    return(list(xlim=xlim, ylim = ylim))
  }else
    return(list())
}

panel.densityplot.flowset <- function(x,
    frames,
    filter = NULL,
    channel.x,
    channel.y
    ,stats = FALSE
    , overlay= NULL#a list of flowSet
    ,...)
{
  
  nm <- as.character(x)
  if (length(nm) < 1) return()
  
  filter <- .processFilter(filter, nm)
  
  if(!is.list(stats)){
    stats <- lapply(seq_along(nm), function(x) stats)
    names(stats) <- nm
    
  }
  
  overlay <- .process_overlay_flowSet(overlay, nm)
  
  panel.densityplot.flowFrame(frame=frames[[nm]], filter=filter[[nm]], stats = stats[[nm]], overlay = overlay, ...)
}
panel.densityplot.flowFrame <-
    function(frame,
        darg=list(n=50, na.rm=TRUE),
        filter=NULL,
        margin=0.005,
        outline=FALSE,
        channel.x.name,
        channel.y.name,
        fill= "#619CFF",
        lty= 1,
        lwd= 1,
        alpha= 1,
        col= "transparent",
        gp
        ,stats = FALSE
        ,pos=0.5
        ,digits=2
        ,abs=FALSE
        ,fitGate=TRUE
        ,refline=NULL
        ,checkName = TRUE
        , overlay = NULL
        , overlay.symbol = NULL
        , plotType = "densityplot"
        , hist.type = "density"
        , breaks = "Sturges"
        ,...
        )
{
          
  
          
          validName <- !length(grep("\\(", channel.x.name))
          if(checkName)
            validName <- !(length(grep("\\(", channel.x.name)) ||
                  length(grep("\\(", channel.y.name)))
          else
            validName <- TRUE
          
          if(!validName)
            warning("Gate will not be plotted because channel names contain '(' character! Try to set checkName to FALSE to skip this check.")
          border <- col
          parm <- channel.x.name
          ptList<-plotType("gdensity", parm)
         
          xx <- exprs(frame)[,channel.x.name]
          r <- unlist(range(frame)[, channel.x.name])
          
          ## we ignore data that has piled up on the margins
          rl <- r + c(-1,1)*min(100, 0.06*diff(r))
          if(!is.logical(margin)||isTRUE(margin))#when margin is logical FALSE we skip marginal events filtering
          {
            margin <- min(1, max(0, margin))
            pl <- xx<=r[1]
            pr <- xx>=r[2]
            xxt <- xx[!(pl | pr)]
            ## we indicate piled up data by vertical lines (if > 1%) unless
            ## margin=FALSE
            if(margin<1)
              mbar(xx, list(pl, pr), r, 1, col, margin)
          }else
            xxt <- xx
          if(length(xxt)){
            if(plotType == "densityplot"){
              #densityplot
              if(!("adjust" %in% names(darg)))
                darg[["adjust"]] <- 2
              
              h <- do.call(density, c(list(x=xxt), darg))
              x.val <- h$x
              y.val <- h$y
              n <- length(x.val)
            }else{
              fitGate <- FALSE
              #histogram
              h <- lattice:::hist.constructor(xxt, breaks = breaks, ...)
              y.val <- switch(hist.type, count = h$counts, percent = 100 * h$counts/length(xxt), density = h$density)
              x.val <- h$breaks
              n <- length(x.val)
              if (length(y.val) != n - 1) 
                warning("problem with 'hist' computations")
            }
            
            max.d <- max(y.val)
            xl <- x.val[c(1, 1:n, n)]
            yl <- c(0, y.val, 0)
            if(hist.type == "density")
              yl <- yl / max.d
            
            if(plotType == "densityplot")
              panel.polygon(x=xl,y=yl, col=fill, border=NA, alpha=alpha)
            else
              panel.rect(x = xl[-n], y = 0, height = yl, width = diff(xl), 
                  col = fill, alpha = alpha, border = col, just = c("left", "bottom"), identifier = "histogram")
                        
#             browser()           
            if(!is.null(overlay))
            {
              overlayNames <- names(overlay)
              for(overLayName in overlayNames){
                thisOverlay <- overlay[[overLayName]]
                if(!is.null(thisOverlay)){
                  thisDat <- exprs(thisOverlay)
                  overlay.x <- thisDat[, channel.x.name]
                  
                  
                  this.overlay.symbol <- gp$overlay.symbol#default setting
                  user.overlay.symbol <- overlay.symbol[[overLayName]]#customized settings
                  #update the default with customized settings
                  if(!is.null(user.overlay.symbol))
                    this.overlay.symbol <- lattice:::updateList(this.overlay.symbol, overlay.symbol[[overLayName]])
#                browser()                
                  h <- do.call(density, c(list(x=overlay.x), darg))
                  n <- length(h$x)
                  
                  xl_overlay <- h$x[c(1, 1:n, n)]
                  yl_overlay <- c(0, h$y, 0) / max(h$y) 
                  
                  
                  panel.polygon(x=xl_overlay,y=yl_overlay 
                      ,  border=NA
                      , col = this.overlay.symbol[["fill"]]
                      , alpha = this.overlay.symbol[["alpha"]]
                  
                  )  
                }
                
              }
              
            }                        
            ## add the filterResult if possible, we get them from the output of
            ## glpolygon (with plot=FALSE)
            if(!is.null(filter) && validName){    
              if(is(filter,"filters"))
              {
                fitGate <- FALSE #it is hard to plot multiple fitted gates
                
                mapply(filter,stats,FUN=function(curFilter,curStats){
                      
#                      browser()
                      names <- .getStats(curFilter,curStats, frame, digits, ...)
                      
                      
                      #this plot routine is only for 2-d scatter plot
                      #thus set plot as FALSE,just use it to get bounds
                      #add plot stats/names
                      bounds <- glpolygon(curFilter, frame,
                          channels=parm
                          ,ptList=ptList
                          ,verbose=FALSE
                          , plot=FALSE 
                          ,names=names
                          ,xlim=r
                          ,ylim=c(0,1)
                          ,strict=FALSE)
                      oo <- options(warn=-1)
                      on.exit(options(oo))
                      if(any(!is.na(bounds))){
                        ## iterate over gate regions
                        for(j in seq_along(bounds)){
                          if(any(!is.na(bounds[[j]]))){
                            tb <- bounds[[j]]
                            gpg<-gp$gate
                            panel.lines(x=c(tb[1],tb[1]),y=c(0,1)
                                        ,col=gpg$col,alpha=gpg$alpha, lwd=gpg$lwd,lty=gpg$lty)
                            panel.lines(x=c(tb[2],tb[2]),y=c(0,1)
                                        ,col=gpg$col,alpha=gpg$alpha, lwd=gpg$lwd,lty=gpg$lty)
                          }
                        }
                      }
                      
                      options(oo)
                    })
              }else
              {
                  names <- .getStats(filter,stats, frame, digits, ...)
                  
        
                  #this plot routine is only for 2-d scatter plot
                  #thus set plot as FALSE,just use it to get bounds
                  #add plot stats/names
                  bounds <- glpolygon(filter, frame,
                      channels=parm
                      ,ptList=ptList
                      ,verbose=FALSE
                      , plot=FALSE 
                      ,names=names
                      ,xlim=r
                      ,ylim=c(0,1)
                      ,strict=FALSE)
                  oo <- options(warn=-1)
                  on.exit(options(oo))
                  if(any(!is.na(bounds))){
                    ## iterate over gate regions
                    for(j in seq_along(bounds)){
                      if(any(!is.na(bounds[[j]]))){
                        tb <- bounds[[j]]
                        if(fitGate)
                        {
                          tb_min <- min(tb)
                          tb_max <- max(tb)
                          
                          tb_min <- max(min(xl),tb_min)
                          tb_max <- min(max(xl),tb_max)
                          if(ncol(tb) == 1 && colnames(tb) == parm){
                            sel <- xl >= tb_min & xl <= tb_max
                            if(any(sel)){
                              afun <- approxfun(xl, yl)
                              xr <- c(tb_min, seq(tb_min, tb_max, len=100), tb_max)
                              #                        browser()
                              yr <- c(0,afun(xr[-c(1, length(xr))]),0)
                              gpd<-gp$gate.density
                              panel.polygon(xr, yr
                                            , border=gpd$col
                                            , col=gpd$fill,
                                            alpha=gpd$alpha, lwd=gpd$lwd,
                                            lty=gpd$lty
                              )
                            }
                          }	
                        }else
                        {
                          gpg<-gp$gate
                          panel.lines(x=c(tb[1],tb[1]),y=c(0,1)
                                      ,col=gpg$col,alpha=gpg$alpha, lwd=gpg$lwd,lty=gpg$lty)
                          panel.lines(x=c(tb[2],tb[2]),y=c(0,1)
                                      ,col=gpg$col,alpha=gpg$alpha, lwd=gpg$lwd,lty=gpg$lty)
                        }
                      }
                    }
                  }
                  
                  
                  
                  options(oo)
              }
            }

            panel.lines(x=xl,y=yl, col=border, lty=lty,lwd=lwd)
    
          }else{
            panel.lines(rl, rep(0,2), col="black")
          }
      if(!is.null(refline))
        panel.abline(v=refline)
}

analyzeDensityFormula <- function(x, dot.names)
{
    ans <- list()
    if (length(x) == 2) {
        ans$left <- FALSE
        x <- x[[2]]
    }
    else if (length(x) == 3) {
        ans$left <- TRUE
        ans$left.symbol <- x[[2]]
        x <- x[[3]]
    }
    else stop("unexpected formula structure")
    if (length(x) == 1) {
        ans$conditioned <- FALSE
        ans$multiple.right <- FALSE
        ans$right.symbol <- x
    }
    else if (length(x) == 3) {
        switch(as.character(x[[1]]),
               "+" = {
                   ans$conditioned <- FALSE
                   ans$multiple.right <- TRUE
                   ans$right.symbol <- x
               },
               "|" = {
                   ans$conditioned <- TRUE
                   ans$cond.symbol <- x[[3]]
                   ans$right.symbol <- x[[2]]
                   ans$multiple.right <-
                       (length(x[[2]]) > 1 &&
                        as.character(x[[2]][[1]]) == "+")
               })
    }
    else stop("unexpected formula structure")
    if (ans$multiple.right) {
        x <- ans$right.symbol
        right.comps <- list()
        while ((length(x) > 1) && (as.character(x[[1]]) == "+")) {
            right.comps <- c(list(x[[3]]), right.comps)
            x <- x[[2]]
        }
        ans$right.comps <- c(list(x), right.comps)
    }
    else if (length(ans$right.symbol) == 1 && as.character(ans$right.symbol) == ".") {
        ans$multiple.right <- TRUE
        ans$right.comps <- lapply(dot.names, as.symbol)
    }
    else ans$right.comps <- list(ans$right.symbol)
    ans
}




# dispatch to different trellis object contructing function based on stack argument
# param: stack \code{logical} indicating whether to stack `name` on y axis
.densityplot.adapor <- function(x, data, stack = TRUE, plotType = "densityplot", ...){
  
      plotType <- match.arg(plotType, c("densityplot", "histogram"))
      if(stack)
        thisObj <- .densityplot.flowSet.stack(x, data, plotType = plotType, ...)
      else
      {
    
        #add dummy y term in order to use .xyplot.flowSet to construct lattice object
        if(length(x[[2]]) == 1)
          xTerm <- x[[2]]
        else
          xTerm <- x[[2]][[2]]
        thisFormula <- eval(substitute(thisX~y, list(thisX = xTerm)))
        thisFormula[[3]] <- x[[2]]
        thisObj <- .xyplot.flowSet(thisFormula, data
            , panel = panel.densityplot.flowset
            , prepanel = prepanel.densityplot.flowset
            , ylab = ""
            , plotType = plotType
            ,...)
        #append channel.name to work ncdfFlow::densityplot
        thisObj$panel.args.common$channel.name <- thisObj$panel.args.common$channel.x.name
      }
      thisObj
}

.densityplot.flowSet.stack <- function(x, data, channels, xlab,
                   as.table = TRUE, overlap = 0.3,
                   prepanel = prepanel.densityplot.flowset.stack,
                   panel = panel.densityplot.flowset.stack,
                   filter=NULL, scales=list(y=list(draw=F)),
                   groups, axis= axis.grid
#                    , marker.only = FALSE
                    , ...)
      {
          ocall <- sys.call(sys.parent())
          ccall <- match.call(expand.dots = TRUE)
          
          
          if(! "name" %in% names(pData(data)))
              pData(data)$name <- sampleNames(data)
          pd <- pData(phenoData(data))
          uniq.name <- createUniqueColumnName(pd)
          ## ugly hack to suppress warnings about coercion introducing
          ## NAs (needs to be `undone' inside prepanel and panel
          ## functions):
          pd[[uniq.name]] <-
              factor(sampleNames(data),
                     levels=unique(sampleNames(data))) 
          if (missing(channels))
              channels <-
                  setdiff(colnames(data),
                          flowCore:::findTimeChannel(data))

          formula.struct <- analyzeDensityFormula(x, dot.names = channels)
          ## we want to add a column to pd for each channel, repeating
          ## pd as necessary.  We might want to skip this if there is
          ## only one channel, but for now we'll use it for
          ## conditioning even then.

          channel.name <-
              sapply(formula.struct$right.comps, expr2char)
          
          frm <- data[[1, use.exprs = FALSE]]
          xObjs <- sapply(channel.name,  getChannelMarker, frm = frm, simplify = FALSE)
          channel.name <- sapply(xObjs, "[[", "name")
          formula.struct$right.comps <- lapply(channel.name, function(i)as.symbol(i))
          
          
          pd <- rep(list(pd), length(channel.name))
#          browser()
#          if(marker.only){
#            names(pd) <-  sapply(xObjs, function(xObj)as.character(ifelse(is.na(xObj[,"desc"]), xObj[,"name"], xObj[,"desc"])))
#               
#          }else{
#            names(pd) <-  sapply(xObjs, function(xObj)sub("NA","",paste(unlist(xObj),collapse=" "))) 
#          }
          names(pd) <- channel.name
          pd <- do.call(lattice::make.groups, pd)
          ## FIXME: this won't work if pd already has a column named
          ## 'which'.  Should deal with that case somehow.

          ## Next task is to manipulate the formula.  The details of
          ## the transformation depends on whether there is a
          ## conditioning variable alread.
          ## y ~ channel ==> y ~ sample | which
          ## y ~ channel | var ==> y ~ sample | which + var

         
          new.x <- d1 ~ d2 | d3
          new.x[[2]] <- ## d1
              if (formula.struct$left) formula.struct$left.symbol
              else as.name("name")
          new.x[[3]][[2]] <- ## d2
              as.name(uniq.name)
          new.x[[3]][[3]] <- ## d3
              if (formula.struct$conditioned) {
                  ans <- (~.+.)[[2]]
                  ans[[3]] <- as.name("which")
                  ans[[2]] <- formula.struct$cond.symbol
                  ## probably not the ideal order, but I don't see how
                  ## to easily ake 'which' the first conditioning
                  ## variable (in case there is more than one
                  ## conditioning variable to begin with)
                  ans
              }
              else as.name("which")
          if (missing(xlab))
              xlab <- ""
            
          gp <- list(...)[["par.settings"]]
          gpar <- flowViz.par.get()
          if(!is.null(gp))
              gpar <- lattice:::updateList(gpar, gp)
          if(!missing(groups))
              ccall$groups <- as.factor(eval(substitute(groups), pData(data)))
          ccall$gp <- gpar
          ccall$x <- new.x
          ccall$data <- pd
          ccall$prepanel <- prepanel
          ccall$panel <- panel
          ccall$par.settings <- gpar
          ccall$channel <- formula.struct$right.comps ## channel
          ## That is super ugly!!! How do we get to the channel name
          ## from the formula???
          ccall$channel.name <- gsub("^.*\\(`|`\\).*$", "", channel.name)
          ccall$frames <- data
          ccall$as.table <- as.table
          overlap <- max(-0.5, overlap)
          ccall$overlap <- overlap
          ccall$axis <- axis
          ccall$xlab <- xlab
          ccall$horizontal <- TRUE
          ccall$subscripts <- TRUE
          ccall$default.scales <- list(x = list(relation = "free"))
          ccall$which.channel <-
              gsub("^.*\\(`|`\\).*$", "", as.character(pd$which))
          ypad <- lattice.getOption("axis.padding")$numeric * (length(data) + overlap)
          ccall$lattice.options <-
              list(axis.padding = list(factor = c(ypad, ypad + 1 + overlap)))
          ccall[[1]] <- quote(lattice::bwplot)
          ans <- eval.parent(ccall)
          ans$call <- ocall
          ans
      }



#' @export
#' @rdname  densityplot
setMethod("densityplot",
          signature(x="formula", data="flowFrame"),
          function(x, data, overlay = NULL, ...){
            sn <- identifier(data)
            data <- as(data, "flowSet")
            sampleNames(data) <- sn
            
            overlay <- .process_flowFrame_overlay(overlay, sn)
                        
            densityplot(x, data, overlap = 0, scales = list(y=list(draw=FALSE)), overlay = overlay, ...)              
          })


#' @export
#' @rdname  densityplot
setMethod("densityplot",
          signature(x="formula", data="view"),
          function(x, data, ...) densityplot(x, Data(data), ...))


#override flowSet-version methods to pass data instead of data@frames
#' @aliases densityplot,formula,ncdfFlowSet-method
#' @rdname densityplot
#' @export 
setMethod("densityplot",
          signature(x = "formula", data = "ncdfFlowSet"),
          function(x, data, ...)
          {
            #construct lattice object
            thisTrellisObj <- .densityplot.adapor(x, data, ...)
            #subset data on channel
            chnl <- thisTrellisObj[["panel.args.common"]][["channel.name"]]
            thisData <- thisTrellisObj[["panel.args.common"]][["frames"]]
            thisData <- thisData[,chnl]
            #update frames
            thisTrellisObj[["panel.args.common"]][["frames"]] <- thisData
            thisTrellisObj
          })



#' @aliases densityplot,formula,ncdfFlowList-method
#' @rdname densityplot
setMethod("densityplot",
          signature(x = "formula", data = "ncdfFlowList"),
          function(x, data, ...)
          {
            selectMethod("densityplot", signature = c("formula", "ncdfFlowSet"))(x, data, ...)
          })

## ----setup, include=FALSE-----------------------------------------------------
library(knitr)
opts_chunk$set(out.extra='style="display:block; margin: auto"', fig.align="center", message = FALSE, warning = FALSE, knitr.table.format = "markdown")
assign("depthtrigger", 60, data.table:::.global)

## ----loadPackage, echo=FALSE,results='hide'-----------------------------------
library(flowViz)
library(flowStats)

## ----loadData-----------------------------------------------------------------
library(flowViz)
data(GvHD)
head(pData(GvHD))

## ----subsetLattice, eval=FALSE------------------------------------------------
# xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD,
#        subset=Patient=="6")

## ----subsetFlowCore-----------------------------------------------------------
GvHD <- GvHD[pData(GvHD)$Patient==6]

## ----transform----------------------------------------------------------------
tf <- transformList(from=colnames(GvHD)[3:7], tfun=asinh)
GvHD <- tf %on% GvHD

## ----simpleRG, fig=TRUE, include=FALSE, echo=TRUE, prefix=FALSE, height=4.5, width=8----
rgate <- rectangleGate("FSC-H"=c(0, 400),"SSC-H"=c(-50, 300))
print(xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD, filter=rgate))

## ----threeDRG-----------------------------------------------------------------
rgate2 <- rgate * rectangleGate("FL1-H"=c(2, 4))
xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD, filter=rgate2)

## ----nonSmoothScatter---------------------------------------------------------
xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD, filter=rgate, smooth=FALSE)

## ----hexbinScatter------------------------------------------------------------
xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD, filter=rgate, smooth=FALSE,xbin=128)

## ----plotnonSmoothScatter, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=4.5, width=8----
print(plot(trellis.last.object()))

## ----nonSmoothScatterOutline--------------------------------------------------
xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD, filter=rgate,
smooth=FALSE, stat=TRUE,pos=0.5,abs=TRUE)

## ----multi-filters------------------------------------------------------------
recGate1<-rectangleGate("FL4-H"=c(3.3,5.3),"FL2-H"=c(2.5,5))
recGate2<-rectangleGate("FL4-H"=c(4,6),"FL2-H"=c(6,8))
filters1<-filters(list(recGate1,recGate2))
xyplot(`FL2-H` ~ `FL4-H`
	   ,data=GvHD[[1]]
       ,filter=filters1
       ,stat=TRUE
       ,margin=FALSE
       )	

## ----plotnonSmoothScatterOutline, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=4.5, width=8----
print(plot(trellis.last.object()))

## ----nonSmoothScatterOutline2-------------------------------------------------
xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD, filter=rgate2,
       smooth=FALSE, outline=TRUE)

## ----plotnonSmoothScatter2, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=4.5, width=8----
print(plot(trellis.last.object()))

## ----norm2Filter--------------------------------------------------------------
n2Filter <- norm2Filter("SSC-H", "FSC-H", scale=2, filterId="Lymphocytes")
n2Filter.results <- filter(GvHD, n2Filter)
xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD, filter=n2Filter.results)

## ----plotnorm2Filter, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=4.5, width=8----
print(plot(trellis.last.object()))

## ----curv2Filter--------------------------------------------------------------
library(flowStats)
c2f <- curv2Filter("FSC-H", "FL4-H", bwFac=1.8)
c2f.results <- filter(GvHD, c2f)
xyplot(`FL4-H` ~ `FSC-H` | Visit, data=GvHD, filter=c2f.results)

## ----plotcurv2Filter, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=4.5, width=8----
print(plot(trellis.last.object()))

## ----densityplots-------------------------------------------------------------
densityplot(~ `FSC-H`, GvHD, filter=curv1Filter("FSC-H"))

## ----plotdensityplots, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=4.5, width=8----
print(plot(trellis.last.object()))

## ----multDensityplots---------------------------------------------------------
densityplot(~ ., GvHD, channels=c("FSC-H", "SSC-H", "FL1-H"), 
filter=list(curv1Filter("FSC-H"), NULL, rgate2))

## ----plotmultDensityplots, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=4, width=8----
print(plot(trellis.last.object()))

## ----Pars1--------------------------------------------------------------------
xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD, filter=rgate,
       par.settings=list(gate=list(fill="black", alpha=0.2)))

## ----plotPars1, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=4.5, width=8----
print(plot(trellis.last.object()))

## ----plotPars2, eval=FALSE----------------------------------------------------
# flowViz.par.set(gate=list(fill="black", alpha=0.2))
# xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD, filter=rgate)

## ----Pars3--------------------------------------------------------------------
xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD, filter=rgate,
       smooth=FALSE, 
       par.settings=list(gate=list(col="orange", alpha=0.04,
                                   pch=20, cex=0.7),
                         flow.symbol=list(alpha=0.04, pch=20, cex=0.7)))

## ----plotPars3, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=4.2, width=8----
print(plot(trellis.last.object()))

## ----Pars4--------------------------------------------------------------------
xyplot(`FL4-H` ~ `FSC-H` | Visit, data=GvHD, filter=c2f.results,
par.settings=list(gate=list(fill=rainbow(10), alpha=0.5, col="transparent")))

## ----plotPars4, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=4.5, width=8----
print(plot(trellis.last.object()))

## ----norm2FilterNames---------------------------------------------------------
xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD, filter=n2Filter.results, 
       names=TRUE, 
       par.settings=list(gate=list(fill="black", alpha=0.2, 
                                   col="transparent"),
                         gate.text=list(col="darkred", alpha=0.7, cex=0.6)))

## ----plotnorm2FilterNames, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=4.5, width=8----
print(plot(trellis.last.object()))

## ----parCoord-----------------------------------------------------------------
parallelplot(~ . | Visit, GvHD, filter=n2Filter.results, alpha = 0.01)

## ----plotparCoord, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=6, width=8----
print(plot(trellis.last.object()))

#' Standard Plots for Flow Cytometry Data
#' 
#' A method that makes standard plots from a \code{flowFrame}. The user may
#' also provide various \code{filter} or \code{filterResult} arguments to
#' customize the plot.
#' 
#' The plot that is most commonly used in flow cytometry data analysis is
#' usuall called a "dot plot". In common statistical language, we would call
#' this a scatter plot. The basic idea is a 2-dimensional plot that shows the
#' location of every cell in regard to the measurements made on it, for
#' example, forward scatter vs side scatter. Most applications will, in
#' addition to the data, want to show information about one or more filters
#' (gates). Since there can be a very large number of cells in a sample, it is
#' common to show a smoothed version of the data that doesn't involve
#' registering every point on the graph.
#' 
#' @name flowPlot
#' @aliases flowPlot flowPlot,flowFrame-method
#' @docType methods
#' @param x An object of class \code{flowFrame} that contains the data to be
#' plotted.
#' @param child An optional argument of class \code{filterResult} that
#' specifies a subset of the data that are included in the \code{filterResult}
#' @param filter A \code{filter}, \code{filterResult} or
#' \code{filterResultList} object.
#' @param plotParameters A vector of charactors defining the x and y variables
#' in terms of columns in the data.
#' @param logx,logy Logical controlling wheterh the corresponding variables
#' will be log transfromed before passing to the panel function. Default to
#' \code{FALSE}.
#' @param parent An optional argument of class \code{filterResult} that
#' specifies a subset of the data that are inclueed in the \code{filterResult}.
#' @param colParent Specifying the color for \code{parent}. See \code{parent}
#' above.
#' @param colChild Specifies the color for \code{child}. See \code{chile}
#' above.
#' @param showFilter Logical, specifying whether to show the \code{filter}.
#' @param gate.fill Specifies the fill color of the gate. Default to
#' \code{transparent}.
#' @param gate.border Character or specifying the color of the gate border.
#' Default to \code{black}.
#' @param xlab,ylab Labels for data axes.
#' @param xlim,ylim Numeric vectors of length 2 specifying axis limits.
#' @param \dots More arguments, usually passed on to the underlying lattice
#' methods.
#' @author P. Haaland
#' @seealso \code{\link[flowCore:flowCore-package]{flowCore}}
#' @keywords methods
#' @examples
#' 
#' library(flowCore)
#' data(GvHD)
#' flowPlot(GvHD[["s5a01"]])
#' flowPlot(transform("SSC-H"=asinh,"FSC-H"=asinh) %on% GvHD[["s5a01"]])
#' 
#' 
#' @export 
setMethod("flowPlot",
          ## basic plot without a gate specified
          signature(x="flowFrame"),
          function(x, child, filter=NULL, plotParameters=c("FSC-H","SSC-H"),
          	logx=FALSE,logy=FALSE,
          	parent,colParent="Grey",colChild="Blue",
          	showFilter=TRUE,gate.fill="transparent",gate.border="black",
          	xlab,ylab,xlim,ylim,...){
            data <- exprs(x)
            ncells <- nrow(data)
            if(missing(xlab)){
              if(is.character(plotParameters)){
                xlab <-  plotParameters[1]
              }
              else {
                xlab <-  colnames(data)[plotParameters[1]]
              }
            }
            if(missing(ylab)){
              if(is.character(plotParameters)){
                ylab <-  plotParameters[2]
              }
              else {
                ylab <-  colnames(data)[plotParameters[2]]
              }
            }
            ## check for the parent. If it is a filterResult get the parentSet
            if(missing(parent)) {
   				## if the parent is missing assume that it is all cells
				selectParent = rep(TRUE,ncells)
 			}
			else {  	
				if(class(parent) != "logicalFilterResult") {
					stop("parent must be of class filterResult.")
				}
				else {
					if(is.null(parent@subSet)) {
						stop("The filterResult parent must have a subSet slot.")
					}
					else {
						selectParent = parent@subSet
					}  	
				}
			}
			## get the data and log if necessary
			xd =    data[selectParent,plotParameters[1]]
            yd =    data[selectParent,plotParameters[2]]   
            if(logx) {
            	xd[xd <=1] = 1
            	xd = log(xd,base=10)
            }
          	if(logy) {
          		yd[yd <=1] = 1
              	yd = log(yd,base=10)
              }

            ## the default limits are going to be 0,1 or the range of the data
            if(missing(xlim)) {
              	if(max(xd) <= 1.0) {
              		xlim = c(0,1)
              	}
              	else {
              		xlim <-  range(xd)
              	}
              }
              if(missing(ylim)) {
              	if(max(yd) <= 1.0) {
              		ylim = c(0,1)
              	}
              	else {
                	ylim <-  range(yd)
                }
              }

            if(missing(child)) {  
            
             
              smoothScatter(xd,yd,nrpoints=100,
                            xlim=xlim,
                            ylim=ylim,
                            xlab=xlab,
                            ylab=ylab,
                            transformation=function(x) x^(1/1),
                            colramp = colorRampPalette(c("white",rev(rainbow(14))[-(1:3)])),                 
                            ...)       
            }
            else {
              ## check for y and if it is a filterResult, get the subSet
              if(class(child) != "logicalFilterResult") {
                stop("child must be of class filterResult.")
              }
              else {
                if(is.null(child@subSet)) {
                  stop("The filterResult child must have a subSet slot.")
                }
                else {
                  selectChild <-  child@subSet
                }
              }
              ## check for the proper relationship between the parent and child
              ## if that is OK then we need to keep only the parts of child relevant to the parent
#              if(any(selectChild>selectParent)) {
#                stop("The child population must be contained in the parent population.")
#              }
#              else {
               	selectChild = selectChild[selectParent]
               	selectParent = rep(TRUE,length=length(selectChild))
#              }
              selectUnfiltered <- ((selectParent & !selectChild))

              plot(xd[selectChild],yd[selectChild],
                   xlab=xlab,
                   ylab=ylab,
                   xlim=xlim,
                   ylim=ylim,
                   type="n",
                   ...)
              ## filtered population
              points(xd[selectChild],yd[selectChild],col=colChild,...)
              ## unfiltered population
              points(xd[selectUnfiltered],yd[selectUnfiltered],col=colParent,...)
              if(showFilter){
              	childFilter = child@filterDetails[[1]]$filter
              	if(class(childFilter) == "subsetFilter") {
              		childFilter = childFilter@left
              	}
             	if(class(childFilter) == "rectangleGate") {
             		## a simple range gate, note that it may be possible that the graph
             		## isn't based on the parameters of the gate in which case the 
             		## gate won't show
             		if(length(childFilter@parameters)==1){
             			if(childFilter@parameters==plotParameters[1]) {
             				abline(v=childFilter@min,col=gate.border)
             				abline(v=childFilter@max,col=gate.border)
             			}
             			else if(childFilter@parameters==plotParameters[2]) {
             				abline(h=childFilter@min,col=gate.border)
             				abline(h=childFilter@max,col=gate.border)
             			}
             		}
             		## the classic rectangle
             		else if(length(childFilter@parameters)==2) {
             			## check to be sure the parameters actually match
             			if(all(childFilter@parameters %in% plotParameters)) {
             				rectends = c(childFilter@min[plotParameters[1]],childFilter@min[plotParameters[2]],childFilter@max[plotParameters[1]],childFilter@max[plotParameters[2]])
             				## draw the rectangles out to the boundaries if -Inf or Inf appears
             				if(rectends[1] == -Inf) {
             					rectends[1] = xlim[1]
             				}
             				if(rectends[2] == -Inf) {
             					rectends[2] = ylim[1]
             				}
             				if(rectends[3] == Inf) {
             					rectends[3] = xlim[2]
             				}
             				if(rectends[4] == -Inf) {
             					rectends[4] = ylim[2]
             				}
             				rect(rectends[1],rectends[2],rectends[3],rectends[4],col=gate.fill,border=gate.border,...)	
             			}
             		}
				}
# require(ellipse)
#				if(!is.null(attr(parentFilter@subSet,"center"))){
#				elps <- ellipse(x=attr(parentFilter@subSet,"cov"),centre=attr(parentFilter@subSet,"center"))
#				lines(elps)
#			}
#				if(!missing(ellCov)) {
#					elps <- ellipse(x=attr(parentFilter@subSet,"cov"),centre=attr(parentFilter@subSet,"center"))
#					lines(elps)
# 				}
					
 
              }
            }
          }
)

### Some utilities (used by the lattice methods, at least)


## needed for nice labels.  deparse() can potentially give results
## with length > 1
expr2char <- function(x) paste(deparse(x), collapse = "")

##return a formatted stats for display
.getStats <- function(curFilter,curStats,frame, digits, as.is = FALSE, ...){
  popNames<-identifier(curFilter)
  if(is.numeric(curStats)){#stats is explicitly provided
    show.stats <- TRUE
    stats <- curStats
  }else if(is.logical(curStats))#stats needs to be computed on the fly
  {
    
    if(curStats)
    {
      if (!is(curFilter, "filterResult")) 
        curFilter <- filter(frame, curFilter)
      curFres<-curFilter
      if(is(curFres, "multipleFilterResult")){
        ind <- lapply(seq_along(curFres), function(x) as(curFres[[x]], "logical"))
        count <- lapply(ind, sum)                         
        p.stats <- lapply(seq_along(ind), function(x) count[[x]]/length(ind[[x]]))
        stats <-p.stats
        names(stats) <- names(curFres)
      }else{
        ind <- as(curFres, "logical")
        count <- sum(ind)                         
        p.stats <- count/length(ind)
        stats <-p.stats
      }
      show.stats <- TRUE 
    }else
      show.stats <- FALSE
  }
  
  #parse names argument (gate name)
  names<-list(...)$names
  if(is.null(names))
    names<-FALSE

  #format stats when applicable
  if(show.stats)
  {
    if(is.numeric(unlist(stats))){
      if(as.is)
        stats <- as.character(stats)
      else{
        if(is.list(stats)){
          stats <- lapply(names(stats), function(x)
            paste(x,": ", format(stats[[x]]*100,digits=digits),"%",sep=""))
        }else{
          stats <- paste(format(stats*100,digits=digits),"%",sep="")   
        }
      }
    }
    #cat gate name if asked
    if(names)
    {
      stats <- paste(basename(popNames), stats, sep = "\n")
    }
    names(stats)<-rep(popNames, length(stats))
  }else
    stats <- names
  stats
}
evalInFlowFrame <- function(expr, envir, enclos = baseenv())
{
    expr <- as.expression(expr)
    flowFrame2env <- function(ff)
    {
        ## function to convert a flowframe into an environment, so we
        ## can subsequently eval() things in it.  FIXME: defining this
        ## inside hoping for some scope advantage, which may not be
        ## real

        ffdata <- exprs(ff)
        e <- new.env()
        cn <- colnames(ff)
        for (i in seq_along(cn))
        {
            e[[ cn[i] ]] <- ffdata[, i]
        }
        e
    }

    ## FIXME: this copies things, which is potentially bad.  Options
    ## to explore are (1) do thing in C, which may turn out to be not
    ## too bad (2) do things on a limited number of rows at a time

    eval(expr, flowFrame2env(envir), enclos)
}


createUniqueColumnName <- function(x)
{
    make.unique(c(names(x), "sample"))[ncol(x) + 1]
}




## mysterious match.call() stuff not understood all that well by the
## author (but bad things happen without them, trust me)...        
manipulate.call <- function(ocall, ccall)
    ## ocall: call actually made by user
    ## ccall: result of match.call(expand.dots = FALSE)
    ## ccall will be modified and returned
{

    ## need to replace things in ccall$"..." with correspondingly
    ## named things in ocall, because language objects get replaced by
    ## ..1, ..2 etc which are never recovered (something to do with
    ## method dispatch)

    if (is.null(ccall$"...")) return(ccall) ## else
    dotnames <- names(ccall$"...")
    if ("" %in% dotnames)
    {
        stop("Unnamed arguments cannot be matched formal arguments")
    }
    ccall$"..." <- NULL
    ccall[dotnames] <- ocall[dotnames]
    ccall
}



## Lighten up or darken colors
desat <- function(col, by=50)
{
    rgbcol <- col2rgb(col)
    up <- max(rgbcol-255)
    down <- min(rgbcol)
    if(by>0)
        rgbcol <- rgbcol + min(by, up)
    if(by<0)
        rgbcol <- rgbcol - min(abs(by), down)
    return(rgb(rgbcol[1,], rgbcol[2,], rgbcol[3,], maxColorValue=255))
}

#' @export 
#' @rdname densityplot
setMethod("histogram",
    signature(x = "formula", data = "flowSet"),
    function(x, data, plotType, ...){
      densityplot(x, data, plotType = "histogram", ...)              
    })

#' @rdname densityplot
#' @aliases histogram,formula,flowFrame-method
setMethod("histogram",
          signature(x="formula", data="flowFrame"),
          function(x, data, ...){
            densityplot(x, data, plotType = "histogram", ...)              
          })

#override flowSet-version methods to pass data instead of data@frames
#' @aliases histogram,formula,ncdfFlowSet-method
#' @rdname densityplot
#' @export 
setMethod("histogram",
          signature(x = "formula", data = "ncdfFlowSet"),
          function(x, data, ...)
          {
            densityplot(x, data, plotType = "histogram", ...)
            
          })

#' @aliases histogram,formula,ncdfFlowList-method
#' @rdname densityplot
setMethod("histogram",
          signature(x = "formula", data = "ncdfFlowList"),
          function(x, data, ...)
          {
            selectMethod("histogram", signature = c("formula", "ncdfFlowSet"))(x, data, ...)
          })
      

## ==========================================================================
## Draw points within a gate  on an existing plot. All graphical
## parameters will be passed on to lpoints in the end, so
## these are basically extended lpoints methods for gates and filters.
## We need to evaluate a filter to plot points (unless we pass a
## filterResult) and we always need the data to plot, hence the methods
## always dispatch on filters (or filteResults since
## they inherits from filter) and on a flowFrame.
## The optional channels argument can be used to pass along
## the plotting parameters, and it takes precendence over everything else.
## FIXME: Need to figure out how to make points a generic without masking
##        the default function



#' Adding points within a gate to a plot
#' 
#' These methods extend the lattice \code{\link[lattice:llines]{lpoints}}
#' methods for drawing of points contained within a
#' \code{\link[flowCore:filter-class]{filter}}. They allow for multiple
#' dispatch, since not all \code{\link[flowCore:filter-class]{filter}} types
#' need to be evaluated for plotting, but this decision should be made
#' internally. In any case, we need the raw data in the form of a
#' \code{\link[flowCore:flowFrame-class]{flowFrame}}.
#' 
#' When plotting \code{\link[flowCore:flowFrame-class]{flowFrame}}s using the
#' \code{plot} method provided by \code{flowViz}, the plotted parameters are
#' recorded, which makes it possible to correctly overlay the points within
#' \code{\link[flowCore:filter-class]{filter}}s assuming that they are defined
#' for the respective parameters. Warnings and error will be cast for the cases
#' where the parameters are non-distinct or ambigious. These methods are meant
#' to be used within lattice panel functions and are probably not of much use
#' outside of those.
#' 
#' @name glpoints-methods
#' @aliases glpoints glpoints-methods
#' glpoints,curv1Filter,flowFrame,character-method
#' glpoints,curv2Filter,flowFrame,character-method
#' glpoints,filter,flowFrame,missing-method glpoints,filter,missing,ANY-method
#' glpoints,filterResult,flowFrame,character-method
#' glpoints,kmeansFilter,flowFrame,character-method
#' glpoints,norm2Filter,flowFrame,character-method
#' glpoints,polygonGate,flowFrame,character-method
#' glpoints,quadGate,flowFrame,character-method
#' glpoints,rectangleGate,flowFrame,character-method
#' glpoints,ellipsoidGate,flowFrame,character-method
#' glpoints,filterResult,flowFrame,ANY-method
#' glpoints,subsetFilter,flowFrame,ANY-method
#' @docType methods
#' @section Methods:
#' 
#' \describe{
#' 
#' \item{x = "filter", data = "flowFrame", channels = "missing"}{ General
#' method for all objects inheriting from
#' \code{\link[flowCore:filter-class]{filter}}. This is used as the default
#' when no more explicit method is found. It tries to find the plotted
#' parameters from the internal \code{flowViz.state} environment. This only
#' works if the flow data has been plotted using the \code{plot} methods
#' provided by this \code{flowViz} package. }
#' 
#' \item{x = "filter", data = "missing", channels = "ANY"}{ This gives a useful
#' error message when we don't get what we need. }
#' 
#' \item{x = "filterResult", data = "flowFrame", channels = }{ We can get all
#' the information about a \code{\link[flowCore:filter-class]{filter}} from its
#' \code{\link[flowCore:filterResult-class]{filterResult}} without the need to
#' re-evaluate.}\item{ "character"}{ We can get all the information about a
#' \code{\link[flowCore:filter-class]{filter}} from its
#' \code{\link[flowCore:filterResult-class]{filterResult}} without the need to
#' re-evaluate.}
#' 
#' \item{x = "curv1Filter", data = "ANY"}{ We either need a
#' \code{\link[flowCore:filterResult-class]{filterResult}} or the raw data as a
#' \code{\link[flowCore:flowFrame-class]{flowFrame}} for
#' \code{\link[flowStats:curv1Filter-class]{curv1Filter}}s. }
#' 
#' \item{x = "curv1Filter", data = "flowFrame"}{ see above }
#' 
#' \item{x = "curv1Filter", data = "missing"}{ see above }
#' 
#' \item{x = "curv1Filter", data = "multipleFilterResult"}{ see above }
#' 
#' \item{x = "curv2Filter", data = "ANY"}{ We either need a
#' \code{\link[flowCore:filterResult-class]{filterResult}} or the raw data as a
#' \code{\link[flowCore:flowFrame-class]{flowFrame}} for
#' \code{\link[flowStats:curv2Filter-class]{curv2Filter}}s.}
#' 
#' \item{x = "curv1Filter", data = "flowFrame", channels = }{ We evaluate the
#' \code{\link[flowCore:filter-class]{filter}} on the
#' \code{\link[flowCore:flowFrame-class]{flowFrame}} and plot the subset of
#' selected points. By default, every subpopulation (if there are any) is
#' colored differently.}\item{ "character"}{ We evaluate the
#' \code{\link[flowCore:filter-class]{filter}} on the
#' \code{\link[flowCore:flowFrame-class]{flowFrame}} and plot the subset of
#' selected points. By default, every subpopulation (if there are any) is
#' colored differently.}
#' 
#' \item{x = "curv2Filter", data = "flowFrame", channels = "character"}{ see
#' above }
#' 
#' \item{x = "kmeansFilter", data = "flowFrame", channels = }{ see above
#' }\item{ "character"}{ see above }
#' 
#' \item{x = "norm2Filter", data = "flowFrame", channels = }{ see above }\item{
#' "character"}{ see above }
#' 
#' \item{x = "polygonGate", data = "flowFrame", channels = }{ see above }\item{
#' "character"}{ see above }
#' 
#' \item{x = "quadGate", data = "flowFrame", channels = "character"}{ see above
#' }
#' 
#' \item{x = "rectangleGate", data = "flowFrame", channels = }{ see above
#' }\item{ "character"}{ see above }
#' 
#' \item{x = "ellipsoidGate", data = "flowFrame", channels = }{ see above
#' }\item{ "character"}{ see above }
#' 
#' }
#' @author F. Hahne
#' @seealso
#' 
#' \code{\link[flowCore:filter-class]{filter}},
#' \code{\link[flowCore:flowFrame-class]{flowFrame}}, \code{\link{glpolygon}}
#' @keywords methods
#' @export
#' @param x filter, filterResult or any derived filter class
#' @param data flowFrame or missing
#' @param channels character or missing
#' @param verbose logical
#' @param filterResult filterResult class
#' @param ... other arguments
setMethod("glpoints",
          signature(x="filter", data="flowFrame", channels="missing"), 
          function(x, data, channels, verbose=TRUE,
          filterResult=NULL, ...)
      {
          glpoints(x=x, data=data, channels=parms, verbose=verbose,
                   filterResult=filterResult, strict=strict, ...)
      })

## Extract the filter definiton from a filterResult and pass that on
## along with it. We decide later if we really need it or not.
setMethod("glpoints",
          signature(x="filterResult", data="flowFrame", channels="ANY"), 
          function(x, data, channels, verbose=TRUE,
                   filterResult=NULL, ...)
      {
          checkIdMatch(x=x, f=data)
          filterResult <- x
          fd <- filterDetails(x)
          x <- fd[[length(fd)]]$filter
          if(missing(channels))
              glpoints(x=x, data=data, verbose=verbose,
                       filterResult=filterResult, ...)
          else
              glpoints(x=x, data=data, channels=channels,
                       verbose=verbose, filterResult=filterResult, ...)
      })    

## A useful error message when we don't get what we need.
setMethod("glpoints",
          signature(x="filter", data="missing", channels="ANY"), 
          function(x, data, channels, ...)
          stop("Need the 'flowFrame' in order to add points.", call.=FALSE))




## ==========================================================================
## for rectangleGates
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## Only warning that we don't use the filterResult, the rest is pretty
## much the default.
setMethod("glpoints",
          signature(x="rectangleGate", data="flowFrame", channels="character"), 
          function(x, data, channels, verbose=TRUE, filterResult=NULL,
                   gpar=flowViz.par.get(), names=FALSE, ...)
      {
          if(!is.null(filterResult))
              dropWarn("filterResult", "rectangleGates", verbose=verbose)
          addLpoints(x=x, data=data, channels=channels, verbose=verbose,
                     filterResult=NULL, gpar=gpar$gate, ...)
          ## add names if necessary
          addName(x, names, channels, gpar$gate.text,...)
      })




## ==========================================================================
## for ellipsoidGates
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## We convert to a polygon gate and pass that on
setMethod("glpoints",
          signature(x="ellipsoidGate", data="flowFrame", channels="character"), 
          function(x, data, channels, verbose=TRUE, filterResult=NULL,
                   gpar=flowViz.par.get(), names=FALSE, ...)
      {
          xe <- as(x, "polygonGate")
          if(!is.null(filterResult))
              dropWarn("filterResult", "ellipsoidGates", verbose=verbose)
          addLpoints(x=xe, data=data, channels=channels, verbose=verbose,
                     filterResult=NULL, gpar=gpar$gate, ...)
          addName(x, names, channels, gpar$gate.text,...)
      })



## ==========================================================================
## for quadGates
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## We plot this as four individual rectangle gates.
setMethod("glpoints",
          signature(x="quadGate", data="flowFrame", channels="character"), 
          function(x, data, channels, verbose=TRUE, filterResult=NULL,
                   gpar=flowViz.par.get(), names=FALSE, strict=TRUE, ...)
      {
          if(!is.null(filterResult))
              dropWarn("filterResult", "quadGates", verbose=verbose)
          v <- x@boundary[channels[1]]
          h <- x@boundary[channels[2]]
          mat <- matrix(c(-Inf, v, h, Inf, v, Inf, h, Inf, -Inf, v, -Inf,
                          h, v, Inf, -Inf, h), byrow=TRUE, ncol=4)
          ## we want to be able to use different colors for each population
          col <- rep(gpar$gate$col, 4)
          for(i in 1:4){
              gpar$gate$col <- col[i]
              rg <- rectangleGate(.gate=matrix(mat[i,], ncol=2,
                                               dimnames=list(c("min", "max"),
                                                             channels)))
              glpoints(x=rg, data=data, channels=channels, verbose=FALSE,
                       gpar=gpar, ...)
              addName(x, names, data, gp=gpar$gate.text,...)
          }
      })




## ==========================================================================
## for polygonGates
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## Only warning that we don't use the filterResult, the rest is pretty
## much the default.
setMethod("glpoints",
          signature(x="polygonGate", data="flowFrame", channels="character"), 
          function(x, data, channels, verbose=TRUE,
                   filterResult=NULL, gpar=flowViz.par.get(), names=FALSE,
                   ...)
      {
          if(!is.null(filterResult))
              dropWarn("filterResult", "polygonGates", verbose=verbose)
          addLpoints(x=x, data=data, channels=channels, verbose=verbose,
                     filterResult=NULL, gpar=gpar$gate, ...)
          addName(x, names, channels, gp=gpar$gate.text,...)
      })




## ==========================================================================
## for norm2Filters
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## We don't need to re-evaluate the filter if the filterResult is used,
## so no need for a warning here.
setMethod("glpoints",
          signature(x="norm2Filter", data="flowFrame", channels="character"), 
          function(x, data, channels, verbose=TRUE, filterResult=NULL,
                   names=FALSE, ...)
      {
          if(is.null(filterResult))
              filterResult <- filter(data, x)
          checkFres(filter=x, fres=filterResult, verbose=verbose)
          fd <- filterDetails(filterResult, identifier(x))
          np <- norm2Polygon(fd, parameters(x))
          identifier(np) <- identifier(x)
          glpoints(x=np, data=data, channels=channels, verbose=FALSE,
                   names=names, ...)
      })







## ==========================================================================
## for kmeansFilters
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## This filter produces a multipleFilterResult, so we can't subset directly.
## Instead, we split the original frame and plot each component separately
setMethod("glpoints",
          signature(x="kmeansFilter", data="flowFrame", channels="character"), 
          function(x, data, channels, verbose=TRUE,
                   filterResult=NULL, gpar=flowViz.par.get(), names=FALSE,
                   ...)
      {
          if(is.null(filterResult))
              filterResult <- filter(data, x)
          multFiltPoints(x=x, data=data, channels=channels, verbose=verbose,
                            filterResult=filterResult, gpar=gpar$gate, ...)
          addName(x, names, split(data[,channels], filterResult),
                  gp=gpar$gate.text,...)
      })




# ==========================================================================
## for subsetFilter
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## For now we just plot the top-level filter.
## FIXME: We may want to be able to plot all filters
setMethod("glpoints",
          signature(x="subsetFilter", data="flowFrame", channels="ANY"), 
          function(x, data, channels, ...)
      {
          glpoints(x@filters[[1]], data, channels, ...)
      })






          

## A nasty hack to get the current parameters that are plotted which need to
## be passed on to panel.xyplot.flowframe
panel.splom.flowframe <- function(x,
                                  frame,
                                  ...)
{
    cv <- current.viewport()$name
    dims <- as.numeric(strsplit(cv, ".", fixed=TRUE)[[1]][2:3])
    cn <- colnames(frame)
    channel.x.name <- cn[dims[1]]
    channel.y.name <- cn[dims[2]]
    ranges <- range(frame)
    xlim <- if(!length(grep("`", channel.x.name, fixed=TRUE))){
        tmp <- ranges[, channel.x.name]
        xd <- diff(tmp)/15
        tmp + c(-1,1)*xd
    }else NULL
    ylim <- if(!length(grep("`", channel.y.name, fixed=TRUE))){
        tmp <- ranges[, channel.y.name]
        yd <- diff(tmp)/15
        tmp + c(-1,1)*yd
    }else NULL
    
    panel.xyplot.flowframe.old(x=x, channel.x.name=channel.x.name,
                           channel.y.name=channel.y.name, frame=frame
				   			,xlim=xlim,ylim=ylim
                           ,...)
}


#' Method implementing Lattice scatter plot matrices for flow data.
#' 
#' 
#' This function create Trellis scatter plots matrices (splom) from flow
#' cytometry data.
#' 
#' 
#' The function draws a scatter plot matrix of the data for each flow parameter
#' in a \code{flowFrame}. For the most, one can think about this as a
#' rectangular arrangement of separate \code{\link[flowViz:xyplot]{xyplots}},
#' and most of that functionality is also available here. To be more precise,
#' the function repeatedly calls \code{panel.xyplot.flowframe} to do the actual
#' plotting. Please see its documentation for details.
#' 
#' @name splom
#' @aliases splom splom,flowFrame,missing-method panel.splom.flowframe
#' @docType methods
#' @param x A formula describing the structure of the plot and the variables to
#' be used in the display.
#' @param data A \code{\link[flowCore:flowFrame-class]{flowFrame}} object
#' that serves as the source of data.
#' @param pscales This arguments is passed unchanged to the corresponding
#' methods in lattice, and is listed here only because it provides a different
#' default.  See documentation for the original methods for details.
#' @param time A character string giving the name of the data column recording
#' time. If not provided, we try to guess from the available parameters.
#' @param exclude.time Logical, specifying whether to exclude the time variable
#' from a scatter plot matrix. Defaults to \code{TRUE}.
#' @param names Logical specifying wether gate names should be added to the
#' plot. Currently, this feature is not supported for splom plots.
#' @param \dots More arguments, usually passed on to the underlying lattice
#' methods.
#' @author F. Hahne, D. Sarkar
#' @seealso
#' 
#' Not all standard lattice arguments will have the intended effect, but many
#' should.  For a fuller description of possible arguments and their effects,
#' consult documentation on lattice.
#' @keywords methods dplot
#' @examples
#' 
#' library(flowCore)
#' data(GvHD)
#' library(flowStats)
#' 
#' tf <- transformList(colnames(GvHD)[3:7], asinh)
#' dat <- tf %on% GvHD[[3]]
#' 
#' 
#' ## scatter plot matrix of individual flowFrames
#' lattice.options(panel.error=NULL)
#' splom(dat)
#' 
#' splom(dat[,1:3], smooth = FALSE)
#' 
#' 
#' ## displaying filters
#' rg <- rectangleGate("FSC-H"=c(200,400), "SSC-H"=c(300,700),
#' "FL1-H"=c(2,4), "FL2-A"=c(4,7))
#' splom(dat, filter=rg)
#' 
#' splom(dat, filter=rectangleGate("FSC-H"=c(400,800)))
#' 
#' splom(dat[,1:4], smooth = FALSE, filter=norm2Filter("FSC-H", "SSC-H", scale=1.5))
#' 
#' 
#' 
#' @export 
setMethod("splom",
          signature=signature(x="flowFrame", data="missing"),
          definition=function(x,
                              data, 
                              pscales,
                              time,
                              exclude.time=TRUE,
                              names=FALSE,
                              ...)
      {
          if(names){
              warning("Filter names are currently not supported for ",
                      "splom plots.", call.=FALSE)
              names=FALSE
          }
          if(missing(pscales))
             pscales <- lapply(range(x), function(x) list(limits=x, at=numeric(0)))
          gp <- list(...)[["par.settings"]]
          expr <- exprs(x)
          column.names <- colnames(expr)
          ## guess the time parameter and exclude if necessary
          expr <- exprs(x)
          if(missing(time))
              time <- flowCore:::findTimeChannel(expr)
          if(exclude.time && length(time))
              column.names <- column.names[column.names != time]
          splom(exprs(x[, column.names]),
                pscales=pscales, 
                panel=panel.splom.flowframe,
                frame=x,
                gp=gp,
                names=names,
                ...)
      })

## Add gate names to a flowViz plot.
## These methods add gate names to a \code{flowViz} plot, either derived from
## the population identifiers or as provided by the user. These methods are
## ment for internal use and are usually not called directly by the user.
## 
#' Add gate names to a flowViz plot.
#' 
#' 
#' These methods add gate names to a \code{flowViz} plot, either derived from
#' the population identifiers or as provided by the user. These methods are
#' ment for internal use and are usually not called directly by the user.
#' 
#' 
#' @name addName-methods
#' @aliases addName addName-methods addName,curv1Filter,character-method
#' addName,curv1Filter,logical-method addName,curv2Filter,character-method
#' addName,curv2Filter,logical-method addName,ellipsoidGate,character-method
#' addName,ellipsoidGate,logical-method addName,kmeansFilter,character-method
#' addName,kmeansFilter,logical-method addName,polygonGate,character-method
#' addName,polygonGate,logical-method addName,quadGate,character-method
#' addName,quadGate,logical-method addName,quadGate,matrix-method
#' addName,rectangleGate,character-method addName,rectangleGate,logical-method
#' @docType methods
#' @return The methods are called for their side effects. No value is returned.
#' @section Methods: \describe{
#' 
#' \item{x = "curv1Filter", name = "character"}{ User-provided names. }
#' 
#' \item{x = "curv1Filter", name = "logical"}{ Get names from the
#' \code{\link[flowCore:filter-class]{filter}} or
#' \code{\link[flowCore:filterResult-class]{filterResult}} object}
#' 
#' \item{x = "curv2Filter", name = "character"}{ see above }
#' 
#' \item{x = "curv2Filter", name = "logical"}{ see above }
#' 
#' \item{x = "ellipsoidGate", name = "character"}{ see above }
#' 
#' \item{x = "ellipsoidGate", name = "logical"}{ see above }
#' 
#' \item{x = "kmeansFilter", name = "character"}{ see above }
#' 
#' \item{x = "kmeansFilter", name = "logical"}{ see above }
#' 
#' \item{x = "polygonGate", name = "character"}{ see above }
#' 
#' \item{x = "polygonGate", name = "logical"}{ see above }
#' 
#' \item{x = "quadGate", name = "character"}{ see above }
#' 
#' \item{x = "quadGate", name = "logical"}{ see above }
#' 
#' \item{x = "quadGate", name = "matrix"}{ see above }
#' 
#' \item{x = "rectangleGate", name = "character"}{ see above }
#' 
#' \item{x = "rectangleGate", name = "logical"}{ see above }
#' 
#' }
#' @author F. Hahne
#' @keywords methods
#' @export 
#' @param x rectangleGate, ellipsoidGate, quadGate, polygonGate or kmeansFilter
#' @param name character or logical or matrix
#' @param data flowFrame
#' @param gp a list of graphical parameters
#' @param pos,abs specifying location of the name. see 'help(xyplot)' for more details
#' @param xlim,ylim limits of axis
#' @param ... other arguments
setMethod("addName",
          signature(x="rectangleGate", name="character"), 
          function(x, name, data, gp,pos=0.5,abs=FALSE,xlim,ylim,...)
      {
#		  browser()
          parms <- parameters(x)
          
		  

		  
          ## 1D rectangular gate (region gate).
          if(length(parms)==1){
              mt <- match(parms, data)
              if(mt==1){
				  xx<-c(x@min,x@max)
				  yy <- ylim
              }else if(mt==2){
				  yy<-c(x@min,x@max)
				  xx <- xlim
              }else stop("How did you end up here????")
          }else{## 2D rectangular gate   
              bl <- x@min[data]
              tr <- x@max[data]
			  xx<-c(bl[1], tr[1])
			  yy<-c(bl[2], tr[2])
#              gltext(mean(xx), mean(yy), labels=name, adj=0.5, gp=gp)
          }
		  
		  if(abs)#plot label whithin the boundary by default 
		  {
			  xx<-xlim
			  yy<-ylim
		  }else #specify location by absolute position of the current window
		  {
			  
			  xx<-fixBound_addName(xx,xlim)
			  yy<-fixBound_addName(yy,ylim)
		  }
		  pos <- rep(pos, length=2)[1:2]
		  xx<-xx[1]+diff(xx)*pos[1]
		  yy<-yy[1]+diff(yy)*pos[2]
          		  
		  gltext(xx, yy, labels=name, adj=0.5, gp=gp)
          return(invisible())
      })


setMethod("addName",
          signature(x="rectangleGate", name="logical"), 
          function(x, name, ...)
      {
          if(name)
              addName(x, paste(identifier(x), "+", sep=""), ...)
          else
              return(invisible())
      })



## ==========================================================================
## for ellipsoidGates
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## 'names' either uses population names generated by the filter
## or can be a character provided by the user.
setMethod("addName",
          signature(x="ellipsoidGate", name="character"), 
          function(x, name, data, gp,...)
      {
          gltext(x@mean[data[1]], x@mean[data[2]], labels=name, adj=0.5, gp=gp)
          return(invisible())
      })

setMethod("addName",
          signature(x="ellipsoidGate", name="logical"), 
          function(x, name, ...)
      {
          if(name)
              addName(x, paste(identifier(x), "+", sep=""), ...)
          else
              return(invisible())
      })



## ==========================================================================
## for quadGates
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## 'names' either uses population names generated by the filter
## or can be a character provided by the user.
setMethod("addName",
          signature(x="quadGate", name="matrix"), 
          function(x, name, data, gp,xlim,ylim,...)
      {
          v <- x@boundary[data[1]]
          h <- x@boundary[data[2]]
          
          yoff <- diff(ylim)/50
          trans <- match(colnames(name)[1], data)-1
          if(trans)
              name <- matrix(c(name[2,2], name[2,1], name[1,2],
                                name[1,1]), ncol=2)
          gltext(c(mean(c(xlim[1], v)), mean(c(v, xlim[2]))),
                 rep(ylim[2], 2)-yoff, labels=name[1,],
                 adj=c(0.5, 1), gp=gp)
          gltext(c(mean(c(xlim[1], v)), mean(c(v, xlim[2]))),
                 rep(ylim[1], 2)+yoff, labels=name[2,],
                 adj=c(0.5, 0), gp=gp)
          return(invisible())
      }) 

setMethod("addName",
          signature(x="quadGate", name="logical"), 
          function(x, name, data, ...)
      {
          if(name){
              desc <- flowCore:::popNames(data, x)
              names <- matrix(c(sprintf("%s-%s+", desc[1], desc[2]),
                                sprintf("%s-%s-", desc[1], desc[2]),
                                sprintf("%s+%s+", desc[1], desc[2]),
                                sprintf("%s+%s-", desc[1], desc[2])),
                              ncol=2)
              colnames(names) <- names(desc)
              data <- checkParameterMatch(parameters(x), verbose=FALSE,...)
              addName(x, names, data, ...)
          }else
          return(invisible())
      })
    
setMethod("addName",
          signature(x="quadGate", name="character"), 
          function(x, name, data, ...)
      {
          desc <- flowCore:::popNames(data, x)
          data <- checkParameterMatch(parameters(x), verbose=FALSE,...)
          names <- matrix(rep(name, 4)[4:1], ncol=2, dimnames=list(NULL, data))
          colnames(names) <- names(desc)
          addName(x, names, data, ...)
          return(invisible())
      })



## ==========================================================================
## for polygonGates
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## 'names' either uses population names generated by the filter
## or can be a character provided by the user.
setMethod("addName",
          signature(x="polygonGate", name="character"), 
          function(x, name, data, gp,pos=0.5,abs=FALSE,xlim,ylim,...)
      {
		  
		  
		  if(abs)#plot label whithin the boundary by default 
		  {
			  xp<-xlim
			  yp<-ylim
		  }else #specify location by absolute position of the current window
		  {
			  xp <- range(x@boundaries[,data[1]])
			  yp <- range(x@boundaries[,data[2]])
			  xp<-fixBound_addName(xp,xlim)
			  yp<-fixBound_addName(yp,ylim)
		  }
		  pos <- rep(pos, length=2)[1:2]
		  
  		  xp<-xp[1]+diff(xp)*pos[1]
		  yp<-yp[1]+diff(yp)*pos[2]
	  		 
          
          gltext(xp, yp, labels=name, adj=0.5, gp=gp)
          return(invisible())
      })

setMethod("addName",
          signature(x="polygonGate", name="logical"), 
          function(x, name, ...)
      {
          if(name)
              addName(x, paste(identifier(x), "+", sep=""), ...)
          else
              return(invisible())
      })



## ==========================================================================
## for kmeansFilter
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## 'names' either uses population names generated by the filter
## or can be a character provided by the user.
setMethod("addName",
          signature(x="kmeansFilter", name="character"), 
          function(x, name, data, gp, ...)
      {
          chan <- checkParameterMatch(parameters(x), verbose=FALSE,...)
          loc <- sapply(data, function(x) colMeans(exprs(x)[,chan]))
          gltext(loc[1,], loc[,2], labels=name, adj=0.5, gp=gp)
          return(invisible())
      })

setMethod("addName",
          signature(x="kmeansFilter", name="logical"), 
          function(x, name, data, ...)
      {
          if(name)
              addName(x, names(data), data=data, ...)
          else
              return(invisible())
      })

## ==========================================================================
## a simple plot method without strange plot parameter and friends. It does
## the most intuitive thing: take a flowFrame and do a pairs plot if there
## are more than 2 parameters. Do a smoothScatter plot for exactly 2
## parameters and a histogram for exactly one.
## If you want to plot specific columns, subset the frame before
## plotting or specify them in the y argument.
## We record parameters of the plot in the internal flowViz.state environment
## which will later be useful to figure out the plotting parameters when
## adding gate outlines to a plot
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

## helper function to do the actual plotting
fplot <- function(x, smooth, pch, xlim, ylim = NULL, ...)
{
    values <- exprs(x)
    sel <- tolower(colnames(values)) != "time"
#    flowViz.state[["plotted"]] <- TRUE
    if(missing(pch))
        pch <- "."
    l <- ncol(values)
    if(l==1){
        if (missing(xlim))
            xlim <- unlist(range(x[,1]))
        hist(values, xlab=colnames(x), xlim = xlim, ylim = ylim, ...)
#        flowViz.state[["type"]] <- "hist"
    }
    else if (l==2) {
        if (missing(xlim))
            xlim <- unlist(range(x[,1]))
        if (is.null(ylim))
            ylim <- unlist(range(x[,2]))
        if (smooth) {
            smoothScatter(values, pch=pch, xlim=xlim, ylim=ylim, ...)
#            flowViz.state[["type"]] <- "smooth"
        }else{
            plot(values, pch=pch, xlim=xlim, ylim=ylim, ...)
#            flowViz.state[["type"]] <- "dot"
        }
    } else {
        if(smooth) {
            x <- x[,sel]
            print(splom(x, pch=pch, ...))
#            flowViz.state[["type"]] <- "splom"
        }
        else {
            pairs(values[,sel], pch=pch, ...)
#            flowViz.state[["type"]] <- "pairs"
        }
    }
#    flowViz.state[["parameters"]] <- colnames(values)
}


#' Very basic plotting of flowFrames
#' 
#' A basic method to plot \code{\link[flowCore:flowFrame-class]{flowFrame}}
#' objects. Depending on the number of dimensions, different types of plots are
#' generates. See below for details.
#' 
#' 
#' Basic plots for \code{flowFrame} objects. If the object has only a single
#' parameter this produces a \code{\link[graphics:hist]{histogram}}. For
#' exactly two parameters we plot a bivariate density map (see
#' \code{\link[graphics]{smoothScatter}}) and for more than two parameters we
#' produce a simple \code{\link[lattice]{splom}} plot. To select specific
#' parameters from a \code{flowFrame} for plotting, either subset the object or
#' specify the parameters as a character vector in the second argument to
#' \code{plot}. The \code{smooth} parameters lets you toggle between
#' density-type \code{\link[graphics]{smoothScatter}} plots and regular scatter
#' or pairs plots.  For far more sophisticated plotting of flow cytometry data,
#' see the lattice-style plot methods provided by this package.
#' 
#' @param ... other arguments 
#' 
#' @name plot
#' 
#' @author F. Hahne
#' @seealso
#' 
#' \code{\link[flowViz]{xyplot}},
#' \code{\link[flowCore:flowFrame-class]{flowFrame}},
#' \code{\link[flowViz]{densityplot}}
#' @keywords methods
#' @importFrom stats4 plot
#' @export 
#' @aliases plot,flowFrame,missing-method
setMethod("plot", signature(x="flowFrame", y="missing"),
          function(x, y, smooth=TRUE, ...)
      {
          fplot(x, smooth=smooth, ...)
          return(invisible(NULL))
      })

#' @export 
#' @rdname plot
#' @param x flowFrame
#' @param y (optional) channel names
#' @param smooth logical
#' @param pch point type
setMethod("plot",signature(x="flowFrame", y="character"),
          function(x, y, smooth=TRUE, pch, ...)
      {
          if(!all(y %in% colnames(x)))
              stop("subset out of bounds", call.=FALSE)
          x <- x[,y]
          fplot(x, smooth=smooth, pch=pch, ...)
          return(invisible(NULL))
      })

## we are not exporting this any more (and removing the dependency on
## rgl), but keeping the code around in case we want to resurrect it
## in future.

if (FALSE)
{

parallelCoordinates.rgl <-
    function(x,
             scaled = FALSE,
             alpha = 0.05,
             
             varnames = colnames(x),
             var.at = seq_len(ncol(x)),

             lim = c(min(x), max(x)),
             at = pretty(range(x, na.rm = TRUE)),
             lab = at,
             col = "orange",
             lwd = 0.1,
             add = FALSE,
             ...)
{

    ## ############################
    ##  INPUT
    ## ############################
    ## x       matrix of the data (rows are the observations,
    ##              columns are the variables)
    ## scaled  boolean; if true then scale the data to the range 0,1
    ##          centered about the minimum value
    ## group

    ## ############################
    ## OUTPUT
    ## ############################
    ## plots each row observation across all column variables

    if (!add)
        clear3d()
    
    if (scaled)
    {
        for (i in seq_len(ncol(x)))
        {
            rng <- range(x[, i], na.rm = TRUE)
            if (diff(rng) > 0)
                x[, i] <- (x[, i] - min(rng)) / diff(rng)
        }
    }
    
    zz <- rep(seq_len(nrow(x)) / 1000, each = ncol(x))
    yy <- rep(c(var.at, rev(var.at)), length = length(x))
    xx <- t(x) ## need ``row major'' order w.r.t. x

    alt.rows <- c(FALSE, TRUE)
    xx[, alt.rows] <- xx[rev(seq_len(nrow(xx))), alt.rows]

    savedP <- par3d(skipRedraw = TRUE)
    on.exit(par3d(savedP))

    cCol = material3d("color")

    rgl.linestrips(x = xx,
                   y = yy,
                   z = zz,
                   col = col,
                   lwd = lwd, 
                   alpha = alpha)

    material3d(color = cCol) 
    aspect3d(1,1,0.1)
    ## aspect3d(1,1,0.1)
    rgl.viewpoint(0, 0)

    if (!add)
    {
        rng <- range(xx)
        keep <- at >= rng[1] & at <= rng[2]
        axis3d("x", at = at[keep], lab = lab[keep])
        axis3d("y", at = var.at, lab = varnames)
        title3d(main = "Parallel Coordinates")
    }
}  

## setGeneric("parallelCoord", function(object, ...)
##     standardGeneric("parallelCoord"))

## setMethod("parallelCoord", "flowFrame", function(object) {
##     time = match("<Time>", names(object), nomatch=0)
##     if( time > 0 )
##        parallelCoordinates.rgl(exprs(object)[,-time])
##     else
##        parallelCoordinates.rgl(exprs(object))
##   })

}

## Plot values of a flowSet against the time domain.
## TO DO: Eventualy, we might want individual methods for flowSets and for
## flowFrames, although it might be worthwhile to reimplement using
## lattice graphics first...



## Call flowCore:::prepareSet for each flowFrame in a flowSet and produce the
## plots, according to "type" (see below for details). Also compute a
## quality value modified by the setting of varCut, which is basically
## the sum of average positive distances of means for each bin from the global
## mean confidence interval, scaled by the variance cutoff:
##       sum(z[z>0])/length(z)/varCut
## For type "frequency", this is the sum of events per time tick for
## bins where the total number of events is > 2 times the expected average
## number
## A spearman rank correlation coefficient is return as an attribute.
#' Plot channel values against time
#' 
#' Plots values of one parameter for each flowFrame in a flowSet against time.
#' 
#' 
#' Plotting flow cytometry data against the time domain can help to identify
#' problems with the fluidics or drifts in the instrument setting during
#' measurement runs.
#' 
#' This function creates plots for all flowFrames in a flowSet for a given
#' parameter against time. A barplot legend indicates the deviation from the
#' median for each sample. There is also a flowFrame method, which will create
#' a plot for a single flowFrame only.
#' 
#' In addition, the function computes a quality score for each frame, which
#' essentially is the sum of the positive distances of each bin mean from a
#' frame-specific confidence interval, divided by the number of bins. Values
#' larger than zero indicate a problem.
#' 
#' @name timeLinePlot
#' @return A numeric vector of quality scores.
#' @section Methods:
#' 
#' 
#' @param x An object of class
#' \code{\link[flowCore:flowFrame-class]{flowFrame}} or
#' \code{\link[flowCore:flowSet-class]{flowSet}} containing the data to be
#' plotted.
#' 
#' @param channel The parameter for which the data is to be plotted
#' 
#' @param type  One in 'stacked', 'scaled' or 'native'. 'stacked' will plot the
#' measurements for the frames on top of each other. 'scaled' will align the
#' median values around zero and 'native' will plot the values in the original
#' dimensions of the measurement range.
#' 
#' @param col Optional color parameter.
#' 
#' @param ylab The axis annotation to add on the y-axis for stacked plots.
#' 
#' @param binSize The number of events per bin. If not set, a reasonable
#' default is computed.
#' 
#' @param varCut The cutoff in the adjusted variance to which the quality score
#' is computed. Basically, all values that are outside of the confidence
#' interval defined by \code{\[my - signma * varCut, my + sigma * varCut\]}
#' will contribute to a positive quality score value.
#' 
#' @param ... Further arguments that are passed on to the base plotting
#' functions.
#' 
#' @author F. Hahne
#' @seealso
#' 
#' \code{\link[flowCore:flowFrame-class]{flowFrame}},
#' \code{\link[flowCore:flowSet-class]{flowSet}}
#' @keywords dplot methods
#' @examples
#' 
#' library(flowCore)
#' data(GvHD)
#' opar <- par(ask=TRUE)
#' 
#' res <- timeLinePlot(GvHD[[1]], "SSC-H")
#' res
#' 
#' res <- timeLinePlot(GvHD, "SSC-H")
#' 
#' res <- timeLinePlot(GvHD, "SSC-H", type="scaled", varCut=4)
#' 
#' res <- timeLinePlot(GvHD[1:4], "SSC-H", type="native", binSize=50)
#' 
#' par(opar)
#' 
#' 
#' @export 
timelineplot <- function(x, channel, type=c("stacked", "scaled", "native",
                                     "frequency"),
                         col, ylab=names(x), binSize, varCut=1, ...)
{
    ## Sanity checking up front
    if(!length(channel)==1)
        stop("'channel' must be character scalar")
    if(!channel %in% colnames(x[[1]]))
        stop(channel, " is not a valid channel in this flowSet.")
    if(tolower(channel) == "time")
        stop("Argument 'channel' can not be the time channel")

    ## Making sure the sample names fit on the plot as axis annotation
    sampleNames(x) <- truncNames(sampleNames(x))

    ## Lets fix ourselves some nice colors
    if(missing(col) | is.null(col)){
#        require(RColorBrewer)
        colp <- brewer.pal(8, "Dark2")
        col <- colorRampPalette(colp)(length(x))
        set.seed(1000)
        col <- sample(col) 
    }else{
        if(length(col)!=1 || length(col)!=length(x))
            stop("'col' must be color vector of length 1 or same length ",
                 "as the flowSet")
    }

    ## Bin the data and compute local variances and locations
    time <- flowCore:::findTimeChannel(xx= exprs(x[[1]]))
    timeData <- fsApply(x, flowCore:::prepareSet, parm=channel, time=time,
                        binSize=binSize, use.exprs=FALSE, simplify=FALSE)
    opar <- par(c("mar", "mgp", "mfcol", "mfrow", "las"))
    on.exit(par(opar))
    type <- match.arg(type)
    mr <- range(x[[1]])[,channel]
    mr[1] <- max(mr[1], 0)
    
    ## Standardize to compute meaningful scale-free QA scores
    med <- sapply(timeData, function(z) median(z$smooth[,2], na.rm=TRUE))
    lm <- length(med)
    gvars <- sapply(timeData, function(x) mean(x$variance))
    stand <-  mapply(function(z,m,v) abs(z$smooth[,2]-m)/(v*varCut), timeData,
                 med, gvars, SIMPLIFY=FALSE)
    tvals <- lapply(timeData, function(x) x$smooth[,1])
    
    ## Create the plot, either one of the 4 possible types. For flowFrames
    ## we always use the native scaling.
    if(lm==1 && type != "frequency"){
        nativePlot(timeData, p=channel, range=mr, col="darkblue",
                   varCut=varCut, ...)
        return((sum(unlist(stand)[unlist(stand)>0])/length(stand))/varCut)
    }else if(lm>1)
        layout(matrix(1:2), heights=c(0.8, 0.2))
    switch(type,
           "scaled"=scaledPlot(timeData, p=channel, range=mr, col=col,
           med=med, varCut=varCut, ...),
           "stacked"=stackedPlot(timeData, p=channel, range=mr, col=col,
           ylab=ylab, med=med, varCut=varCut, ...),
           "native"=nativePlot(timeData, p=channel, range=mr, col=col,
           varCut=varCut, ...),
           "frequency"={
               freqPlot(timeData, p=channel, col=col, varCut=varCut,
                        ylab=ylab, ...)
               stand <- lapply(timeData, function(x)
                               x$frequencies[,2] /
                               (mean(x$frequencies[,2])*varCut)-1)
               tvals <- lapply(timeData, function(x) x$frequencies[,1])
           },
           stop("Unknown type"))
    
    ## the QA score and correlation coefficient
    qaScore <- computeQAScore(stand)
    corr <- mapply(cor, tvals, stand, method="spearman", use="pairwise")

    ## a legend indicating the problematic samples
    if(lm>1){
        par(mar=c(5,3,0,3), las=2)
        on.exit(par(opar))
        top <- 2
        barplot(qaScore, axes=FALSE, col=col, cex.names=0.7,
                ylim=c(0, min(c(top, max(qaScore, na.rm=TRUE)))), border=col,
                space=0.2)
        wh <- which(qaScore >= top)
        points((wh+wh*0.2)-0.5, rep(top-(top/12), length(wh)), pch=17, col="white",
               cex=0.7)
    }

    ## The return value with attributes attached.
    attr(qaScore, "binSize") <- binSize
    attr(qaScore, "correlation") <- corr
    attr(qaScore, "raw") <- stand
    return(invisible(qaScore))
}


## Compute the QA score from the standardized values
computeQAScore <- function(stand, varCutoff=1)
    sapply(stand, function(z) sum(z[abs(z) > varCutoff])/length(z))*100

## Truncate the names to make them fit on the plot
truncNames <- function(names){
    nc <- nchar(names)
    names[nc>11] <- paste(substr(names[nc>11], 1, 8), "...", sep="")
    if(any(duplicated(names))){
        ns <- split(names, names)
        is <- split(seq_along(names), names)
        ns<- lapply(ns, function(x)
                    if(length(x)>1) paste(x, seq_along(x), sep="_") else x)
        names <- unlist(ns)[unlist(is)]
    }
    return(names)
}



## Align all values around 0 and plot
scaledPlot <- function(y, p, main=paste("time line for", p),
                       range, col, med, lwd, varCut, ...){
    par(mar=c(1,2.5,3,2.5), mgp=c(1.5,0.5,0))
    yy <- mapply(function(z, m) data.frame(x=z$smooth[,1], y=z$smooth[,2]-m),
                 y, med, SIMPLIFY=FALSE)
    var <- sapply(y, function(z) mean(z$var, na.rm=TRUE))
    maxX <- max(sapply(yy, function(z) max(z[,1], na.rm=TRUE)), na.rm=TRUE)
    xlim <- c(0, maxX)
    maxY <- max(sapply(yy, function(z) max(abs(range(z[,2], na.rm=TRUE)), 
                                          na.rm=TRUE)), na.rm=TRUE)
    minRange <- max(c(diff(range)/20, var)) 
    ylim <- c(min(-maxY, -minRange), max(maxY, minRange))
    if(missing(lwd))
        lwd <- 2
    plot(yy[[1]], xlab="time", type="n", col=col[1], xaxt="n", yaxt="n",
         lwd=lwd, xlim=xlim, ylim=ylim, main=main, ylab="", ...)
    if(varCut>0){
        xl <- par("usr")[1:2]
        xl <- xl + c(1,-1)*(diff(xl)*0.01)
        rect(xl[1], max(var)*varCut, xl[2], -max(var)*varCut,
             col=desat("lightgray", by=30), border=NA)
    }
    abline(h=0, col="darkgray")
    for(j in 1:length(y))
        lines(yy[[j]], col=col[j], lwd=lwd)
}


## Plot values for each flowFrame and stack individual results
stackedPlot <- function(y, p, main=paste("time line for", p),
                        range, col, ylab, med, lwd, varCut, ...){
    par(mar=c(1,5,3,3), mgp=c(2,0.5,0), las=1)
    var <- sapply(y, function(z) mean(z$var, na.rm=TRUE))
    actualRange <- max(c(diff(range)/10, sapply(y, function(x)
                        diff(range(x$smooth[,2], na.rm=TRUE))), var*2))*1.01
    stacks <- ((length(y):1)-1) * actualRange
    yy <- mapply(function(z, m, s) data.frame(x=z$smooth[,1],
                                              y=z$smooth[,2]-m+s), y,
                 med, stacks, SIMPLIFY=FALSE)
    maxX <- max(sapply(yy, function(z) max(z[,1], na.rm=TRUE)))
    xlim <- c(0, maxX)
    ylim <- range(c(sapply(yy, function(z) range(z[,2], na.rm=TRUE))),
                  median(yy[[1]]$y)+var[[1]], median(yy[[length(yy)]]$y) -
                                        var[length(yy)])
    if(missing(ylab) | is.null(ylab))
       ylab <- names(y)
    if(missing(lwd))
        lwd <- 2
    plot(yy[[1]], xlab="", ylab="", type="n", xaxt="n", 
         lwd=lwd, xlim=xlim, ylim=ylim, main=main, yaxt="n", ...)
    xl <- par("usr")[1:2]
    xl <- xl + c(1,-1)*(diff(xl)*0.01)
    if(length(ylab)>1)
        axis(2, stacks, ylab, cex.axis=0.8)
    if(varCut>0)
    for(j in 1:length(y))
        rect(xl[1], mean(yy[[j]]$y)-var[[j]]*varCut, xl[2],
             mean(yy[[j]]$y)+var[[j]]*varCut,
             col=desat("lightgray", by=30), border=NA)
    for(j in 1:length(y))
        lines(yy[[j]], col=col[j], lwd=lwd)   
}



## Plot values in the "native" dimensions
nativePlot <- function(y, p, main=paste("time line for", p),
                       range, col, lwd, varCut, ...){
    par(mar=c(1,2.5,3,2.5), mgp=c(1.5,0.5,0))
    var <- sapply(y, function(z) mean(z$var, na.rm=TRUE))
    actualRange <- max(c(diff(range)/10, sapply(y, function(x)
                        diff(range(x$smooth[,2], na.rm=TRUE))),
                         max(var)*2.1))*1.01
    maxX <- max(sapply(y, function(z) max(z$smooth[,1], na.rm=TRUE)),
                na.rm=TRUE)
    xlim <- c(0, maxX)
    m <- mean(sapply(y, function(z)
                 {
                     sel <- z$smooth[,2]>range[1] & z$smooth[,2]<range[2]
                     if(length(sel))
                         mean(z$smooth[sel,2])
                     else
                         z$smooth[1,2]
                 }))
    maxY <-  max(c(sapply(y,function(z)
                          max(z$smooth[,2],na.rm=TRUE)),
                   m+max(var)*1.05, m-diff(range)/20))
    minY <-  min(c(sapply(y,function(z)
                        min(z$smooth[,2],na.rm=TRUE)),
                   m-max(var)*1.05, m-diff(range)/20))
    ylim <- c(minY, maxY)
    if(missing(lwd))
        lwd <- 2                  
    plot(y[[1]]$smooth, xlab="", ylab="", type="n", col=col[1], yaxt="n", 
         lwd=lwd, xlim=xlim, ylim=ylim, main=main, xaxt="n", ...)
    if(varCut>0 && length(var)==1){
        xl <- par("usr")[1:2]
        xl <- xl + c(1,-1)*(diff(xl)*0.01)
        
        rect(xl[1], m-var*varCut, xl[2], m+var*varCut,
             col=desat("lightgray", by=30), border=NA)
    }
    for(j in 1:length(y))
        lines(y[[j]]$smooth, col=col[j], lwd=lwd, ...)
}



## Plot frequency values for each flowFrame
freqPlot <- function(y, p, main="time line frequencies",
                     col, ylab, lwd, varCut, ...){
    par(mar=c(1,5,3,3), mgp=c(2,0.5,0), las=1)
    var <- 1
    stX <- lapply(y, function(x) x$frequencies[,1])
    stY <- lapply(y, function(x)
                  x$frequencies[,2] / mean(x$frequencies[,2])-1) 
    actualRange <- max(diff(range(stY)), var*varCut*2)*1.01
    stacks <- ((length(y):1)-1) * actualRange
    stYY <- mapply(function(x,s) x+s, stY, stacks, SIMPLIFY=FALSE)
    if(!is.list(stYY))
        stYY <- list(stYY)
    xlim <- c(0, max(unlist(stX)))
    ylim <- range(c(stYY), stacks+var*varCut, stacks-var*varCut)
    if(missing(ylab) | is.null(ylab))
       ylab <- names(y)
    if(missing(lwd))
        lwd <- 2
    plot(stX[[1]], stYY[[1]], xlab="", ylab="", type="n", xaxt="n", 
         lwd=lwd, xlim=xlim, ylim=ylim, main=main, yaxt="n", ...)
    xl <- par("usr")[1:2]
    xl <- xl + c(1,-1)*(diff(xl)*0.01)
    if(length(ylab)>1)
        axis(2, stacks, ylab, cex.axis=0.8)
    if(varCut>0)
    for(j in 1:length(y))
        rect(xl[1], stacks[j]-var*varCut, xl[2],
             stacks[j]+var*varCut,
             col=desat("lightgray", by=30), border=NA)
    for(j in 1:length(y))
        lines(stX[[j]], stYY[[j]], col=col[j], lwd=lwd)
}

#' @export 
#' @rdname timeLinePlot
setMethod("timeLinePlot",
          signature(x="flowSet", channel="character"),
          function(x, channel, type=c("stacked", "scaled", "native",
                               "frequency"),
                   col=NULL, ylab=sampleNames(x), binSize, varCut=1, ...)
      {
          ## a reasonable default for the bin size
          if(missing(binSize))
              binSize <- min(max(1, floor(median(fsApply(x, nrow)/100))), 500)
          type <- match.arg(type)
          timelineplot(x, channel, binSize=binSize, col=col,
                       varCut=varCut, type=type, ylab = ylab, ...)
      })


#' @export 
#' @rdname timeLinePlot
setMethod("timeLinePlot",
          signature(x="flowFrame", channel="character"),
          function(x, channel, ...)
      {
          timeLinePlot(as(x, "flowSet"), channel=channel, ...)
      })

#' @export 
#' @rdname timeLinePlot
setMethod("timeLinePlot",
          signature(x="ANY", channel="missing"),
          function(x, channel, ...)
          stop("Argument 'channel' is missing", call.=FALSE))

## ==========================================================================
## Draw gate boundaries as lines on an existing plot. All graphical
## parameters will be passed on to graphics::lines in the end, so
## these are basically extended lines methods for gates and filters.
## Filters are only evaluated if that is needed for plotting of the
## boundaries.
## All auxiliary functions are defined in the file "gateplotting_utils.R"
##
## FIXME: Need to figure out how to make lines a generic without masking
##        the default function
## FIXME: How do we plot transform filters and combined filters?




## ==========================================================================
## for all filters
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## We only know how to add the gate boundaries if the definiton of that gate
## contains exactly two dimensions, and even then we need to guess that
## they match the plotted data, hence we warn. Supplying the names of the
## plotted channels via the "channels" argument always gets precendence.
## All downstream methods will eventually run across this method, so we only
## need to check once.

#' Drawing filter boundaries
#' 
#' These methods extend the basic graphics \code{\link{lines}} methods for
#' drawing of \code{\link[flowCore:filter-class]{filter}} boundaries. They
#' allow for multiple dispatch, since not all
#' \code{\link[flowCore:filter-class]{filter}} types need to be evaluated for
#' plotting, but this decision should be made internally.
#' 
#' When plotting \code{\link[flowCore:flowFrame-class]{flowFrames}} using the
#' \code{plot} or \code{xyplot} methods provided by \code{flowViz}, the plotted
#' parameters are recorded, which makes it possible to correctly overlay the
#' outlines of \code{\link[flowCore:filter-class]{filter}} assuming that they
#' are defined for the respective parameters. Warnings and error will be cast
#' for the cases where the parameters are non-distinct or ambigious.
#' 
#' The flow parameters plotted can be passed on to any of the methods through
#' the optional \code{channels} argument, which always gets precedence over
#' automatically detected parameters.
#' 
#' The methods support all plotting parameters that are available for the
#' \code{base} \code{lines} functions.
#' 
#' @name glines-methods
#' @aliases glines glines-methods glines,curv1Filter,ANY-method
#' glines,curv1Filter,flowFrame-method glines,curv1Filter,missing-method
#' glines,curv1Filter,multipleFilterResult-method glines,curv2Filter,ANY-method
#' glines,curv2Filter,flowFrame-method
#' glines,curv2Filter,multipleFilterResult-method glines,filter,missing-method
#' glines,filterResult,flowFrame-method glines,filterResult,ANY-method
#' glines,kmeansFilter,ANY-method glines,norm2Filter,ANY-method
#' glines,norm2Filter,flowStats-method
#' glines,norm2Filter,logicalFilterResult-method
#' glines,norm2Filter,flowFrame-method
#' glines,polygonGate,character-method glines,polygonGate,filterResult-method
#' glines,polygonGate,flowFrame-method glines,quadGate,character-method
#' glines,quadGate,filterResult-method glines,quadGate,flowFrame-method
#' glines,rectangleGate,character-method
#' glines,rectangleGate,filterResult-method
#' glines,rectangleGate,flowFrame-method glines,ellipsoidGate,character-method
#' glines,ellipsoidGate,filterResult-method
#' glines,ellipsoidGate,flowFrame-method
#' @docType methods
#' @section Methods:
#' 
#' @param x filter or filterResult or any derived filter class
#' @param data flowFrame or filterResult or character or missing or ANY
#' @param verbose logical
#' @param ... other arguments
#' 
#' \describe{
#' 
#' \item{x = "filter", data = "missing"}{ General method for all objects
#' inheriting from \code{\link[flowCore:filter-class]{filter}}. This is used as
#' the default when no more explicit method is found. It tries to find the
#' plotted parameters from the internal \code{flowViz.state} environment. This
#' only works if the flow data has been plotted using the \code{plot} or
#' \code{xyplot} methods provided by this \code{flowViz} package. }
#' 
#' \item{x = "filterResult", data = "ANY"}{ General method for all
#' \code{\link[flowCore:filterResult-class]{filterResult}} object. This
#' basically extracts the \code{\link[flowCore:filter-class]{filter}} from the
#' \code{\link[flowCore:filterResult-class]{filterResult}} and dispatches on
#' that. }
#' 
#' \item{x = "filterResult", data = "flowFrame"}{ For some
#' \code{\link[flowCore:filter-class]{filter}} types we need the raw data to
#' re-evaluate the filter. }
#' 
#' \item{x = "curv1Filter", data = "ANY"}{ We either need a
#' \code{\link[flowCore:filterResult-class]{filterResult}} or the raw data as a
#' \code{\link[flowCore:flowFrame-class]{flowFrame}} for
#' \code{\link[flowStats:curv1Filter-class]{curv1Filter}}. }
#' 
#' \item{x = "curv1Filter", data = "flowFrame"}{ see above }
#' 
#' \item{x = "curv1Filter", data = "missing"}{ see above }
#' 
#' \item{x = "curv1Filter", data = "multipleFilterResult"}{ see above }
#' 
#' \item{x = "curv2Filter", data = "ANY"}{ We either need a
#' \code{\link[flowCore:filterResult-class]{filterResult}} or the raw data as a
#' \code{\link[flowCore:flowFrame-class]{flowFrame}} for
#' \code{\link[flowStats:curv2Filter-class]{curv2Filter}}.}
#' 
#' \item{x = "curv2Filter", data = "flowFrame"}{ see above }
#' 
#' \item{x = "curv2Filter", data = "multipleFilterResult"}{ see above }
#' 
#' \item{x = "kmeansFilter", data = "ANY"}{ We don't know how to plot outlines
#' of a \code{\link[flowCore]{kmeansFilter}}, hence we warn. }
#' 
#' \item{x = "norm2Filter", data = "ANY"}{ We either need a
#' \code{\link[flowCore:filterResult-class]{filterResult}} or the raw data as a
#' \code{\link[flowCore:flowFrame-class]{flowFrame}} for
#' \code{\link[flowStats:norm2Filter-class]{norm2Filter}}.}
#' 
#' \item{x = "norm2Filter", data = "flowFrame"}{ see above }
#' 
#' \item{x = "norm2Filter", data = "logicalFilterResult"}{ see above }
#' 
#' \item{x = "polygonGate", data = "character"}{ We can plot a
#' \code{\link[flowCore]{polygonGate}} directly from the gate definition. }
#' 
#' \item{x = "polygonGate", data = "filterResult"}{ see above }
#' 
#' \item{x = "polygonGate", data = "flowFrame"}{ see above }
#' 
#' \item{x = "quadGate", data = "character"}{ We can plot a
#' \code{\link[flowCore]{quadGate}} directly from the gate definition. }
#' 
#' \item{x = "quadGate", data = "filterResult"}{ see above }
#' 
#' \item{x = "quadGate", data = "flowFrame"}{ see above }
#' 
#' \item{x = "rectangleGate", data = "character"}{ We can plot a
#' \code{\link[flowCore]{rectangleGate}} directly from the gate definition. }
#' 
#' \item{x = "rectangleGate", data = "filterResult"}{ see above }
#' 
#' \item{x = "rectangleGate", data = "flowFrame"}{ see above }
#' 
#' \item{x = "ellipsoidGate", data = "character"}{ We can plot a
#' \code{\link[flowCore]{rectangleGate}} directly from the gate definition. }
#' 
#' \item{x = "ellipsoidGate", data = "filterResult"}{ see above }
#' 
#' \item{x = "ellipsoidGate", data = "flowFrame"}{ see above }
#' 
#' }
#' @author F. Hahne
#' @seealso
#' 
#' \code{\link[flowCore:filter-class]{filter}},
#' \code{\link[flowCore:flowFrame-class]{flowFrame}},
#' \code{\link[flowViz:gpoints-methods]{gpoints}}
#' @keywords methods
#' @export 
setMethod("glines",
          signature(x="filter", data="missing"), 
          function(x, data, verbose=TRUE, ...)
      {
          parms <- checkParameterMatch(parameters(x), verbose=verbose, ...)
          glines(x, parms, ...)
      })

## Extract the filter definiton from a filterResult and pass that on
## along with it
setMethod("glines",
          signature(x="filterResult", data="ANY"), 
          function(x, data, verbose=TRUE, ...)
      {
          fd <- filterDetails(x)
          filt <- filterDetails(x)[[length(fd)]]$filter
          if(!missing(data) && is.character(data) &&
             ! ("channels" %in% names(list(...))))
              glines(filt, x, verbose=FALSE, channels=data, ...)
          else
              glines(filt, x, verbose=FALSE, ...)
      })

## We don't need the flowFrame if the filter is already evaluated, but we
## can check that the IDs are matching
setMethod("glines",
          signature(x="filterResult", data="flowFrame"), 
          function(x, data, verbose=TRUE, ...)
      {
          checkIdMatch(x=x, f=data)
          glines(x, verbose=verbose, ...)
          dropWarn("flowFrame", "filterResults", verbose=verbose)
      })




## ==========================================================================
## for rectangleGates
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## Plotting parameters are specified as a character vector
setMethod("glines",
          signature(x="rectangleGate", data="character"), 
          function(x, data, channels, verbose=TRUE, ...)
      {
          if(!missing(channels))
              data <- channels
          parms <- parameters(x)
          if(length(parms)==1){ ## ID rectangular gate (region gate)
              mt <- match(parms, data)
              if(mt == 1)
                  abline(v=c(x@min, x@max), ...)
              else if(mt == 2)
                  abline(h=c(x@min, x@max), ...)
              else
                  stop("How did you end up here????")
          }else{ ## 2D rectangular gate
              usr <- par("usr")
              bounds <- cbind(x@min, x@max)[data,]
              bounds[1,] <- fixInf(bounds[1,], usr[1:2])
              bounds[2,] <- fixInf(bounds[2,], usr[3:4])
              bl <- bounds[,1]
              tr <- bounds[,2]
              lines(c(bl[1], tr[1], tr[1], bl[1], bl[1]),
                    c(rep(c(bl[2], tr[2]), each=2), bl[2]), ...) 
          }
      })

## We can ignore the filterResult, don't need it to plot the gate
setMethod("glines",
          signature(x="rectangleGate", data="filterResult"), 
          function(x, data, verbose=TRUE, ...)
      {
          dropWarn("filterResult", "rectangleGates", verbose=verbose)
          glines(x, verbose=verbose, ...)
      })

## we can drop the flowFrame, don't need it for rectangleGates
setMethod("glines",
          signature(x="rectangleGate", data="flowFrame"), 
          function(x, data, verbose=TRUE, ...)
      {
          dropWarn("flowFrame", "rectangleGates", verbose=verbose)
          glines(x, verbose=verbose, ...)
      })




## ==========================================================================
## for quadGates
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## We plot this as ablines
setMethod("glines",
          signature(x="quadGate", data="character"), 
          function(x, data, channels, verbose=TRUE, ...)
      {
          if(!missing(channels))
              data <- channels
          parms <- parameters(x)
          v <- x@boundary[data[1]]
          h <- x@boundary[data[2]]
          abline(v=v,h=h, ...)
      })

## We can ignore the filterResult, don't need it to plot the gate
setMethod("glines",
          signature(x="quadGate", data="filterResult"), 
          function(x, data, verbose=FALSE, ...)
      {
          dropWarn("filterResult", "quadGates", verbose=verbose)
          glines(x, verbose=verbose, ...)
      })

## we can drop the dataFrame, don't need it for quadGates
setMethod("glines",
          signature(x="quadGate", data="flowFrame"), 
          function(x, data, verbose=TRUE, ...)
      {
          dropWarn("flowFrame", "quadGates", verbose=verbose)
          glines(x, verbose=verbose, ...)
      })




## ==========================================================================
## for polygonGates
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## Plotting parameters are specified as a character vector
setMethod("glines",
          signature(x="polygonGate", data="character"), 
          function(x, data, channels, verbose=TRUE, ...)
      {
          if(!missing(channels))
              data <- channels
          parms <- parameters(x)
          xp <- x@boundaries[,data[1]]
          yp <- x@boundaries[,data[2]]
          lines(c(xp, xp[1]), c(yp,yp[1]), ...)
      })

## We can ignore the filterResult, don't need it to plot the gate
setMethod("glines",
          signature(x="polygonGate", data="filterResult"), 
          function(x, data, verbose=TRUE, ...)
      {
          dropWarn("filterResult", "polygonGates", verbose=verbose)
          glines(x, verbose=verbose, ...)
      })

## we can drop the flowFrame, don't need it for polygonGates
setMethod("glines",
          signature(x="polygonGate", data="flowFrame"), 
          function(x, data, verbose=TRUE, ...)
      {
          dropWarn("flowFrame", "polygonGates", verbose=verbose)
          glines(x, verbose=verbose, ...)
      })




## ==========================================================================
## for norm2Filters
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## An error if we can't evaluate the filter
setMethod("glines",
          signature(x="norm2Filter", data="ANY"), 
          function(x, data, verbose=TRUE, ...) evalError("norm2Filters"))      

## Filter has been evaluated and the filterResult is provided
setMethod("glines",
          signature(x="norm2Filter", data="logicalFilterResult"), 
          function(x, data, verbose=TRUE, ...)
      {
          checkFres(filter=x, fres=data, verbose=verbose)
          fd <- filterDetails(data, identifier(x))
          ## create a polygonGate and plot that
          glines(norm2Polygon(fd, parameters(x)), verbose=verbose, ...)      
      })

## Evaluate the filter and plot the filterResult
setMethod("glines",
          signature(x="norm2Filter", data="flowFrame"), 
          function(x, data, verbose=TRUE, ...)
      {
          fres <- filter(data, x)
          glines(x, fres, verbose=verbose, ...)
      })



## ==========================================================================
## for ellipsoidGatess
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

## Plotting parameters are specified as a character vector
setMethod("glines",
          signature(x="ellipsoidGate", data="character"), 
          function(x, data, channels, verbose=TRUE, ...)
      {
          if(!missing(channels))
              data <- channels
          parms <- parameters(x)
	  ## We coerce to a polygon gate and plot that
          glines(as(x, "polygonGate"), verbose=verbose, ...)      
      })


## We can ignore the filterResult, don't need it to plot the gate
setMethod("glines",
          signature(x="ellipsoidGate", data="filterResult"), 
          function(x, data, verbose=TRUE, ...)
      {
          dropWarn("filterResult", "ellipsoidGates", verbose=verbose)
          glines(x, verbose=verbose, ...)
      })

## we can drop the flowFrame, don't need it for ellipsoidGates
setMethod("glines",
          signature(x="ellipsoidGate", data="flowFrame"), 
          function(x, data, verbose=TRUE, ...)
      {
          dropWarn("flowFrame", "ellipsoidGates", verbose=verbose)
          glines(x, verbose=verbose, ...)
      })






## ==========================================================================
## for kmeansFilters
## - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## We don't know how to plot these, hence we warn
setMethod("glines",
          signature(x="kmeansFilter", data="ANY"), 
          function(x, data, verbose=TRUE, ...) nnWarn("kmeansFilter", verbose))

context("ncdfFlowSet plots")
library(flowCore)
library(flowStats)
library(ncdfFlow)
data(GvHD)

morphGate <- norm2Filter("FSC-H", "SSC-H", filterId = "MorphologyGate",scale = 2)
fs <- GvHD[pData(GvHD)$Patient %in% 6:7][1:4]
suppressMessages(ncfs <- ncdfFlowSet(fs))
samples <- sampleNames(ncfs)

test_that("xyplot ncdfFlowSet", {
  sn <- samples[1:2]
  nc <- ncfs[sn]
  ncObj <- xyplot(`SSC-H`~`FSC-H`, nc)
  
  expect_is(ncObj[["panel.args.common"]][["frames"]], "ncdfFlowSet")
  
  expect_equal(ncObj[["panel.args.common"]][["type"]], "xyplot")
  
  fsObj <- xyplot(`SSC-H`~`FSC-H`, fs[sn])
  
  expect_is(fsObj[["panel.args.common"]][["frames"]], "environment")
  
  expect_equal(sub("type", "plotType", deparse(ncObj[["call"]])), deparse(fsObj[["call"]]))
  
  ncObj[["panel.args.common"]][["frames"]] <- NULL
  fsObj[["panel.args.common"]][["frames"]] <- NULL
  ncObj[["panel.args.common"]][["type"]] <- NULL
  ncObj[["call"]] <- NULL
  fsObj[["call"]] <- NULL
  
  expect_equivalent(fsObj, ncObj)
})

test_that("densityplot ncdfFlowSet", {
  sn <- samples[1:2]
  nc <- ncfs[sn]
  ncObj <- densityplot(~`SSC-H`, nc)
  fsObj <- densityplot(~`SSC-H`, fs[sn])
  
  expect_is(ncObj[["panel.args.common"]][["frames"]], "ncdfFlowSet")
  expect_is(fsObj[["panel.args.common"]][["frames"]], "environment")
  
  expect_equal(deparse(ncObj[["call"]]), deparse(fsObj[["call"]]))
  
  ncObj[["panel.args.common"]][["frames"]] <- NULL
  fsObj[["panel.args.common"]][["frames"]] <- NULL
  ncObj[["call"]] <- NULL
  fsObj[["call"]] <- NULL
  
  expect_equivalent(fsObj, ncObj)
})

<!--
% NOTE -- ONLY EDIT THE .Rnw FILE!!!  The .tex file is
% likely to be overwritten.
%
%\VignetteIndexEntry{Visualizing Gates with Flow Cytometry Data}
%\VignetteDepends{flowViz, flowStats}
%\VignettePackage{flowViz}
%\VignetteEngine{knitr}
-->

Gates/filters in Flow Cytometry Data Visualization
=======================================

```{r setup, include=FALSE}
library(knitr)
opts_chunk$set(out.extra='style="display:block; margin: auto"', fig.align="center", message = FALSE, warning = FALSE, knitr.table.format = "markdown")
assign("depthtrigger", 60, data.table:::.global)
```

abstract
------------
  The **flowViz** package provides tools for visualization of
  flow cytometry data.  This document describes the support for
  visualizing gates (a.k.a. filters).


```{r loadPackage, echo=FALSE,results='hide'}
library(flowViz)
library(flowStats)
```


Introduction
------------
Tools to read in and otherwise manipulate flow cytometry data are
implemented in the **flowCore** package.  The
**flowViz** package provides visualization support for such
data.  In this document we give examples dealing with gated or
filtered data. Please consult the online documentation for more
details on the high-level visualization functions used here.




Filters and filter results
------------
The **flowCore** package defines the concepts of
`filters` and `filterResults`.  Filters are abstract
entities defined in terms of markers that are measured on the flow
instrument as different channels, whereas a filter result is the
result of applying a filter to one or more `flowFrames` (data
objects representing individual FCM experiments).  Some filters are
data driven, while some are not. We will later see how this
distinction has an impact on their plotting. All abstractions of
filters or gates inherit from class `filter`, whereas objects
generated as the result of applying a filter inherit from class
`filterResult`.


Visualization
------------
Before we discuss how to visualize gates in **flowViz**, we need
to point out that this may only be reasonable for certain types of the
many possible plots, namely one-dimensional density plots and
two-dimensional scatter plots. Over time we might add gate-plotting
support for other plot types as well. There are two principal ways to
add gates to a flow cytometry plot; either we render the outlines of
the gate region (for both one and two-dimensional plots), or we
highlight the points within a gate region by distinctive color,
glyphs, or point size (this applies for two-dimensional plots
only). It only makes sense to visualize the boundaries of a filter if
it has a (one or two dimensional) geometric representation.  This is
true for rectangle, ellipsoid and polygon gates, which are all
frequently used.  It is also true for some data driven gates,
e.g. `norm2Filter` gates, which have a (data dependent)
spherical representation.  Also, it makes sense to draw gate
boundaries only when plotting (some of) the channels that define the
gate.

Visualizing `filterResults` is more general.  Specifically, the
result of applying a filter is usually a logical (`TRUE` or
`FALSE`) vector for each cell, or more generally, a
`factor` (as long as we restrict ourselves to non-fuzzy
filters).  This can be used as a grouping variable within a display,
also when plotting channels other than those defining the gate.

All data-driven filters depend on the `filterResult` to be
computed in order to plot them. The user doesn't have to worry about
this fact, as the software will implicitly compute these objects if
necessary. However, realizing filters and creating
`filterResult` is often computationally intense and
time-consuming, and in many cases makes sense to explicitly create
the `filterResult` once and pass it on to the plotting
functions instead of the input filter. In the course of this manual,
`filter` objects and `filterResults` may be used
interchangeably, unless stated otherwise.



Example Data
------------
We use the `GvHD` data set to provide some examples. It come as
a serialized `flowSet` with the **flowViz** package and
the interested user is referred to its documentation for details. For
the purpose of this demonstration it is sufficient to know that the
`phenoData` slot of the `GvHD` set contains several
factor variables, `Patient` and `Visit` two of the
most descriptive ones. In general, all `flowSets` contain an
implicit `name` variable which is is used as the default
conditioning variable in all of **flowViz's** high-level
plotting functions.
```{r loadData}
library(flowViz)
data(GvHD)
head(pData(GvHD))
``` 


The set is quite large and reducing it to a reasonable subset will
speed up things for our interactive demonstration purpose. Due to
various constrains (data size, complexity of computations, limitations
in the **grid** software underlying the **lattice** and
**flowViz** packages), rendering plots is usually not
instantaneous. It usually takes a little bit of time to output
complex panel layouts. When producing postscript output, the user
should be aware that file size may become an issue, and we will
address solutions for this problem at the end of this document.

The **lattice** package offers inline subsetting capabilities
for all high level plotting functions though the `subset`
argument, and this functionality (like most of the other typical
**lattice** concepts) is also available for all derived
plotting methods in **flowCore**. The general idea here is that
all symbols defined in either the formula or one of the special
arguments like `subset` are evaluated in the context of the
`flowFrame's` `phenoData` data frame or the raw data
matrix. This is a slight extension of the fundamental
**lattice** idea necessitated by the fact that raw data and
annotation data are stored separately in a **flowSet**.
```{r subsetLattice, eval=FALSE}
xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD,
       subset=Patient=="6")
``` 

Inline subsetting is useful to change plots on the fly, or to play
around with various panel arrangements. However, we still pass the
whole `GvHD` object down to the plotting function, potentially
increasing memory usage and decreasing performance due to unnecessary
heavy copying operations. Since we only want to use the subset for
patient 6 in the following examples, it makes sense to directly subset
the `flowSet`.
```{r subsetFlowCore}
GvHD <- GvHD[pData(GvHD)$Patient==6]
```

 

We also want to transform some of the fluorescence channels to an
adequate log-like scale. A good choice is the `asinh`
function which can deal with negative values.
```{r transform}
tf <- transformList(from=colnames(GvHD)[3:7], tfun=asinh)
GvHD <- tf %on% GvHD
``` 

For details on this step, please see the documentation of the
`transformList` and `\%on\%` functions in the
**flowCore** package.


Filters in scatter plots
------------
Trellis scatter plots are created using `xyplot` methods.
The `xyplot` method for `flowSet` objects supports
filters through the `filter` argument. As mentioned before, its
value can either be an object inheriting from class `filter` or
a `filterResult` (a `filterResultList` of multiple
`filterResults` for `flowSets`).

The key concepts here are that

  
* `filters` and `filterResults` can be used
  interchangeably. Providing `filterResults` directly may
  increase performance for data-driven filters.
  
* visualization of `filters` depends on the type of
  rendering.  For example, with `smooth=TRUE`, filters are
  visualized geometrically, which makes sense only under certain
  circumstances (e.g. display axes matching filter parameters, the
  `filter` class has a geometric represention). For scatter
  plots of individual dots for all events (`smooth=FALSE`),
  filters are visualized through grouping and/or geometric filter
  outlines; the former makes sense more generally, as display
  variables need not match filter parameters. Grouping has the
  drawback of overplotting.  The effect of overplotting can be reduced
  somewhat using transparency, but scalability issues remain.  We may
  try dealing with this at some point if it becomes enough of a
  hassle.
  
* the software will check for matching parameters and available
  visualization representations as much as possible, yet finally it is
  up to the user to construct reasonable calls to the plotting
  functions.



Simple Geometric Filter Types
------------
Visualization of most of the typical FCM filter types is straight
forward and doesn't require the computation of
`filterResult`. All parameters (e.g. min and max values in a
recangular gate) are unambigously defined in the `filter`
object. We will start with a simple `rectangleGate` in the
`FSC-H` and `SSC-H` dimensions.

```{r simpleRG, fig=TRUE, include=FALSE, echo=TRUE, prefix=FALSE, height=4.5, width=8} 
rgate <- rectangleGate("FSC-H"=c(0, 400),"SSC-H"=c(-50, 300))
print(xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD, filter=rgate))
```



As default for smoothed scatter plots, the gate boundaries are
drawn. Orientation of the gate will be handled by the plotting
function and the user doesn't have to worry about the order of
arguments when defining the `filter`. The software also decides
on a reasonable two-dimensional geometric representation of more
complex filters. E.g., we can add a third dimension to the
`rectangleGate` and still achive the same visualization in the
`FSC-H` and `SSC-H` dimensions.
```{r threeDRG}
rgate2 <- rgate * rectangleGate("FL1-H"=c(2, 4))
xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD, filter=rgate2)
``` 

Most of the customization options defined in the **lattice**
package will also work here. A more detailed discussion about the
filter-specific graphical settings will follow in one of the later
sections.

For the non-smoothed rendering (i.e., all events are plotted as
individual points).

```{r nonSmoothScatter}
xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD, filter=rgate, smooth=FALSE)
```

Sometime non-smoothed plots can be slow for large number of events. We provide
hexbin version of xyplot for faster rendering.

```{r hexbinScatter}
xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD, filter=rgate, smooth=FALSE,xbin=128)
```



```{r plotnonSmoothScatter, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=4.5, width=8}
print(plot(trellis.last.object()))
```

Additionally, We can add statistics of gated population along with the `filter` to the plot
using the `stat` argument.`pos` and `abs`(whether the position is absolute or relative to filter boundary ) are used to control the label position.

```{r nonSmoothScatterOutline}
xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD, filter=rgate,
smooth=FALSE, stat=TRUE,pos=0.5,abs=TRUE)
```

Sometime it is necessary to display multipe filters/gates in one panel to represent multiple sub-populations gated from the same parent populatuion.
```{r multi-filters}
recGate1<-rectangleGate("FL4-H"=c(3.3,5.3),"FL2-H"=c(2.5,5))
recGate2<-rectangleGate("FL4-H"=c(4,6),"FL2-H"=c(6,8))
filters1<-filters(list(recGate1,recGate2))
xyplot(`FL2-H` ~ `FL4-H`
	   ,data=GvHD[[1]]
       ,filter=filters1
       ,stat=TRUE
       ,margin=FALSE
       )	
```
 

```{r plotnonSmoothScatterOutline, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=4.5, width=8}
print(plot(trellis.last.object()))
```

The constraint for a valid two-dimensional representation doesn't
apply any more for this type of rendering. Since each event is
represented by a single point on the plot, we can visualize
arbitrarily complex `filters` using different colors or point
glyphs for the different sub-populations.  However this implies that
we need to evaluate each filter, i.e., we need to figure out which of
the events are in and which are outside of the filter. We will see in
a minute how we can optimize these operations. Going back to our
three-dimensional rectangle, we notice that not all points within the
rectangle are also color red, because the additional third dimension
further reduced the selection of positive events in the
`FSC-H` and `SSC-H` dimensions. 

```{r nonSmoothScatterOutline2}
xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD, filter=rgate2,
       smooth=FALSE, outline=TRUE)
``` 
%

```{r plotnonSmoothScatter2, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=4.5, width=8}
print(plot(trellis.last.object()))
```



Overplotting is a potential problem for this representation. As a
matter of fact, it is problematic for all visualization approaches of
high-volume FCM data that try to display individual events rather than
some form of summary statistic like density estimates. Partial
transparency can alliviate some of these shortcomings but this
approach does not scale well and has certain technical limitations on
graphic devices that don't support transparency. We will see in one of
the following sections how to enable partial transparency in scatter
plots.

Data-Driven Filters
------------
Data-driven filters don't have a natural geometric representation a
priori; they are data-driven. Once all parameters are estimated, we
can usually derive such a representation from the
`filterResult`. There is only a small subet of `filter`
classes for which this is not directly possible
(`kmeansFilter`, `timeFilter`), although one might be
able to fall back to approximations like convex hulls or similar. So
far, **flowViz** has nor support for plotting gate outlines of
these filter types, and they are silently ignored when passed on as
argument `filter` to any of the high-level plotting
functions. As shown in the previous example, the absence of a
two-dimensional spherical representation only poses a problem when
trying to plot filter boundaries, the non-smooth representation of
individual events is available for virtually all `filter`
types.

In the following example, we first compute the `filterResults`
of a `norm2Filter` in `FSC-H` and `SSC-H` for
each frame in our `GvHD` `flowSet` and plot their
geometric elliptic representation.


```{r norm2Filter}
n2Filter <- norm2Filter("SSC-H", "FSC-H", scale=2, filterId="Lymphocytes")
n2Filter.results <- filter(GvHD, n2Filter)
xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD, filter=n2Filter.results)
``` 
%

```{r plotnorm2Filter, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=4.5, width=8}
print(plot(trellis.last.object()))
```

There are data-driven filter types that may result in more than just
one sub-population. `curv1Filters` and `curv2Filters`
are a prominent example. In the next code chunk we use a
`curv2Filter` to identify high-density areas in the
`FSC-H` and `FL4-H` projections of the data.


```{r curv2Filter}
library(flowStats)
c2f <- curv2Filter("FSC-H", "FL4-H", bwFac=1.8)
c2f.results <- filter(GvHD, c2f)
xyplot(`FL4-H` ~ `FSC-H` | Visit, data=GvHD, filter=c2f.results)
``` 
%

```{r plotcurv2Filter, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=4.5, width=8}
print(plot(trellis.last.object()))
```



This is a good example for a case where passing the
`filterResult` instead of the `filter` helps to optimize
computation time. Depending on the hardware it can take quite a while
to complete the extensive computations necessary for the
identification of siginficant high-density areas in two
dimensions. Imagine you want to make slight changes to your plot (and
producing good graphical output is almost always an iterative
approach); having to recompute the **filterResult** on each
iteration would be very time-cosuming and annoying at best.

Filters in one-dimensional density plots
------------
The **lattice** package provides the high-level
`densityplot` function to draw one-dimensional Kernel
density estimates of univariate data. Density estimates are a
generalization of the well-known histograms; instead of drawing boxes
of relative or absolute frequencies of binned observations, a
continous relative density is displayed, usually beautified by
applying a smoother function with an appropriate bandwidth. The
`densityplot` methods in the **flowViz** package
assume an implicit conditioning variable (the measurement channel or
channels) and display the density estimates of all frames for one
channel as a stacked layout. This has proven to be a useful
visualization, since the direct comparison of univariate channel
distributions is of great interest in many FCM application, however the
typically large number of samples makes superimposing in a single
display impratical. See the documention of `densityplot` for
more details.

In one-dimensional density plots it only makes sense to plot filter
boundaries. The densities are basically a summary of the distribution
of events for a particular channel, and there is no real notion of
individual events any more. Similar to the `xyplot` methods,
we can pass `filters` or `filterResults` to the function
as optional argument `filter`. We decided to indicate gate
boundaries by different shading of the the respective integrals of the
density regions rather than simply adding vertical lines. These tend
to be distracting in the stacked layout or are often partly masked by
overplotting of neighbouring density areas.

```{r densityplots}
densityplot(~ `FSC-H`, GvHD, filter=curv1Filter("FSC-H"))
``` 

```{r plotdensityplots, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=4.5, width=8}
print(plot(trellis.last.object()))
```

The situation gets slightly more complex when we are conditioning on
multiple FCM channels. In this case, filter has to be a list of equal
length as the number of channels that are supposed to be displayed
(i.e., the number of panels). Each list item may contain one of the
familiar objects of class `filter`, `filterResult`,
`filterResultList`, or `NULL` in case no filter should
be plotted at all for a given panel.




```{r multDensityplots}
densityplot(~ ., GvHD, channels=c("FSC-H", "SSC-H", "FL1-H"), 
filter=list(curv1Filter("FSC-H"), NULL, rgate2))
``` 
%

```{r plotmultDensityplots, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=4, width=8}
print(plot(trellis.last.object()))
```

Note that by default the scale of the x axis has been adjusted for
each panel. This is contrary to the default settings in the
**lattice** package and can be reversed using appropriate
settings in in the `scales` argument.

Plotting parameters
------------
**Lattice** graphics are a great tool to easily create
informative and consise data visualization with a minimal amount of
code. Most of its default graphical parameters are well thought
through. However, there is also a wealth of customization available,
and we refer readers to the package's documentation as well as
Deepayan Sarkar's excellent book 
"Lattice: Multivariate Data Visualization with R" for details. With
respect to **flowViz**, it should suffice to mention that
customization follows the exact same principles defined in the
**lattice** package. As a matter of fact, most customization
actually happens at the level of the underlying **lattice**
software. The facts to mention are:


* There are session-wide global defaults that can be queried and
  set using the `flowViz.par.get` and
  `flowViz.par.set` functions. These are extensions to the
  `trellis.par.get` and `trellis.par.set`
  functions in the **lattice** package, and work in exactly the
  same way. All graphical parameters that are not defined in
  **flowViz** are directly passed on to **lattice**.
  
* Parameters can also be set for a single function call using the
  `par.settings` argument. These setting take precedence over
  global settings.
  
* Parameters are split up into logical categories and have to be
  provided as named lists or lists of lists. The categories directly
  relevant for filter plotting are `gate`,
  `gate.density`, and `gate.text`, the basic
  **flowViz** settings are controlled by the
  `flow.symbol` category. See the documentation for
  `flowViz.par.set` for a complete list of available
  parameters. All additional graphical parameters (like `cex`,
  `pch` and `col`) known from the **lattice**
  high-level plotting functions are also still available.
  


```{r Pars1}
xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD, filter=rgate,
       par.settings=list(gate=list(fill="black", alpha=0.2)))
``` 
%

```{r plotPars1, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=4.5, width=8}
print(plot(trellis.last.object()))
```
  

We could have achieved the same customization by changing the session defaults:
```{r plotPars2, eval=FALSE}
flowViz.par.set(gate=list(fill="black", alpha=0.2))
xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD, filter=rgate)
```

Depending on the rendering, the graphical parameters may have slightly
different effects. The `col` parameters for instance sets the
line color for filter boundaries and the point color for non-smooth
scatter plots (and also the outline if `outline=TRUE`). In the
following code sample we try to make use of partial transparency to
address the problem of overplotting. Dense regions of the plot with
many overplotted points will apprear darker. Although this is better
than using opaque colors, lots of the underlying structure could still
be hidden and we strongly emphasize the advantages of smoothed scatter
plots for vizualization of FCM data.


```{r Pars3}
xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD, filter=rgate,
       smooth=FALSE, 
       par.settings=list(gate=list(col="orange", alpha=0.04,
                                   pch=20, cex=0.7),
                         flow.symbol=list(alpha=0.04, pch=20, cex=0.7)))
``` 

```{r plotPars3, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=4.2, width=8}
print(plot(trellis.last.object()))
```




For multiple population filters, R ordinary recycling rules apply, and
we can spice up out plot of the `curv2Filter` results by using
a different color for each sub-population.


```{r Pars4}
xyplot(`FL4-H` ~ `FSC-H` | Visit, data=GvHD, filter=c2f.results,
par.settings=list(gate=list(fill=rainbow(10), alpha=0.5, col="transparent")))
``` 


```{r plotPars4, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=4.5, width=8}
print(plot(trellis.last.object()))
```
  





Sometimes it helps to add population names to a
plot. **flowCore** provides default names for each
`filter` and their associated results, but the user is free to
pass their own custom names. The interface is very simple: argument
`names` either takes a logical scalar (default names are used
if `TRUE`) or a character vector. Again, recycing rules apply
when there are multiple sub-populations (unless default names are uses
in which case the software provides a reasonable choice).

```{r norm2FilterNames}
xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD, filter=n2Filter.results, 
       names=TRUE, 
       par.settings=list(gate=list(fill="black", alpha=0.2, 
                                   col="transparent"),
                         gate.text=list(col="darkred", alpha=0.7, cex=0.6)))
``` 


```{r plotnorm2FilterNames, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=4.5, width=8}
print(plot(trellis.last.object()))
```
  




Restrictions on the formula interface
------------
We mentioned before that all elements of the formulae used in
**flowViz** are evaluated in the context of either the raw data
matrix or the `phenoData` slot. This implies that formula
components can themselves be valid R expressions including function
calls. To a certain extend this is true, and the user might be able to
produce reasonable graphical output by evaluating expressions on
existing data or annotation objects, however we strongly discourage
this use. The software makes certain assumptions on the relationship
between gate definitions and data, the most prominent one being that
both are on the same scale. The use of expressions in
**flowViz** potentially changes the scale of the raw data, in
which case the gate representation doesn't make much sense
anymore. Furthermore, FCM data is naturally censored (by the available
measurement range of the instrument) and we try to protect the user
from irritating visual artifacts caused by the piling up of events on
the margins of the data range. This is most notable in the
one-dimensional densityplots, where densities are only computed within
the data range, and margin events are added as vertical
bars. Similarily, in the two-dimensional smoothed scatter plots, we
display margin events as ticks around the actual data display. Again,
changing the scale of the data would potentially invalidate many of
the necessary computations.

In summary, **lattice** encourages the use of expressions in the formula
interface and for the sake of customizability we didn't want to
exclude this feature completely in the **flowViz** methods.
However, the tool has to be used with great care, particularly when
plotting gates.



Filters in parallel coodinate plots
------------
Although the `filter` argument does not make much sense except
in scatter plots, `filterResults` can be used for grouping in
other contexts.  So far, only the `parallelplot` method supports
this syntax.

```{r parCoord}
parallelplot(~ . | Visit, GvHD, filter=n2Filter.results, alpha = 0.01)
``` 


```{r plotparCoord, fig=TRUE, include=FALSE, echo=FALSE, results='hide', prefix=FALSE, height=6, width=8}
print(plot(trellis.last.object()))
```

---
title: "histogram_vs_densityplot"
author: "Mike Jiang"
date: "04/13/2015"
output: html_document
vignette: >    
  %\VignetteKeywords{flow cytometry, visualization}
  %\VignettePackage{flowViz}  
  %\VignetteIndexEntry{histogram_vs_densityplot}
---

```{r, echo=FALSE}
library(knitr)
opts_chunk$set(message = FALSE, warning = FALSE)
```


```{r}
library(flowViz)
data(GvHD)
fs <- GvHD[1:5]
fs <- transform(fs, estimateLogicle(fs[[1]], colnames(fs)[-c(1:2)]))

```


## One sample(`flowFrame`) vs one channel 
```{r}
fr <- fs[[1]]
densityplot(~`FL1-H`, fr)
histogram(~`FL1-H`, fr)
histogram(~`FL1-H`, fr, breaks = 50) ##change the breaks

# change the border colors for hist
flowViz.par.set("superpose.polygon", list(border = "white"))
histogram(~`FL1-H`, fr, breaks = 50)
```

## One sample vs multi-channels
```{r}
densityplot(~., fr, channels = c("FL1-H", "FL2-H"))
histogram(~., fr, channels = c("FL1-H", "FL2-H"), breaks = 50)
densityplot(~., fr) #default will plot all channels
histogram(~., fr)
densityplot(~., fr, margin = F) #disable margin filtering
histogram(~., fr, margin = F)
```

## Multi-samples (`flowSet`) vs one channel
```{r}
densityplot(~`FL1-H`, fs)
histogram(~`FL1-H`, fs, breaks = 50)

#non-stacked version
densityplot(~`FL1-H`, fs, stack = F)
histogram(~`FL1-H`, fs, stack = F, breaks = 50, col = "white")

# change histogram type
histogram(~`FL1-H`, fs, stack = F, breaks = 50, col = "white", hist.type = "count")
histogram(~`FL1-H`, fs, stack = F, breaks = 50, col = "white", hist.type = "percent")
# Independent scales
histogram(~`FL1-H`, fs, stack = F, breaks = 50, col = "white", hist.type = "count"
          , scale = list(y=list(relation = "free")))
```

## Multi-samples (`flowSet`) vs multi-channels
```{r}
densityplot(~., fs, channels = c("FL1-H", "FL2-H"))
histogram(~., fs, channels = c("FL1-H", "FL2-H"), breaks = 50)

densityplot(~., fs)
histogram(~., fs, breaks = 50)
```


## display gate
```{r}
g <- rectangleGate(`FL1-H` =  c(3, 5))
densityplot(~`FL1`, fs, filter = g, stats = T)
densityplot(~`FL1`, fs, filter = g, stats = T, fitGate = F)#disable fitGate

histogram(~`FL1`, fs, stack = T, breaks = 1e2, type = "count", filter = g, stats = T)
histogram(~`FL1`, fs, stack = F, breaks = 1e2, type = "count", filter = g, stats = T)
```

## `densityplot` + `overlay`
```{r}
pos <- Subset(fs, g)
pos #gated population
#dispaly pos as overlay
xyplot(`FSC-H`~`FL1`, fs,overlay = list(pos = pos), xbin = 32, smooth = F)
# Not sure how to make y scale of the overlay to be compariable to the original density since its density is estimated indenpendenly.
densityplot(~`FL1`, fs, margin = F, overlay = list(pos =  pos), stack = F, filter = g, fitGate = F) 

# add overlay + independent y scaling
histogram(~`FL1`, fs, stack = F, breaks = 1e2, type = "count", filter = g, stats = T,overlay = list(pos =pos), scale = list(y=list(relation = "free")))
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/flowViz-package.R
\docType{package}
\name{flowViz-package}
\alias{flowViz-package}
\alias{flowViz}
\title{Visualization for flow cytometry}
\description{
Functions and methods to visualize flow cytometry data. This package heavily
depends on the flowCore package.
}
\details{
\tabular{ll}{ Package: \tab flowViz\cr Type: \tab Package\cr Version: \tab
0.2.1\cr Date: \tab 2006-11-16\cr License: \tab Artistic\cr } Traditionally,
large parts of the analysis process of flow cytometry data has been mostly
qualitative. To this end, dedicated visualization techniques have been used
for both quality control and infernece of the data. This package provides a
number of different visualization tools for flow data.
}
\examples{

## examples go here
}
\seealso{
\code{\link[flowCore:flowCore-package]{flowCore}}
}
\author{
Maintainer: Florian Hahne <f.hahne@dkfz.de> Authors: T. Duong, B. Ellis, R.
Gentleman, F. Hahne, N. Le Meur, D. Sarkar, M. Tang
}
\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/gateplotting_utils.R
\name{flowViz.par.get}
\alias{flowViz.par.get}
\alias{flowViz.par.set}
\title{Query and set session-wide graphical parameter defaults.}
\usage{
flowViz.par.get(name = NULL)

flowViz.par.set(name, value, ..., theme, warn = TRUE, strict = FALSE,
  reset = FALSE)
}
\arguments{
\item{name}{The name of a parameter category to set.}

\item{value}{A named list of values to set for category \code{name} or a
list of such lists if \code{name} is missing.}

\item{\dots}{Further arguments that get passed on.}

\item{theme}{The theme to set. See
\code{\link[lattice:trellis.par.get]{trellis.par.set}} for details.}

\item{warn}{This gets passed on directly to \code{trellis.par.set}.}

\item{strict}{This gets passed on directly to \code{trellis.par.set}.}

\item{reset}{\code{logical} scalar. When TRUE, drop the entire list of old
graphical parameters and reset it with the supplied one. Default is FALSE,
which updates the existing parameters.}
}
\value{
\code{flowViz.par.get} returns a list of graphical parameter defaults, if
\code{name} is not empty, only for this particular category. For an empty
\code{name} argument, the function returns all parameter defaults, including
the ones specified in the lattice package.

\code{flowViz.par.set} is called for its side-effects of setting default
parameters.
}
\description{
\code{flowViz.par.get} is the equivalent to
\code{\link[lattice]{trellis.par.get}}. It queries the session wide defaults
for all \code{lattice} and \code{flowViz} graphical parameters.
}
\details{
\code{flowViz.par.set} is the equivalent to
\code{\link[lattice:trellis.par.get]{trellis.par.set}}. It sets the same set
of graphical parameters, either in the \code{flowViz} package or directly in
\code{lattice}.

Getting and setting graphical parameters in \code{flowViz} follows exactly
the mechanism of the \code{lattice} package. For all purpose and intentions,
\code{flowViz.par.get} and \code{flowViz.par.get} can be viewed as wrappers
around their \code{lattice} counterparts
\code{\link[lattice]{trellis.par.get}} and
\code{\link[lattice:trellis.par.get]{trellis.par.set}} and you should
consult their documentation for further details.

We introduce four new categories of graphical parameters that are relevant
for \code{flowViz} plots:

\describe{ \item{gate}{Controls the appearance of gate boundaries in
\code{xyplots} (if \code{smooth=TRUE}) or of the points within a gate region
(\code{smooth=FALSE}).  Available parameters are \code{col},
\code{cex},\code{pch},\code{alpha},\code{lwd},\code{lty} and \code{fill}. }

\item{gate.density}{Controls the appearance of gate boundaries in
\code{densityplots}.  Available parameters are \code{col},
\code{alpha},\code{lwd},\code{lty} and \code{fill}. }

\item{flow.symbol}{Controls the appearance of 'regular' points in a
\code{flowViz} plot.  Available parameters are \code{col},
\code{cex},\code{pch},\code{alpha} and \code{fill}. }

\item{gate.text}{Controls the appearance of the text used for gate names.
Available parameters are \code{col}, \code{cex},\code{font},\code{alpha} and
\code{lineheight}. } }
}
\note{
Because parameter settings in \code{lattice} are device-dependent,
\code{flowViz.par.get} will open a (default) device none is open at the time
of the query.
}
\examples{


## Return all available parameters, including lattice ones
flowViz.par.get()

## Set the font for gate names 
flowViz.par.set("gate.text", list(font=2))

## Query only the gate.text category
flowViz.par.get("gate.text")

## Set a lattice parameter
plot.symbol <- trellis.par.get("plot.symbol")
flowViz.par.set("plot.symbol", list(col="red"))
trellis.par.get("plot.symbol")

## undo all settings
flowViz.par.set(list(plot.symbol=plot.symbol, gate.text=list(font=1)))
library(flowCore)
data(GvHD)
fs <- GvHD[1:2]

# using default ggplot2like theme
densityplot(~`FSC-H`, fs)
xyplot(`SSC-H`~`FSC-H`, fs, smooth = FALSE)
            
# reset it with default lattice theme            
flowViz.par.set(theme =  trellis.par.get(), reset = TRUE)
densityplot(~`FSC-H`, fs)
xyplot(`SSC-H`~`FSC-H`, fs, smooth = FALSE)


}
\references{
Deepayan Sarker, \emph{Lattice, Multivariate Data Visualization
with R}, Springer, New York, 2008
}
\seealso{
\code{\link[lattice]{trellis.par.get}} and
\code{\link[lattice:trellis.par.get]{trellis.par.set}}
}
\author{
F. Hahne
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot-methods.R
\docType{methods}
\name{plot}
\alias{plot}
\alias{plot,flowFrame,missing-method}
\alias{plot,flowFrame,character-method}
\title{Very basic plotting of flowFrames}
\usage{
\S4method{plot}{flowFrame,missing}(x, y, smooth = TRUE, ...)

\S4method{plot}{flowFrame,character}(x, y, smooth = TRUE, pch, ...)
}
\arguments{
\item{x}{flowFrame}

\item{y}{(optional) channel names}

\item{smooth}{logical}

\item{...}{other arguments}

\item{pch}{point type}
}
\description{
A basic method to plot \code{\link[flowCore:flowFrame-class]{flowFrame}}
objects. Depending on the number of dimensions, different types of plots are
generates. See below for details.
}
\details{
Basic plots for \code{flowFrame} objects. If the object has only a single
parameter this produces a \code{\link[graphics:hist]{histogram}}. For
exactly two parameters we plot a bivariate density map (see
\code{\link[graphics]{smoothScatter}}) and for more than two parameters we
produce a simple \code{\link[lattice]{splom}} plot. To select specific
parameters from a \code{flowFrame} for plotting, either subset the object or
specify the parameters as a character vector in the second argument to
\code{plot}. The \code{smooth} parameters lets you toggle between
density-type \code{\link[graphics]{smoothScatter}} plots and regular scatter
or pairs plots.  For far more sophisticated plotting of flow cytometry data,
see the lattice-style plot methods provided by this package.
}
\seealso{
\code{\link[flowViz]{xyplot}},
\code{\link[flowCore:flowFrame-class]{flowFrame}},
\code{\link[flowViz]{densityplot}}
}
\author{
F. Hahne
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/lpolygon-methods.R
\docType{methods}
\name{glpolygon-methods}
\alias{glpolygon-methods}
\alias{glpolygon}
\alias{glpolygon,curv1Filter,ANY-method}
\alias{glpolygon,complementFilter,ANY-method}
\alias{glpolygon,curv1Filter,flowFrame-method}
\alias{glpolygon,curv1Filter,missing-method}
\alias{glpolygon,curv1Filter,multipleFilterResult-method}
\alias{glpolygon,curv2Filter,ANY-method}
\alias{glpolygon,curv2Filter,flowFrame-method}
\alias{glpolygon,curv2Filter,multipleFilterResult-method}
\alias{glpolygon,filter,missing-method}
\alias{glpolygon,filterResult,flowFrame-method}
\alias{glpolygon,filterResult,missing-method}
\alias{glpolygon,filterResult,ANY-method}
\alias{glpolygon,kmeansFilter,ANY-method}
\alias{glpolygon,norm2Filter,ANY-method}
\alias{glpolygon,norm2Filter,flowFrame-method}
\alias{glpolygon,norm2Filter,logicalFilterResult-method}
\alias{glpolygon,polygonGate,character-method}
\alias{glpolygon,polygonGate,filterResult-method}
\alias{glpolygon,polygonGate,flowFrame-method}
\alias{glpolygon,quadGate,character-method}
\alias{glpolygon,quadGate,filterResult-method}
\alias{glpolygon,quadGate,flowFrame-method}
\alias{glpolygon,rectangleGate,character-method}
\alias{glpolygon,rectangleGate,filterResult-method}
\alias{glpolygon,rectangleGate,flowFrame-method}
\alias{glpolygon,ellipsoidGate,character-method}
\alias{glpolygon,ellipsoidGate,filterResult-method}
\alias{glpolygon,ellipsoidGate,flowFrame-method}
\alias{glpolygon,subsetFilter,ANY-method}
\title{Drawing filter regions}
\usage{
\S4method{glpolygon}{filter,missing}(x, data, verbose = TRUE,
  gpar = flowViz.par.get(), strict = TRUE, ...)
}
\arguments{
\item{x}{filter or filterResult or any derived filter class}

\item{data}{flowFrame or filterResult or character or missing or ANY}

\item{verbose}{logical}

\item{gpar}{a list of graphical parameters. see 'help(flowViz.par.get)' for details.}

\item{strict}{logical}

\item{...}{other arguments}
}
\value{
The methods will return the outlines of the gate region as polygon
vertices.
}
\description{
These methods extend the lattice \code{\link[lattice:llines]{lpolygon}}
methods for drawing of \code{\link[flowCore:filter-class]{filter}} regions.
They allow for multiple dispatch, since not all
\code{\link[flowCore:filter-class]{filter}} types need to be evaluated for
plotting, but this decision should be made internally.
}
\details{
When plotting \code{\link[flowCore:flowFrame-class]{flowFrames}} using the
any of the lattice-type \code{plot} method provided by \code{flowViz}, the
plotted parameters are recorded, which makes it possible to correctly
overlay the outlines of \code{\link[flowCore:filter-class]{filter}} assuming
that they are defined for the respective parameters. Warnings and error will
be cast for the cases where the parameters are non-distinct or ambigious.
These methods are meant to be used within lattice panel functions and are
probably not of much use outside of those.
}
\section{Methods}{


\describe{

\item{x = "filter", data = "missing"}{ General method for all objects
inheriting from \code{\link[flowCore:filter-class]{filter}}. This is used as
the default when no more explicit method is found. It tries to find the
plotted parameters from the internal \code{flowViz.state} environment. This
only works if the flow data has been plotted using the \code{plot} methods
provided by this \code{flowViz} package. }

\item{x = "filterResult", data = "missing"}{ General method for all
\code{\link[flowCore:filterResult-class]{filterResult}} object. This
basically extracts the \code{\link[flowCore:filter-class]{filter}} from the
\code{\link[flowCore:filterResult-class]{filterResult}} and dispatches on
that. }

\item{x = "filterResult", data = "flowFrame"}{ For some
\code{\link[flowCore:filter-class]{filter}} types we need the raw data to
re-evaluate the filter. }

\item{x = "curv1Filter", data = "ANY"}{ We either need a
\code{\link[flowCore:filterResult-class]{filterResult}} or the raw data as a
\code{\link[flowCore:flowFrame-class]{flowFrame}} for
\code{\link[flowStats:curv1Filter-class]{curv1Filter}}s. }

\item{x = "curv1Filter", data = "flowFrame"}{ see above }

\item{x = "curv1Filter", data = "missing"}{ see above }

\item{x = "curv1Filter", data = "multipleFilterResult"}{ see above }

\item{x = "curv2Filter", data = "ANY"}{ We either need a
\code{\link[flowCore:filterResult-class]{filterResult}} or the raw data as a
\code{\link[flowCore:flowFrame-class]{flowFrame}} for
\code{\link[flowStats:curv2Filter-class]{curv2Filter}}.}

\item{x = "curv2Filter", data = "flowFrame"}{ see above }

\item{x = "curv2Filter", data = "multipleFilterResult"}{ see above }

\item{x = "kmeansFilter", data = "ANY"}{ We don't know how to plot regions
of a \code{\link[flowCore:kmeansFilter]{kmeansFilter}}, hence we warn. }

\item{x = "norm2Filter", data = "ANY"}{ We either need a
\code{\link[flowCore:filterResult-class]{filterResult}} or the raw data as a
\code{\link[flowCore:flowFrame-class]{flowFrame}} for
\code{\link[flowStats:norm2Filter-class]{norm2Filter}}.}

\item{x = "norm2Filter", data = "flowFrame"}{ see above }

\item{x = "norm2Filter", data = "logicalFilterResult"}{ see above }

\item{x = "polygonGate", data = "character"}{ We can plot a
\code{\link[flowCore]{polygonGate}} directly from the gate definition. }

\item{x = "polygonGate", data = "filterResult"}{ see above }

\item{x = "polygonGate", data = "flowFrame"}{ see above }

\item{x = "quadGate", data = "character"}{ We can plot a
\code{\link[flowCore]{quadGate}} directly from the gate definition. }

\item{x = "quadGate", data = "filterResult"}{ see above }

\item{x = "quadGate", data = "flowFrame"}{ see above }

\item{x = "rectangleGate", data = "character"}{ We can plot a
\code{\link[flowCore]{rectangleGate}} directly from the gate definition. }

\item{x = "rectangleGate", data = "filterResult"}{ see above }

\item{x = "rectangleGate", data = "flowFrame"}{ see above }

\item{x = "ellipsoidGate", data = "character"}{ We can plot a
\code{\link[flowCore]{rectangleGate}} directly from the gate definition. }

\item{x = "ellipsoidGate", data = "filterResult"}{ see above }

\item{x = "ellipsoidGate", data = "flowFrame"}{ see above }

}
}

\seealso{
\code{\link[flowCore:filter-class]{filter}},
\code{\link[flowCore:flowFrame-class]{flowFrame}},
\code{\link[flowViz:glpoints-methods]{glpoints}}
}
\author{
F. Hahne
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/latticeMethods.R, R/parallel.R
\docType{methods}
\name{levelplot,formula,flowSet-method}
\alias{levelplot,formula,flowSet-method}
\alias{lattice-methods}
\alias{qqmath,formula,flowSet-method}
\alias{parallelplot,flowFrame,missing-method}
\alias{parallelplot,formula,flowSet-method}
\title{Methods implementing Lattice displays for flow data}
\usage{
\S4method{levelplot}{formula,flowSet}(x, data, xlab, ylab,
  as.table = TRUE, contour = TRUE, labels = FALSE, n = 50, ...)

\S4method{qqmath}{formula,flowSet}(x, data, xlab, ylab,
  f.value = function(n) ppoints(ceiling(sqrt(n))),
  distribution = qnorm, ...)

\S4method{parallelplot}{flowFrame,missing}(x, data, reorder.by = function(x)
  var(x, na.rm = TRUE), time = "Time", exclude.time = TRUE, ...)

\S4method{parallelplot}{formula,flowSet}(x, data, time = "Time",
  exclude.time = TRUE, filter = NULL, xlab = NULL, ylab = NULL,
  ...)
}
\arguments{
\item{x}{a formula describing the structure of the plot and the variables to
be used in the display.}

\item{data}{a \code{flowSet} object that serves as a source of data.}

\item{xlab, ylab}{Labels for data axes, with suitable defaults taken from the
formula}

\item{as.table, contour, labels}{These arguments are passed unchanged to the
corresponding methods in lattice, and are listed here only because they
provide different defaults.  See documentation for the original methods for
details.}

\item{n}{the number of bins on each axis to be used when evaluating the
density}

\item{\dots}{more arguments, usually passed on to the underlying lattice
methods.}

\item{f.value, distribution}{number of points used in Q-Q plot, and the
reference distribution used.  See \code{\link[lattice:qqmath]{qqmath}} for
details.}

\item{reorder.by}{a function, which is applied to each column.  The columns
are ordered by the results.  Reordering can be suppressed by setting this to
\code{NULL}.}

\item{time}{A character string giving the name of the column recording time.}

\item{exclude.time}{logical, specifying whether to exclude the time variable
from a scatter plot matrix or parallel coordinates plot.  It is rarely
meaningful not to do so.}

\item{filter}{flowCore filter}
}
\description{
Various methods implementing multipanel visualizations for flow data using
infrastructure provided in the lattice package.  The original generics for
these methods are defined in lattice, and these S4 methods (mostly) dispatch
on a formula and the \code{data} argument which must be of class
\code{flowSet} or \code{flowFrame}.  The formula has to be fairly basic:
conditioning can be done using phenodata variables and channel names (the
\code{colnames} slot) can be used as panel variables. See examples below for
sample usage.
}
\details{
Not all standard lattice arguments will have the intended effect, but many
should.  For a fuller description of possible arguments and their effects,
consult documentation on lattice (Trellis docs would also work for the
fundamentals).
}
\section{Methods}{
 \describe{

\item{qqmath}{\code{signature(x = "formula", data = "flowSet")}: creates
theoretical quantile plots of a given channel, with one or more samples per
panel }

\item{levelplot}{\code{signature(x = "formula", data = "flowSet")}: similar
to the \code{xyplot} method, but plots estimated density (using
\code{\link[MASS:kde2d]{kde2d}}) with a common z-scale and an optional color
key.  }

\item{parallelplot}{\code{signature(x = "flowFrame", data = "missing")}: draws a
parallel coordinates plot of all channels (excluding time, by default) of a
\code{flowFrame} object.  This is rarely useful without transparency, but
that is currently only possible with the \code{\link{pdf}} device (and
perhaps the aqua device as well).  }

}
}

\examples{

library(flowCore)
data(GvHD)

qqmath( ~ `FSC-H` | factor(Patient), GvHD,
       grid = TRUE, type = "l",
       f.value = ppoints(100))


## contourplot of bivariate density:

require(colorspace)
YlOrBr <- c("#FFFFD4", "#FED98E", "#FE9929", "#D95F0E", "#993404")
colori <- colorRampPalette(YlOrBr)
levelplot(asinh(`SSC-H`) ~ asinh(`FSC-H`) | Visit + Patient, GvHD, n = 20,
          col.regions = colori(50), main = "Contour Plot")



## parallel coordinate plots

parallelplot(GvHD[["s6a01"]])

\dontrun{

## try with PDF device
parallelplot(GvHD[["s7a01"]], alpha = 0.01)

}

}
\keyword{dplot}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/addNames-methods.R
\docType{methods}
\name{addName-methods}
\alias{addName-methods}
\alias{addName}
\alias{addName,curv1Filter,character-method}
\alias{addName,curv1Filter,logical-method}
\alias{addName,curv2Filter,character-method}
\alias{addName,curv2Filter,logical-method}
\alias{addName,ellipsoidGate,character-method}
\alias{addName,ellipsoidGate,logical-method}
\alias{addName,kmeansFilter,character-method}
\alias{addName,kmeansFilter,logical-method}
\alias{addName,polygonGate,character-method}
\alias{addName,polygonGate,logical-method}
\alias{addName,quadGate,character-method}
\alias{addName,quadGate,logical-method}
\alias{addName,quadGate,matrix-method}
\alias{addName,rectangleGate,character-method}
\alias{addName,rectangleGate,logical-method}
\title{Add gate names to a flowViz plot.}
\usage{
\S4method{addName}{rectangleGate,character}(x, name, data, gp, pos = 0.5,
  abs = FALSE, xlim, ylim, ...)
}
\arguments{
\item{x}{rectangleGate, ellipsoidGate, quadGate, polygonGate or kmeansFilter}

\item{name}{character or logical or matrix}

\item{data}{flowFrame}

\item{gp}{a list of graphical parameters}

\item{pos, abs}{specifying location of the name. see 'help(xyplot)' for more details}

\item{xlim, ylim}{limits of axis}

\item{...}{other arguments}
}
\value{
The methods are called for their side effects. No value is returned.
}
\description{
These methods add gate names to a \code{flowViz} plot, either derived from
the population identifiers or as provided by the user. These methods are
ment for internal use and are usually not called directly by the user.
}
\section{Methods}{
 \describe{

\item{x = "curv1Filter", name = "character"}{ User-provided names. }

\item{x = "curv1Filter", name = "logical"}{ Get names from the
\code{\link[flowCore:filter-class]{filter}} or
\code{\link[flowCore:filterResult-class]{filterResult}} object}

\item{x = "curv2Filter", name = "character"}{ see above }

\item{x = "curv2Filter", name = "logical"}{ see above }

\item{x = "ellipsoidGate", name = "character"}{ see above }

\item{x = "ellipsoidGate", name = "logical"}{ see above }

\item{x = "kmeansFilter", name = "character"}{ see above }

\item{x = "kmeansFilter", name = "logical"}{ see above }

\item{x = "polygonGate", name = "character"}{ see above }

\item{x = "polygonGate", name = "logical"}{ see above }

\item{x = "quadGate", name = "character"}{ see above }

\item{x = "quadGate", name = "logical"}{ see above }

\item{x = "quadGate", name = "matrix"}{ see above }

\item{x = "rectangleGate", name = "character"}{ see above }

\item{x = "rectangleGate", name = "logical"}{ see above }

}
}

\author{
F. Hahne
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/points-methods.R
\docType{methods}
\name{gpoints-methods}
\alias{gpoints-methods}
\alias{gpoints}
\alias{gpoints,curv1Filter,flowFrame,character-method}
\alias{gpoints,curv2Filter,flowFrame,character-method}
\alias{gpoints,filter,flowFrame,missing-method}
\alias{gpoints,filter,missing,ANY-method}
\alias{gpoints,filterResult,flowFrame,character-method}
\alias{gpoints,kmeansFilter,flowFrame,character-method}
\alias{gpoints,norm2Filter,flowFrame,character-method}
\alias{gpoints,polygonGate,flowFrame,character-method}
\alias{gpoints,quadGate,flowFrame,character-method}
\alias{gpoints,rectangleGate,flowFrame,character-method}
\title{Adding points within a gate to a plot}
\usage{
\S4method{gpoints}{filter,flowFrame,missing}(x, data, channels,
  verbose = TRUE, filterResult = NULL, ...)
}
\arguments{
\item{x}{filter, filterResult or any derived filter class}

\item{data}{flowFrame or missing}

\item{channels}{character or missing}

\item{verbose}{logical}

\item{filterResult}{filterResult class}

\item{...}{other arguments}
}
\description{
These methods extend the basic graphics \code{\link{points}} methods for
drawing of points contained within a
\code{\link[flowCore:filter-class]{filter}}. They allow for multiple
dispatch, since not all \code{\link[flowCore:filter-class]{filter}} types
need to be evaluated for plotting, but this decision should be made
internally. In any case, we need the raw data in the form of a
\code{\link[flowCore:flowFrame-class]{flowFrame}}.
}
\details{
When plotting \code{\link[flowCore:flowFrame-class]{flowFrame}}s using the
\code{plot} method provided by \code{flowViz}, the plotted parameters are
recorded, which makes it possible to correctly overlay the points within
\code{\link[flowCore:filter-class]{filter}}s assuming that they are defined
for the respective parameters. Warnings and error will be cast for the cases
where the parameters are non-distinct or ambigious.
}
\section{Methods}{


\describe{

\item{x = "filter", data = "flowFrame", channels = "missing"}{ General
method for all objects inheriting from
\code{\link[flowCore:filter-class]{filter}}. This is used as the default
when no more explicit method is found. It tries to find the plotted
parameters from the internal \code{flowViz.state} environment. This only
works if the flow data has been plotted using the \code{plot} methods
provided by this \code{flowViz} package. }

\item{x = "filter", data = "missing", channels = "ANY"}{ This gives a useful
error message when we don't get what we need. }

\item{x = "filterResult", data = "flowFrame", channels = }{ We can get all
the information about a \code{\link[flowCore:filter-class]{filter}} from its
\code{\link[flowCore:filterResult-class]{filterResult}} without the need to
re-evaluate.}\item{ "character"}{ We can get all the information about a
\code{\link[flowCore:filter-class]{filter}} from its
\code{\link[flowCore:filterResult-class]{filterResult}} without the need to
re-evaluate.}

\item{x = "curv1Filter", data = "ANY"}{ We either need a
\code{\link[flowCore:filterResult-class]{filterResult}} or the raw data as a
\code{\link[flowCore:flowFrame-class]{flowFrame}} for
\code{\link[flowStats:curv1Filter-class]{curv1Filter}}s. }

\item{x = "curv1Filter", data = "flowFrame"}{ see above }

\item{x = "curv1Filter", data = "missing"}{ see above }

\item{x = "curv1Filter", data = "multipleFilterResult"}{ see above }

\item{x = "curv2Filter", data = "ANY"}{ We either need a
\code{\link[flowCore:filterResult-class]{filterResult}} or the raw data as a
\code{\link[flowCore:flowFrame-class]{flowFrame}} for
\code{\link[flowStats:curv2Filter-class]{curv2Filter}}s.}

\item{x = "curv1Filter", data = "flowFrame", channels = }{ We evaluate the
\code{\link[flowCore:filter-class]{filter}} on the
\code{\link[flowCore:flowFrame-class]{flowFrame}} and plot the subset of
selected points. By default, every subpopulation (if there are any) is
colored differently.}\item{ "character"}{ We evaluate the
\code{\link[flowCore:filter-class]{filter}} on the
\code{\link[flowCore:flowFrame-class]{flowFrame}} and plot the subset of
selected points. By default, every subpopulation (if there are any) is
colored differently.}

\item{x = "curv2Filter", data = "flowFrame", channels = "character"}{ see
above }

\item{x = "kmeansFilter", data = "flowFrame", channels = }{ see above
}\item{ "character"}{ see above }

\item{x = "norm2Filter", data = "flowFrame", channels = }{ see above }\item{
"character"}{ see above }

\item{x = "polygonGate", data = "flowFrame", channels = }{ see above }\item{
"character"}{ see above }

\item{x = "quadGate", data = "flowFrame", channels = "character"}{ see above
}

\item{x = "rectangleGate", data = "flowFrame", channels = }{ see above
}\item{ "character"}{ see above }

}
}

\seealso{
\code{\link[flowCore:filter-class]{filter}},
\code{\link[flowCore:flowFrame-class]{flowFrame}}, \code{\link{glines}},
\code{\link{gpolygon}}
}
\author{
F. Hahne
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/xyplot.R
\name{.process_flowFrame_overlay}
\alias{.process_flowFrame_overlay}
\title{convert a single flowFrame or a list of flowFrames to a list of flowSet}
\usage{
.process_flowFrame_overlay(overlay, sn)
}
\arguments{
\item{overlay}{flowFrame or a list of flowFrame objects}

\item{sn}{sample name}
}
\description{
convert a single flowFrame or a list of flowFrames to a list of flowSet
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/xyplot.R
\docType{methods}
\name{xyplot,flowFrame,missing-method}
\alias{xyplot,flowFrame,missing-method}
\alias{prepanel.xyplot.flowframe.time}
\alias{panel.xyplot.flowframe.time}
\alias{xyplot}
\alias{xyplot,formula,flowFrame-method}
\alias{prepanel.xyplot.flowframe}
\alias{panel.xyplot.flowframe}
\alias{xyplot,formula,flowSet-method}
\alias{prepanel.xyplot.flowset}
\alias{panel.xyplot.flowset}
\alias{xyplot,formula,view-method}
\alias{xyplot,view,missing-method}
\alias{xyplot,formula,gateView-method}
\alias{xyplot,formula,ncdfFlowSet-method}
\alias{xyplot,formula,ncdfFlowList-method}
\title{Methods implementing Lattice xyplots for flow data.}
\usage{
\S4method{xyplot}{flowFrame,missing}(x, data, time, xlab, ylab = "",
  layout, prepanel = prepanel.xyplot.flowframe.time,
  panel = panel.xyplot.flowframe.time, type = "discrete", ...)

prepanel.xyplot.flowframe.time(x, y, frame, time, xlim, ylim, ...)

panel.xyplot.flowframe.time(x, y, frame, time, type = "discrete",
  nrpoints = 0, binSize = 100, ...)

\S4method{xyplot}{formula,flowFrame}(x, data, filter = NULL,
  overlay = NULL, stats = FALSE, strip.text = NULL, ...)

prepanel.xyplot.flowframe(frame, channel.x.name, channel.y.name, x, y,
  xlim, ylim, ...)

panel.xyplot.flowframe(frame, filter = NULL, smooth = TRUE,
  margin = TRUE, outline = FALSE, channel.x.name, channel.y.name,
  pch = gp$flow.symbol$pch, alpha = gp$flow.symbol$alpha,
  cex = gp$flow.symbol$cex, col = gp$flow.symbol$col, gp, xbins = 0,
  binTrans = sqrt, stats = FALSE, pos = 0.5, digits = 2,
  abs = FALSE, overlay = NULL, checkName = TRUE, sample.ratio = 1,
  overlay.symbol = NULL, ...)

\S4method{xyplot}{formula,flowSet}(x, data, ...)

prepanel.xyplot.flowset(x, frames, channel.x.name, channel.y.name, xlim,
  ylim, ...)

panel.xyplot.flowset(x, frames, filter = NULL, channel.x, channel.y,
  overlay = NULL, stats = FALSE, ...)

\S4method{xyplot}{formula,view}(x, data, ...)

\S4method{xyplot}{view,missing}(x, data, ...)

\S4method{xyplot}{formula,gateView}(x, data, filter = NULL, par.settings,
  ...)

\S4method{xyplot}{formula,ncdfFlowSet}(x, data, ...)

\S4method{xyplot}{formula,ncdfFlowList}(x, data, ...)
}
\arguments{
\item{x}{A formula describing the structure of the plot and the variables to
be used in the display.  In the \code{prepanel} and \code{panel} functions,
also the names of \code{\link[flowCore:flowFrame-class]{flowFrames}} or any
of the annotation data columns in the \code{phenoData} slot.}

\item{data, y, frame}{a \code{flowSet}, \code{\link[flowCore:flowFrame-class]{flowFrame}},
\code{ncdfFlowSet}, or \code{ncdfFlowList} object that serves as the
source of data.}

\item{time}{A character string giving the name of the data column recording
time. If not provided, we try to guess from the available parameters.}

\item{xlab, ylab}{Labels for data axes, with suitable defaults taken from the
formula.}

\item{layout}{These arguments are passed unchanged to the corresponding
methods in lattice, and are listed here only because they provide different
defaults.  See documentation for the original methods for details.}

\item{prepanel}{The prepanel function. See
\code{\link[lattice:xyplot]{xyplot}}.}

\item{panel}{The panel function. See \code{\link[lattice:xyplot]{xyplot}}.}

\item{type}{type of rendering; see
\code{\link[lattice:panel.xyplot]{panel.xyplot}} for details. For the basic
\code{flowFrame} method without a detailed formula, the addtional type
    \code{discrete} is available, which plots a smoothed average of the flow
    cytometry values against time.}

\item{\dots}{marker.only \code{logical} specifies whether to show both channel and marker
names

More arguments, usually passed on to the underlying lattice methods.}

\item{xlim, ylim}{limits for data axes. If not given, they are taken from the
ranges stored in flowFrame}

\item{nrpoints}{The number of points plotted on the smoothed plot in sparse
regions. This is only listed here because we use a different default. See
    \code{\link[lattice:panel.smoothScatter]{panel.smoothScatter}} for details.}

\item{binSize}{The size of a bin (i.e., the number of events within a bin)
used for the smoothed average timeline plots.}

\item{filter}{A \code{\link[flowCore:filter-class]{filter}},
\code{\link[flowCore:filterResult-class]{filterResult}} or
\code{\link[flowCore:filterResult-class]{filterResultList}} object or a list
of such objects of the same length as the \code{flowSet}.  Also a
\code{\link[flowCore:filters-class]{filters}} or A
\code{\link[flowCore:filtersList-class]{filtersList}} can be passed to
xyplot in order to plot multiple filters/gates(with the same x,y parameters)
on one panel to represent multiple sub-populations.  The appropriate
spherical 2D representation of this filter will be superimposed on the plot
if \code{smooth=TRUE}, or the result of the filtering operation will be
indicated by grouping if \code{smooth=FALSE}. The software will figure out
whether the \code{filter} needs to be evaluated in order to be plotted (in
which case providing a \code{filterResult} can speed things up
considerably).}

\item{overlay}{The extra cell events plotted on top of the current cell
population.  It is a \code{flowSet} for \code{panel.xyplot.flowset} function
and a \code{flowFrame} for \code{xyplot(c("formula","flowFrame"))} method.}

\item{stats, pos, digits, abs}{Arguments to control statistics that is
associated with \code{\link[flowCore:filter-class]{filter}} to be plotted
Currently only population proportion/percentage is supported.  \code{stats}
is a \code{logical} scalar indicating whether to display statistics. Default
is FALSE.  \code{pos} is the \code{numeric} scalar (range within c(0,1)) or
vector(length of 2,first is for x-axis,second for y-axis) to control the
position of the statistics label. It is set as 0.5,which is the center.
\code{digits} is an \code{integer} indicating the number of significant
digits to be used when displaying the percentage of population
statistics,Default is 2. see more details from \code{\link[base]{format}}
\code{abs} is a \code{logical} scalar indicating whether the \code{pos} is
relative to the gate boundary or the entire xy-axis(absolute position).  By
default it is set as FALSE,which indicates the position is relative to gate.}

\item{strip.text}{A \code{character} that customizes the text in strip.
Default is NULL, which does not display the strip box at all. It is only
valid when plotting a \code{flowFrame}}

\item{channel.x.name, channel.y.name}{Character strings giving corresponding
names used to match filter parameters if applicable.}

\item{smooth}{Logical. If \code{TRUE}, \code{panel.smoothScatter} is used to
display a partially smoothed version of the data.  Otherwise, events are
plotted individually, as in a standard scatter plot. If \code{FALSE}, a
graphical parameter \code{colramp} can be used to obtain a coloring of
points that is indicative of their local density.}

\item{margin}{Logical indicating whether to truncate the density estimation
on the margins of the measurement range and plot margin events as lines if
\code{smooth=TRUE}. To avoid visual artifacts it is highly recommended to
set this option to \code{TRUE}.}

\item{outline}{Logical, specifying whether to add the boundaries of a gate
to the plot when \code{smooth=FALSE} in addition to the grouping. Defaults
to \code{FALSE}.}

\item{pch, cex, col, alpha}{Graphical parameters used when \code{smooth=FALSE}.
These mostly exist for conveniance and much more control is available
throught the \code{lattice}-like \code{par.setting} and
\code{flowViz.par.set} customization. See \code{\link{flowViz.par.set}} for
details.}

\item{gp}{A list of graphical parameters that are passed down to the low
level panel functions. This is for internal use only. The public user
interface to set graphical parameters is either \code{par.settings} for
customization of a single call or \code{flowViz.par.set} for customization
of session-wide defaults.}

\item{xbins}{The argument passed to \code{\link[hexbin:hexbin]{hexbin}}
,which is the number of bins partitioning the range of xbnds.  It is set as
0 by default,which plots all the events without binning.  When it is larger
than 0,hexbin plot engine is used for the faster plotting.  Note that it is
only valid when \code{smooth} is set as FALSE .}

\item{binTrans}{The argument passed to
\code{\link[hexbin:grid.hexagons]{grid.hexagons}} ,which is a transformation
function (or NULL) for the count.  It is \code{\link[base:sqrt]{sqrt}} by
default.}

\item{checkName}{\code{logical} indicating whether to skip checking the
bracket '(' in channel name}

\item{sample.ratio}{\code{numeric} the ratio of sub-sampling of events to
speed up plotting.}

\item{overlay.symbol}{list of the lattice graphic parameters to format the
overlay points.}

\item{frames}{An environment containing frame-specific data.}

\item{channel.x, channel.y}{Expressions defining the x and y variables in
terms of columns in the data.  Can involve functions or multiple columns
from the data, however this usage is discouraged.}

\item{par.settings}{A list of lists of graphical parameters.  See \code{\link{flowViz.par.set}} for details.}
}
\description{
These functions create Trellis scatter plots (a.k.a. dot plots in the Flow
Cytometry community) from flow cytometry data.
}
\details{
The implementation of \code{xyplot} in \code{flowViz} is very close to the
original \code{lattice} version. Concepts like conditioning and the use of
panels apply directly to the flow cytometry data. The single fundamental
difference is that conditioning variables are not evaluated in the context
of the raw data, but rather in the \code{phenoData} slot environment (only
for the \code{flowSet} methods. Thus, we can directly condition on pheotypic
variables like sample groups, patients or treatments.

In the formula interface, the primary and secondary variables (separated by
the tilde) have to be valid parameter names. Please note that frequently
used variants like \code{FSC-H} and \code{SSC-H} are not syntactically
correct R symbols, and need to be wrapped in \code{` `}. E.g.,
\code{`FSC-H`}. For \code{flowSets}, the use of a conditioning variable is
optional. We implicitely condition on \code{flowFrames} and the default is
to arrange panels by sample names.
}
\section{Methods}{


\describe{

\item{xyplot}{\code{signature(x = "flowFrame", data = "missing")}: Creates
diagnostic time series plots of flow parameter values against time. These
plots are useful to detect quality issues in the raw data. If not provided
explicitely via the \code{tine} argument, the time parameter will be
automatically detected. The additional arguments \code{xlab}, \code{ylab},
\code{nrpoints}, and \code{layout} are only listed because \code{flowViz}
provides different defaults. Internally, they are directly passed on to the
underlying \code{lattice} functions}. Argument \code{type} can be a
combination of any of the types allowed in \code{lattice xyplots}, or
\code{discrete}, in which case a smoothed average of the parameter against
time is plotted. \code{binSize} controls the binning that is used for the
smoothing procedure.

\item{xyplot}{\code{signature(x = "formula", data = "flowFrame")}: Creates
scatter plots (a.k.a. dot plots) of a pair of FCM channels. Depending on the
setting of the \code{smooth} argument, the data will be rendered as a
partially smoothed density estimate (\code{smooth=TRUE}, the default) or as
a regular scatter plot with separate points for individual events. The
formula interface allows for fairly general plotting, however there are
certain limitations on the use of expressions as part of the formulae.
Unless you are sure about what you are doing, you should transform the raw
data in a separate step using one of the tools in the
\code{\link[flowCore:flowCore-package]{flowCore}} package rather than inline
using the formula interface. The method allows to superimpose gating results
though the \code{filter} argument. If \code{smooth=TRUE}, we try to add
spherical 2D representations of the gates if applicable. For
\code{smooth=FALSE}, gates are indicated by a grouping mechanism using
different point shapes or colors (unless \code{outline} is also \code{TRUE},
in which case the gate outlines are superimposed in addition to the
grouping). Argument \code{margins} controls how events on the margins of the
measurement range are treated. The default (\code{TRUE}) is to discard them
from any density estimation and later add them as separate glyphs. Argument \code{par.settings} can be used
to supply lists of graphical parameters. See \code{\link{flowViz.par.set}} for details on controlling graphical
parameters in these plots. }

\item{xyplot}{\code{signature(x = "formula", data = "flowSet")}: Scatter
plots from a \code{flowSet} object. We allow for conditioning on variables
in the \code{phenoData} slot of the \code{flowSet}. All additional arguments
that apply to the \code{flowFrame} method are also valid for
\code{flowSets}. }

}
}

\examples{

library(flowCore)
data(GvHD)
GvHD <- GvHD[pData(GvHD)$Patient \%in\% 5:6]

## a bivariate scatterplot
## by default ('smooth=TRUE') panel.smoothScatter is used
xyplot(`FSC-H` ~ `SSC-H`, GvHD[["s5a05"]], nbin = 100,
main="A single flowFrame")

## A non-smooth version of the same data
xyplot(`FSC-H` ~ `SSC-H`, GvHD[["s5a05"]], nbin = 100,
main="A single flowFrame", smooth=FALSE)

## A non-smooth version of the same data with customerized color scheme
require(IDPmisc)
colramp <- colorRampPalette(IDPcolorRamp(21))
xyplot(`FSC-H` ~ `SSC-H`, GvHD[["s5a05"]], nbin = 100,
       main="A single flowFrame", smooth=FALSE,
       colramp=colramp, pch=20, cex=0.1)

## A hexbin version of non-smooth scatter plot  
xyplot(`FSC-H` ~ `SSC-H`, GvHD[["s5a05"]], xbin = 128
       ,main="A single flowFrame", smooth=FALSE)


## Visual artifacts created by the pileup of margin events
xyplot(`FSC-H` ~ `SSC-H`, GvHD[["s5a05"]], nbin = 100,
       main="A single flowFrame", margin=FALSE)


## simple bivariate scatter plot (a.k.a. dot plot)
## for the whole flowSet, conditioning on Patient and
## Visit
xyplot(`SSC-H` ~ `FSC-H` | Patient:Visit, data = GvHD)

## Same bivariate scatter plot with replacing default color
require(IDPmisc)
cols <- colorRampPalette(IDPcolorRamp(21))
xyplot(`SSC-H` ~ `FSC-H` | Patient:Visit, data = GvHD, colramp=cols)

## several examples with time on the X axis
## first for a flowFrame
xyplot(GvHD[[1]])

## and for flowSets
xyplot(`FSC-H` ~ Time | Visit, GvHD, 
       smooth = FALSE, type = "l", 
       subset = (Patient == 5), xbin = 32)

xyplot(`FSC-H` ~ Time | Patient+Visit, GvHD, 
       smooth = FALSE, type = "a",
       strip = FALSE, strip.left = TRUE,
       aspect = "xy", xbin = 32)


## combine plots for two channels
ssc.time <- 

    xyplot(`SSC-H` ~ Time | factor(Patient):factor(Visit), GvHD, 
           smooth = FALSE, type = "a",
           strip = FALSE,
           strip.left = strip.custom(horizontal = TRUE),
           par.strip.text = list(lines = 3),
           between = list(y = rep(c(0, 0.5), c(6, 1))),
           scales = list(x = list(axs = "i"), y = list(draw = FALSE)),
           layout = c(1, 14), xbin = 32)

fsc.time <- 
    xyplot(`FSC-H` ~ Time | factor(Patient):factor(Visit), GvHD, 
           smooth = FALSE, type = "a",
           strip = FALSE,
           strip.left = strip.custom(horizontal = TRUE),
           par.strip.text = list(lines = 3),
           between = list(y = rep(c(0, 0.5), c(6, 1))),
           scales = list(x = list(axs = "i"), y = list(draw = FALSE)),
           layout = c(1, 14), xbin = 32)

plot(fsc.time, split = c(1, 1, 2, 1))
plot(ssc.time, split = c(2, 1, 2, 1), newpage = FALSE)


## saving plots as variables allows more manipulation
plot(update(fsc.time[8:14], layout = c(1, 7)),
     split = c(1, 1, 1, 2))

plot(update(ssc.time[8:14], layout = c(1, 7)),
     split = c(1, 2, 1, 2), newpage = FALSE)


## displaying filters
library(flowStats)
n2gate <- norm2Filter("SSC-H", "FSC-H")

xyplot(`SSC-H` ~ `FSC-H` | Patient:Visit, data = GvHD,
       filter=n2gate, subset=Patient==5)

xyplot(`SSC-H` ~ `FSC-H` | Patient:Visit,
       data=transform("SSC-H"=asinh,"FSC-H"=asinh) \%on\% GvHD,
       smooth=FALSE, filter=n2gate, subset=Patient == 5, xbin = 32)


## displaying filters with stats
n2gate.results <- filter(GvHD, n2gate)

xyplot(`SSC-H` ~ `FSC-H` | Visit, data=GvHD,
       subset=Patient == "6",
       filter=n2gate.results, smooth=FALSE, xbin = 32
       ,stats=TRUE
       ,abs=TRUE
       ,digits=3 
       )

       
## displaying multiple filters in one panel with stats
recGate1<-rectangleGate("FL3-H"=c(2.3,4.1),"FL2-H"=c(6.8,9))
recGate2<-rectangleGate("FL3-H"=c(1,3),"FL2-H"=c(4,6))
filters1<-filters(list(recGate1,recGate2))
trans<-transform("FL2-H"=asinh,"FL3-H"=asinh)
trans_data<-transform(GvHD[1:2],trans)
#replicate filters object across samples
flist <- list(filters1 , filters1)
names(flist) <- sampleNames(trans_data)
xyplot(`FL2-H` ~ `FL3-H`
	   ,data=trans_data 
       ,filter= flist
       ,stats=TRUE
       ,margin=FALSE
       , xbin = 32
       , smooth = FALSE
       )

#display recGate2 as a overlay 
overlay <- Subset(trans_data,recGate1)
xyplot(`FL2-H` ~ `FL3-H`
	   ,data=trans_data 
       ,filter=recGate2
       ,stats=TRUE
       ,margin=FALSE
       , smooth = FALSE
       , xbin = 32
       ,overlay= list(rect2 = overlay)
       ,par.settings = list(overlay.symbol = list(cex = 0.1))
       )




}
\seealso{
Not all standard lattice arguments will have the intended effect, but many
should.  For a fuller description of possible arguments and their effects,
consult documentation on lattice.
}
\author{
F. Hahne, D. Sarkar
}
\keyword{dplot}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/splom.R
\docType{methods}
\name{splom}
\alias{splom}
\alias{splom,flowFrame,missing-method}
\alias{panel.splom.flowframe}
\title{Method implementing Lattice scatter plot matrices for flow data.}
\usage{
\S4method{splom}{flowFrame,missing}(x, data, pscales, time,
  exclude.time = TRUE, names = FALSE, ...)
}
\arguments{
\item{x}{A formula describing the structure of the plot and the variables to
be used in the display.}

\item{data}{A \code{\link[flowCore:flowFrame-class]{flowFrame}} object
that serves as the source of data.}

\item{pscales}{This arguments is passed unchanged to the corresponding
methods in lattice, and is listed here only because it provides a different
default.  See documentation for the original methods for details.}

\item{time}{A character string giving the name of the data column recording
time. If not provided, we try to guess from the available parameters.}

\item{exclude.time}{Logical, specifying whether to exclude the time variable
from a scatter plot matrix. Defaults to \code{TRUE}.}

\item{names}{Logical specifying wether gate names should be added to the
plot. Currently, this feature is not supported for splom plots.}

\item{\dots}{More arguments, usually passed on to the underlying lattice
methods.}
}
\description{
This function create Trellis scatter plots matrices (splom) from flow
cytometry data.
}
\details{
The function draws a scatter plot matrix of the data for each flow parameter
in a \code{flowFrame}. For the most, one can think about this as a
rectangular arrangement of separate \code{\link[flowViz:xyplot]{xyplots}},
and most of that functionality is also available here. To be more precise,
the function repeatedly calls \code{panel.xyplot.flowframe} to do the actual
plotting. Please see its documentation for details.
}
\examples{

library(flowCore)
data(GvHD)
library(flowStats)

tf <- transformList(colnames(GvHD)[3:7], asinh)
dat <- tf \%on\% GvHD[[3]]


## scatter plot matrix of individual flowFrames
lattice.options(panel.error=NULL)
splom(dat)

splom(dat[,1:3], smooth = FALSE)


## displaying filters
rg <- rectangleGate("FSC-H"=c(200,400), "SSC-H"=c(300,700),
"FL1-H"=c(2,4), "FL2-A"=c(4,7))
splom(dat, filter=rg)

splom(dat, filter=rectangleGate("FSC-H"=c(400,800)))

splom(dat[,1:4], smooth = FALSE, filter=norm2Filter("FSC-H", "SSC-H", scale=1.5))



}
\seealso{
Not all standard lattice arguments will have the intended effect, but many
should.  For a fuller description of possible arguments and their effects,
consult documentation on lattice.
}
\author{
F. Hahne, D. Sarkar
}
\keyword{dplot}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/timeLinePlot.R
\docType{methods}
\name{timeLinePlot}
\alias{timeLinePlot}
\alias{timelineplot}
\alias{timeLinePlot,flowSet,character-method}
\alias{timeLinePlot,flowFrame,character-method}
\alias{timeLinePlot,ANY,missing-method}
\title{Plot channel values against time}
\usage{
timelineplot(x, channel, type = c("stacked", "scaled", "native",
  "frequency"), col, ylab = names(x), binSize, varCut = 1, ...)

\S4method{timeLinePlot}{flowSet,character}(x, channel,
  type = c("stacked", "scaled", "native", "frequency"), col = NULL,
  ylab = sampleNames(x), binSize, varCut = 1, ...)

\S4method{timeLinePlot}{flowFrame,character}(x, channel, ...)

\S4method{timeLinePlot}{ANY,missing}(x, channel, ...)
}
\arguments{
\item{x}{An object of class
\code{\link[flowCore:flowFrame-class]{flowFrame}} or
\code{\link[flowCore:flowSet-class]{flowSet}} containing the data to be
plotted.}

\item{channel}{The parameter for which the data is to be plotted}

\item{type}{One in 'stacked', 'scaled' or 'native'. 'stacked' will plot the
measurements for the frames on top of each other. 'scaled' will align the
median values around zero and 'native' will plot the values in the original
dimensions of the measurement range.}

\item{col}{Optional color parameter.}

\item{ylab}{The axis annotation to add on the y-axis for stacked plots.}

\item{binSize}{The number of events per bin. If not set, a reasonable
default is computed.}

\item{varCut}{The cutoff in the adjusted variance to which the quality score
is computed. Basically, all values that are outside of the confidence
interval defined by \code{\[my - signma * varCut, my + sigma * varCut\]}
will contribute to a positive quality score value.}

\item{...}{Further arguments that are passed on to the base plotting
functions.}
}
\value{
A numeric vector of quality scores.
}
\description{
Plots values of one parameter for each flowFrame in a flowSet against time.
}
\details{
Plotting flow cytometry data against the time domain can help to identify
problems with the fluidics or drifts in the instrument setting during
measurement runs.

This function creates plots for all flowFrames in a flowSet for a given
parameter against time. A barplot legend indicates the deviation from the
median for each sample. There is also a flowFrame method, which will create
a plot for a single flowFrame only.

In addition, the function computes a quality score for each frame, which
essentially is the sum of the positive distances of each bin mean from a
frame-specific confidence interval, divided by the number of bins. Values
larger than zero indicate a problem.
}
\section{Methods}{

}

\examples{

library(flowCore)
data(GvHD)
opar <- par(ask=TRUE)

res <- timeLinePlot(GvHD[[1]], "SSC-H")
res

res <- timeLinePlot(GvHD, "SSC-H")

res <- timeLinePlot(GvHD, "SSC-H", type="scaled", varCut=4)

res <- timeLinePlot(GvHD[1:4], "SSC-H", type="native", binSize=50)

par(opar)


}
\seealso{
\code{\link[flowCore:flowFrame-class]{flowFrame}},
\code{\link[flowCore:flowSet-class]{flowSet}}
}
\author{
F. Hahne
}
\keyword{dplot}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/polygon-methods.R
\docType{methods}
\name{gpolygon-methods}
\alias{gpolygon-methods}
\alias{gpolygon}
\alias{gpolygon,curv1Filter,ANY-method}
\alias{gpolygon,curv1Filter,flowFrame-method}
\alias{gpolygon,curv1Filter,missing-method}
\alias{gpolygon,curv1Filter,multipleFilterResult-method}
\alias{gpolygon,curv2Filter,ANY-method}
\alias{gpolygon,curv2Filter,flowFrame-method}
\alias{gpolygon,curv2Filter,multipleFilterResult-method}
\alias{gpolygon,filter,missing-method}
\alias{gpolygon,filterResult,flowFrame-method}
\alias{gpolygon,filterResult,ANY-method}
\alias{gpolygon,kmeansFilter,ANY-method}
\alias{gpolygon,norm2Filter,ANY-method}
\alias{gpolygon,norm2Filter,flowFrame-method}
\alias{gpolygon,norm2Filter,logicalFilterResult-method}
\alias{gpolygon,polygonGate,character-method}
\alias{gpolygon,polygonGate,filterResult-method}
\alias{gpolygon,polygonGate,flowFrame-method}
\alias{gpolygon,quadGate,character-method}
\alias{gpolygon,quadGate,filterResult-method}
\alias{gpolygon,quadGate,flowFrame-method}
\alias{gpolygon,rectangleGate,character-method}
\alias{gpolygon,rectangleGate,filterResult-method}
\alias{gpolygon,rectangleGate,flowFrame-method}
\alias{gpolygon,ellipsoidGate,character-method}
\alias{gpolygon,ellipsoidGate,filterResult-method}
\alias{gpolygon,ellipsoidGate,flowFrame-method}
\title{Drawing filter regions}
\usage{
\S4method{gpolygon}{filter,missing}(x, data, verbose = TRUE, ...)
}
\arguments{
\item{x}{filter or filterResult or any derived filter class}

\item{data}{flowFrame or filterResult or character or missing or ANY}

\item{verbose}{logical}

\item{...}{other arguments}
}
\description{
These methods extend the basic graphics \code{\link{polygon}} methods for
drawing of \code{\link[flowCore:filter-class]{filter}} regions. They allow
for multiple dispatch, since not all
\code{\link[flowCore:filter-class]{filter}} types need to be evaluated for
plotting, but this decision should be made internally.
}
\details{
When plotting \code{\link[flowCore:flowFrame-class]{flowFrame}}s using the
\code{plot} method provided by \code{flowViz}, the plotted parameters are
recorded, which makes it possible to correctly overlay the outlines of
\code{\link[flowCore:filter-class]{filter}}s assuming that they are defined
for the respective parameters. Warnings and error will be cast for the cases
where the parameters are non-distinct or ambigious.

The flow parameters plotted can be passed on to any of the methods through
the optional \code{channels} argument, which always gets precedence over
automatically detected parameters.

The methods support all plotting parameters that are available for the
\code{base} \code{polygon} functions.
}
\section{Methods}{


\describe{

\item{x = "filter", data = "missing"}{ General method for all objects
inheriting from \code{\link[flowCore:filter-class]{filter}}. This is used as
the default when no more explicit method is found. It tries to find the
plotted parameters from the internal \code{flowViz.state} environment. This
only works if the flow data has been plotted using the \code{plot} methods
provided by this \code{flowViz} package. }

\item{x = "filterResult", data = "ANY"}{ General method for all
\code{\link[flowCore:filterResult-class]{filterResult}} object. This
basically extracts the \code{\link[flowCore:filter-class]{filter}} from the
\code{\link[flowCore:filterResult-class]{filterResult}} and dispatches on
that. }

\item{x = "filterResult", data = "flowFrame"}{ For some
\code{\link[flowCore:filter-class]{filter}} types we need the raw data to
re-evaluate the filter. }

\item{x = "curv1Filter", data = "ANY"}{ We either need a
\code{\link[flowCore:filterResult-class]{filterResult}} or the raw data as a
\code{\link[flowCore:flowFrame-class]{flowFrame}} for
\code{\link[flowStats:curv1Filter-class]{curv1Filter}}s. }

\item{x = "curv1Filter", data = "flowFrame"}{ see above }

\item{x = "curv1Filter", data = "missing"}{ see above }

\item{x = "curv1Filter", data = "multipleFilterResult"}{ see above }

\item{x = "curv2Filter", data = "ANY"}{ We either need a
\code{\link[flowCore:filterResult-class]{filterResult}} or the raw data as a
\code{\link[flowCore:flowFrame-class]{flowFrame}} for
\code{\link[flowStats:curv2Filter-class]{curv2Filter}}.}

\item{x = "curv2Filter", data = "flowFrame"}{ see above }

\item{x = "curv2Filter", data = "multipleFilterResult"}{ see above }

\item{x = "kmeansFilter", data = "ANY"}{ We don't know how to plot regions
of a \code{\link[flowCore]{kmeansFilter}}, hence we warn. }

\item{x = "norm2Filter", data = "ANY"}{ We either need a
\code{\link[flowCore:filterResult-class]{filterResult}} or the raw data as a
\code{\link[flowCore:flowFrame-class]{flowFrame}} for
\code{\link[flowStats:norm2Filter-class]{norm2Filter}}.}

\item{x = "norm2Filter", data = "flowFrame"}{ see above }

\item{x = "norm2Filter", data = "logicalFilterResult"}{ see above }

\item{x = "polygonGate", data = "character"}{ We can plot a
\code{\link[flowCore]{polygonGate}} directly from the gate definition. }

\item{x = "polygonGate", data = "filterResult"}{ see above }

\item{x = "polygonGate", data = "flowFrame"}{ see above }

\item{x = "quadGate", data = "character"}{ We can plot a
\code{\link[flowCore]{quadGate}} directly from the gate definition. }

\item{x = "quadGate", data = "filterResult"}{ see above }

\item{x = "quadGate", data = "flowFrame"}{ see above }

\item{x = "rectangleGate", data = "character"}{ We can plot a
\code{\link[flowCore]{rectangleGate}} directly from the gate definition. }

\item{x = "rectangleGate", data = "filterResult"}{ see above }

\item{x = "rectangleGate", data = "flowFrame"}{ see above }

\item{x = "ellipsoidGate", data = "character"}{ We can plot a
\code{\link[flowCore]{ellipsoidGate}} directly from the gate definition. }

\item{x = "ellipsoidGate", data = "filterResult"}{ see above }

\item{x = "ellipsoidGate", data = "flowFrame"}{ see above }

}
}

\seealso{
\code{\link[flowCore:filter-class]{filter}},
\code{\link[flowCore:flowFrame-class]{flowFrame}}, \code{\link{glines}},
\code{\link{gpoints}}
}
\author{
F. Hahne
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/flowPlot.R
\docType{methods}
\name{flowPlot}
\alias{flowPlot}
\alias{flowPlot,flowFrame-method}
\title{Standard Plots for Flow Cytometry Data}
\usage{
\S4method{flowPlot}{flowFrame}(x, child, filter = NULL,
  plotParameters = c("FSC-H", "SSC-H"), logx = FALSE, logy = FALSE,
  parent, colParent = "Grey", colChild = "Blue", showFilter = TRUE,
  gate.fill = "transparent", gate.border = "black", xlab, ylab, xlim,
  ylim, ...)
}
\arguments{
\item{x}{An object of class \code{flowFrame} that contains the data to be
plotted.}

\item{child}{An optional argument of class \code{filterResult} that
specifies a subset of the data that are included in the \code{filterResult}}

\item{filter}{A \code{filter}, \code{filterResult} or
\code{filterResultList} object.}

\item{plotParameters}{A vector of charactors defining the x and y variables
in terms of columns in the data.}

\item{logx, logy}{Logical controlling wheterh the corresponding variables
will be log transfromed before passing to the panel function. Default to
\code{FALSE}.}

\item{parent}{An optional argument of class \code{filterResult} that
specifies a subset of the data that are inclueed in the \code{filterResult}.}

\item{colParent}{Specifying the color for \code{parent}. See \code{parent}
above.}

\item{colChild}{Specifies the color for \code{child}. See \code{chile}
above.}

\item{showFilter}{Logical, specifying whether to show the \code{filter}.}

\item{gate.fill}{Specifies the fill color of the gate. Default to
\code{transparent}.}

\item{gate.border}{Character or specifying the color of the gate border.
Default to \code{black}.}

\item{xlab, ylab}{Labels for data axes.}

\item{xlim, ylim}{Numeric vectors of length 2 specifying axis limits.}

\item{\dots}{More arguments, usually passed on to the underlying lattice
methods.}
}
\description{
A method that makes standard plots from a \code{flowFrame}. The user may
also provide various \code{filter} or \code{filterResult} arguments to
customize the plot.
}
\details{
The plot that is most commonly used in flow cytometry data analysis is
usuall called a "dot plot". In common statistical language, we would call
this a scatter plot. The basic idea is a 2-dimensional plot that shows the
location of every cell in regard to the measurements made on it, for
example, forward scatter vs side scatter. Most applications will, in
addition to the data, want to show information about one or more filters
(gates). Since there can be a very large number of cells in a sample, it is
common to show a smoothed version of the data that doesn't involve
registering every point on the graph.
}
\examples{

library(flowCore)
data(GvHD)
flowPlot(GvHD[["s5a01"]])
flowPlot(transform("SSC-H"=asinh,"FSC-H"=asinh) \%on\% GvHD[["s5a01"]])


}
\seealso{
\code{\link[flowCore:flowCore-package]{flowCore}}
}
\author{
P. Haaland
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/densityplot.R, R/histogram.R
\docType{methods}
\name{densityplot}
\alias{densityplot}
\alias{densityplot,formula,flowSet-method}
\alias{prepanel.densityplot.flowset.stack}
\alias{panel.densityplot.flowset.stack}
\alias{densityplot,formula,flowFrame-method}
\alias{densityplot,formula,view-method}
\alias{densityplot,formula,ncdfFlowSet-method}
\alias{densityplot,formula,ncdfFlowList-method}
\alias{histogram,formula,flowSet-method}
\alias{histogram,formula,flowFrame-method}
\alias{histogram,formula,ncdfFlowSet-method}
\alias{histogram,formula,ncdfFlowList-method}
\title{One-dimensional density/histogram plots for flow data}
\usage{
\S4method{densityplot}{formula,flowSet}(x, data, ...)

prepanel.densityplot.flowset.stack(x, y, frames, overlap = 0.3,
  subscripts, ..., which.channel)

panel.densityplot.flowset.stack(x, y, darg = list(n = 50, na.rm = TRUE),
  frames, channel, overlap = 0.3, channel.name, filter = NULL,
  fill = superpose.polygon$col, lty = superpose.polygon$lty,
  lwd = superpose.polygon$lwd, alpha = superpose.polygon$alpha,
  col = superpose.polygon$border, groups = NULL, refline = NULL,
  margin = 0.005, stats = FALSE, pos = 0.5, digits = 2,
  abs = FALSE, fitGate = TRUE, checkName = TRUE,
  plotType = "densityplot", hist.type = "density",
  breaks = "Sturges", gp, ...)

\S4method{densityplot}{formula,flowFrame}(x, data, overlay = NULL, ...)

\S4method{densityplot}{formula,view}(x, data, ...)

\S4method{densityplot}{formula,ncdfFlowSet}(x, data, ...)

\S4method{densityplot}{formula,ncdfFlowList}(x, data, ...)

\S4method{histogram}{formula,flowSet}(x, data, plotType, ...)

\S4method{histogram}{formula,flowFrame}(x, data, ...)

\S4method{histogram}{formula,ncdfFlowSet}(x, data, ...)

\S4method{histogram}{formula,ncdfFlowList}(x, data, ...)
}
\arguments{
\item{x}{A formula describing the structure of the plot and the variables to
be used in the display. The structure of the formula is \code{factor ~
parameter}, where \code{factor} can be any of the phenotypic factors in the
\code{phenoData} slot or an appropriate factor object and \code{parameter}
is a flow parameter. Panels for multiple parameters are drawn if the formula
structure is similar to \code{factor ~ parameter1 + parameter2}, and
\code{factor} can be missing, in which case the sample names are used as
y-variable. To facilitate programatic access, the formula can be of special
structure \code{factor ~ .}, in which case the optional \code{channel}
argument is considered for parameter selection. For the workflow methods,
\code{x} can also be one of the several workflow objects.}

\item{data}{A flow data object that serves as a source of data, either a
\code{\link[flowCore:flowFrame-class]{flowFrame}} or
\code{\link[flowCore:flowSet-class]{flowSet}}}

\item{\dots}{More arguments, usually passed on to the underlying lattice
methods.  
\itemize{

 \item channels A character vector of parameters that are supposed to be
                 plotted when the formula in \code{x} is of structure \code{factor ~ .}.

 \item xlab: Label for data x axis, with suitable defaults taken from the
 formula

 \item prepanel: The prepanel function.  See \code{\link[lattice]{xyplot}}

 \item panel: the panel function.  See \code{\link[lattice]{xyplot}}

 \item axis: axis function passed to lattice, default is \code{axis.grid}

 \item ... : other arguments passed to panel.densityplot.flowset.stack or
             panel.histogram.flowframe

}}

\item{frames}{An environment containing frame-specific data.}

\item{overlap}{The amount of overlap between stacked density plots. This
argument is ignored for the \code{flowFrame} method.}

\item{subscripts, which.channel, channel.name, y}{Internal indices necessary to
map panels to parameters.}

\item{darg}{These arguments are passed unchanged to the corresponding
methods in lattice, and are listed here only because they provide different
defaults.  See documentation for the original methods for details.
\code{darg} gets passed on to \code{\link[stats]{density}}.}

\item{channel}{The name of the currently plotted flow parameter.}

\item{filter}{A \code{\link[flowCore:filter-class]{filter}},
\code{\link[flowCore:filterResult-class]{filterResult}} or
\code{\link[flowCore:filterResult-class]{filterResultList}} object or a list
of such objects of the same length as the \code{flowSet}. If applicable, the
gate region will be superiposed on the density curves using color shading.
The software will figure out whether the \code{filter} needs to be evaluated
in order to be plotted (in which case providing a \code{filterResult} can
speed things up considerably).}

\item{col, fill, lty, lwd, alpha}{Graphical parameters. These mostly exist for
conveniance and much more control is available throught the
\code{lattice}-like \code{par.setting} and \code{flowViz.par.set}
customization. The relevant parameter category for density plots is
\code{gate.density} with available parameters \code{col}, \code{fill},
\code{lwd}, \code{alpha} and \code{lty}. See
\code{\link[flowViz:flowViz.par.get]{flowViz.par.set}} for details.}

\item{groups}{Use identical colors for grouping. The value of the argument
is expected to be a phenotypic variable in the \code{flowSet}, or a factor.}

\item{refline}{Logical. Add one ore more vertical reference lines to the
plot.  This argument is directly passed to
\code{\link[lattice:panel.functions]{panel.abline}}.}

\item{margin}{Either Logical value 'FALSE' or Numeric valuein \code{[0,1]}.
When 'FALSE', it doesn't do anything to the margin events.  When Numeric
value, it indicates margin events by horizontal bars. The value of
\code{margin} is interpreted as the proportion of events on the margin over
which the bars are added. E.g., a value of \code{0,5} means to indicate
margin events if there are more than \code{0.5} times the total number of
events. \code{1} means to ignore margin events completetly. For \code{0}
bars are added even if there is only a single margin event.}

\item{stats, pos, digits, abs}{Arguments to control statistics that is
associated with \code{\link[flowCore:filter-class]{filter}} to be plotted.
see \link[flowViz]{xyplot} for details.}

\item{fitGate}{A \code{logical} scalar indicating whether to display the
gate as fitted 1d density gate region or simply display the gate boundaries
using vertical lines. The latter would be helpful to display the gate when
the gated density region is too small to see.}

\item{checkName}{A \code{logical} scalar indicating whether to validity
check the channel name. Default is TRUE, which consider '(' as invalid
character in channel names}

\item{plotType}{either 'densityplot' or 'histogram'}

\item{hist.type}{see 'type' argument in 'help(panel.histogram)'}

\item{breaks}{see 'help(hist)'}

\item{gp}{A list of graphical parameters that are passed down to the low
level panel functions. This is for internal use only. The public user
interface to set graphical parameters is either \code{par.settings} for
customization of a single call or \code{flowViz.par.set} for customization
of session-wide defaults.}

\item{overlay}{see help(xyplot).}
}
\description{
For \code{\link[flowCore:flowSet-class]{flowSets}} the idea is to
horizontally stack plots of density estimates for all frames in the
\code{flowSet} for one or several flow parameters. In the latter case, each
parameter will be plotted in a separate panel, i.e., we implicitly condition
on parameters.
}
\details{
Not all standard lattice arguments will have the intended effect, but many
should.  For a fuller description of possible arguments and their effects,
consult documentation on lattice (Trellis docs would also work for the
fundamentals).
}
\examples{

library(flowCore)
library(flowStats)
data(GvHD)
GvHD <- GvHD[pData(GvHD)$Patient \%in\% 6:7]

densityplot(~ `FSC-H`, GvHD)

densityplot(~ `FSC-H` + `SSC-H`, GvHD)

densityplot(~ ., GvHD[1:3])

## include a filter
densityplot(~ `FSC-H`, GvHD, filter=curv1Filter("FSC-H"))

#display the gate by its boundaries with statistics 
densityplot(~ `FSC-H`, GvHD[1:2], filter=curv1Filter("FSC-H"),fitGate=FALSE,stats=TRUE)

## plot a single flowFrame
densityplot(~ `SSC-H`, GvHD[[1]], margin=FALSE)

## plot histogram
histogram(~ `SSC-H`, GvHD[[1]]) #default type is 'density'
#change the type to 'count' and adjust breaks
histogram(~ `SSC-H`, GvHD[[1]], margin=FALSE, type = "count", breaks = 50)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/contour.R
\docType{methods}
\name{contour-methods}
\alias{contour-methods}
\alias{contour}
\alias{contour,ANY-method}
\alias{contour,flowFrame-method}
\alias{contour,flowSet-method}
\title{Contour plots for flow data}
\usage{
\S4method{contour}{flowFrame}(x, y = 1:2, nlevels = 10, bw,
  grid.size = c(65, 65), add = FALSE, xlab, ylab, xlim, ylim,
  lwd = 1, lty = 1, col = par("fg"), fill = "transparent", ...)
}
\arguments{
\item{x}{An object of class
\code{\link[flowCore:flowFrame-class]{flowFrame}} or
\code{\link[flowCore:flowFrame-class]{flowSet}}.}

\item{y}{Numeric or character vector of length 2 indicating the channels to
plot.}

\item{nlevels}{The approximate number of contour line levels, see
\code{\link[graphics]{contour}} for details.}

\item{bw}{The bandwidth factor used for the kernel density estimation, see
\code{\link[KernSmooth]{bkde2D}} for details.}

\item{grid.size}{The grid size used for the kernel density estimation, see
\code{\link[KernSmooth]{bkde2D}} for details.}

\item{add}{Logical, indicating whether contour lines should be superimposed
on an existing plot.}

\item{xlab, ylab}{The axis annotation.}

\item{xlim, ylim}{The plotting ranges.}

\item{lwd, lty, col, fill}{The usual plotting parameters, i.e. the line width,
line type, line color and fill color. When using a fill color you should
consider alpha blending to improve the results.}

\item{\dots}{Parameters that are passed on to the plotting functions.}
}
\description{
Basic contour plots for both
\code{\link[flowCore:flowFrame-class]{flowFrame}}s and
\code{\link[flowCore:flowFrame-class]{flowSet}}s. The densities for the
contours are estimated using the fast kernel density estimation algorithm
\code{\link[KernSmooth]{bkde2D}}.
}
\section{Methods}{
 \describe{

\item{x = "flowFrame"}{ A regular contour plot of the flow data in the
frame. It can be added on top of an existing plot using the \code{add}
argument.}

\item{x = "flowSet"}{ Overlay of contours of densities for each individual
frame in the set. You should consider using differnt colors and alpha
blending to improve the result. This is only useful for a very limited
number of frames in a set (~5), for larger sets you should consider a
panelled lattice-type plot. Not that \code{bw}, \code{gridSize} and
\code{nlevels} are passed on via the \dots{} argument.}

}
}

\examples{

library(flowCore)
data(GvHD)

## simple contour plot
contour(GvHD[[1]])

## overlay with existing plot
plot(GvHD[[1]], c("FSC-H", "SSC-H"))
contour(GvHD[[1]], add=TRUE, col="lightgray", lty=3)

## colored contours
contour(GvHD[[1]], fill="red")
cols <- rainbow(3, alpha=0.1)
contour(GvHD[[1]], fill=cols, col=cols)

## overlay of multiple flowFrames in a flowSet
contour(GvHD[1:3], col=cols, fill=cols)

}
\seealso{
\code{\link[KernSmooth]{bkde2D}}, \code{\link[graphics]{contour}},
\code{\link[flowCore:flowFrame-class]{flowFrame}},
\code{\link[flowCore:flowFrame-class]{flowSet}}
}
\author{
F. Hahne
}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ecdfplot.R
\docType{methods}
\name{prepanel.ecdfplot.flowset}
\alias{prepanel.ecdfplot.flowset}
\alias{panel.ecdfplot.flowset}
\alias{ecdfplot}
\alias{ecdfplot,formula,flowSet-method}
\title{Method implementing Lattice ECDF plots for flow data}
\usage{
prepanel.ecdfplot.flowset(x, frames, channel, f.value, ...)

panel.ecdfplot.flowset(x, frames, channel, f.value, ref = TRUE,
  groups = NULL, subscripts, col = superpose.symbol$col,
  col.points = col, pch = superpose.symbol$pch,
  cex = superpose.symbol$cex, alpha = superpose.symbol$alpha,
  col.line = col, lty = superpose.line$lty, lwd = superpose.line$lwd,
  ...)

\S4method{ecdfplot}{formula,flowSet}(x, data, xlab, f.value = function(n)
  ppoints(ceiling(sqrt(n))), prepanel = prepanel.ecdfplot.flowset,
  panel = panel.ecdfplot.flowset, type = "l", as.table = TRUE, ...)
}
\arguments{
\item{x}{a formula describing the structure of the plot and the variables to
be used in the display.  For the prepanel and panel functions, a vector of
names for the flow frames to be used in the panel.}

\item{frames}{environment containing frame-specific data}

\item{channel}{expression involving names of columns in the data}

\item{f.value}{determines the number of points used in the plot
\code{\link[latticeExtra:ecdfplot]{ecdfplot}} for details.}

\item{\dots}{more arguments, usually passed on to the underlying lattice
methods and the panel function.}

\item{ref}{logical; whether to add reference lines at 0 and 1}

\item{groups, subscripts}{grouping variable, if specified, and subscripts
indexing which frames are being used in the panel.  See
\code{\link[lattice:xyplot]{xyplot}} for details.}

\item{col, col.points, pch, cex, alpha, col.line, lty, lwd}{vector of graphical
parameters that are replicated for each group}

\item{data}{a \code{flowSet} object that serves as a source of data}

\item{xlab}{Labels for data axes, with suitable defaults taken from the
formula}

\item{panel, prepanel}{the panel and prepanel functions.}

\item{type}{type of rendering; by default lines are drawn}

\item{as.table}{logical; whether to draw panels from top left}
}
\description{
This function creates Trellis displays of Empirical Cumulative Distribution
Functions from flow cytometry data using a formula interface.
}
\section{Methods}{
 \describe{

\item{ecdfplot}{\code{signature(x = "formula", data = "flowSet")}: plote
empirical CDF for a given channel, with one or more samples per panel } }
}

\examples{

library(flowCore)
data(GvHD)

ecdfplot(~ `FSC-H` | Patient, GvHD, f.value = ppoints(100))

ecdfplot(~ asinh(`FSC-H`) | Patient, GvHD,
         strip = strip.custom(strip.names = TRUE),
         ref = FALSE)

ecdfplot(~ asinh(`FSC-H`) | Patient, GvHD, groups = Visit,
         strip = strip.custom(strip.names = TRUE),
         ref = FALSE, auto.key = list(columns = 4))


}
\seealso{
Not all standard lattice arguments will have the intended effect,
but many should.  For a fuller description of possible arguments and their
effects, consult documentation on lattice.
}
\keyword{dplot}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/xyplot.R
\name{.process_overlay_flowSet}
\alias{.process_overlay_flowSet}
\title{extract the respective flowFrame from each flowSet based on the given sampleName}
\usage{
.process_overlay_flowSet(overlay, nm)
}
\arguments{
\item{overlay}{a list of flowSet}

\item{nm}{sample name}
}
\description{
extract the respective flowFrame from each flowSet based on the given sampleName
}
